////////////////////////////////////////////////////////////////////////////////
// Enemies.h
// Contains general enemy subroutines that are independent of the enemy subtype
// See Enemy_Structures.h for the enemy substructures

void Update_Enemies() //Loop through the enemies and update the active ones
{
    Update_Enemy_Spawners();
    for(int i = 0; i < total_enemies; i ++)
    {
        if(Enemies[i]->active)
        {
            if(Enemies[i]->type_flag == METROID)
            {
                if(rect_clip(Enemies[i]->bound, camera.lft, camera.top, camera.rgt, camera.bot))
                {
                    Enemies[i]->funcptr(i);
                    if(Enemies[i]->refreeze_timer > 0) Enemies[i]->refreeze_timer --;
                }
            }
            else
            {
                if(rect_clip(Enemies[i]->bound, camera.lft-256, camera.top-256, camera.rgt+256, camera.bot+256))
                {
                    Enemies[i]->funcptr(i);
                    if(Enemies[i]->refreeze_timer > 0) Enemies[i]->refreeze_timer --;
                }
            }
        }
    }
    for(int i = 0; i < total_rinkas; i ++)
    {
        Update_Rinka(i);
    }
    for(int i = 0; i < total_zebetites; i ++)
    {
        Update_Zebetite(i);
    }
}

void Immunize_From_Beam(int i, int beamcode)
{
    for(int e = 0; e < Enemies[i]->immune.total_codes; e ++)
    {
        if(Enemies[i]->immune.codes[e] == beamcode) //Already immune to this one
        {
            return;
        }
    }
    //If the beam isn't already in the array, add it
    Enemies[i]->immune.codes = (int *)realloc(Enemies[i]->immune.codes, sizeof(int) * (Enemies[i]->immune.total_codes+1));
    Enemies[i]->immune.codes[Enemies[i]->immune.total_codes] = beamcode;
    Enemies[i]->immune.total_codes ++;
}
