int Create_Breakable(int x, int y, int respawn_timer, int flags, bool killflag, int tile_show)
{
    for(int i = 0; i < total_breakables; i ++)
    {
        if(!Breakables[i].active)
        {
            Place_Breakable_In_Slot(i, x, y, respawn_timer, flags, killflag, tile_show);
            return i;
        }
    }
    Breakables = (BREAKABLE *)realloc(Breakables, sizeof(BREAKABLE) * (total_breakables + 1));
    Place_Breakable_In_Slot(total_breakables, x, y, respawn_timer, flags, killflag, tile_show);
    total_breakables ++;
    return total_breakables - 1;
}

void Place_Breakable_In_Slot(int i, int x, int y, int respawn_timer, int flags, bool killflag, int tile_show)
{
    Breakables[i].active = true;
    Breakables[i].x = x;
    Breakables[i].y = y;
    Breakables[i].dim.lft = x * 16;
    Breakables[i].dim.rgt = x * 16 + 16;
    Breakables[i].dim.top = y * 16;
    Breakables[i].dim.bot = y * 16 + 16;
    Breakables[i].respawn_timer = -1;
    Breakables[i].respawn_max = respawn_timer;
    Breakables[i].flags = flags;
    Breakables[i].killflag = killflag;
    Breakables[i].fadeout_timer = 0;
    Breakables[i].tile_show = tile_show;
    Breakables[i].fadein_timer = 0;
    Breakables[i].show_item = false;
    Clip_Area(Breakables[i].dim, STOP_ALL);
}

void Update_Breakables()
{
    for(int i = 0; i < total_breakables; i ++)
    {
        if(Breakables[i].active)
        {
            if(Breakables[i].respawn_timer == -1) //Block is active
            {
                if(Breakables[i].fadein_timer > 0) //Block is respawning
                {
                    Breakables[i].fadein_timer ++;
                    if(Breakables[i].fadein_timer >= 6)
                    {
                        Breakables[i].fadein_timer = 0;
                        Clip_Area(Breakables[i].dim, STOP_ALL);
                        Breakables[i].show_item = false;
                    }
                }
                else if(Breakables[i].fadeout_timer > 0) //Block is despawning
                {
                    Breakables[i].fadeout_timer ++;
                    if(Breakables[i].fadeout_timer >= 6)
                    {
                        Breakables[i].fadeout_timer = 0;
                        Breakables[i].respawn_timer = Breakables[i].respawn_max;
                        Clip_Area(Breakables[i].dim, STOP_NONE);
                        Breakables[i].show_item = true;
                    }
                }
                else //Hit detection code
                {
                    for(int p = 0; p < total_projectiles; p ++)
                    {
                        if(Projectiles[p]->owner_flag != -1 AND !Projectiles[p]->bomb)
                        {
                            if(rect_clip(Breakables[i].dim, Projectiles[p]->dim))
                            {
                                Breakables[i].fadeout_timer = 1;
                            }
                        }
                    }
                }
            }
            else if(Breakables[i].respawn_timer > 0 AND Breakables[i].respawn_max != -154) //Block is ticking to respawn
            {
                Breakables[i].respawn_timer --;
                if(Breakables[i].respawn_timer == 0)
                {
                    Breakables[i].respawn_timer = -1;
                    Breakables[i].fadein_timer = 1;
                }
            }
        }
    }
}

void Compare_Breakables_To_Bombs(int p)
{
    for(int b = 0; b < total_breakables; b ++)
    {
        if(Breakables[b].active AND Breakables[b].respawn_timer == -1 AND Breakables[b].fadeout_timer == 0 AND Breakables[b].fadein_timer == 0)
        {
            if(rect_clip(Breakables[b].dim, Projectiles[p]->dim.lft-8, Projectiles[p]->dim.top-9, Projectiles[p]->dim.rgt+8, Projectiles[p]->dim.bot+4))
            {
                Breakables[b].fadeout_timer = 1;
            }
        }
    }
}
