void Create_Cambound(int lft, int top, int rgt, int bot, int flags)
{
    bool failflag = false;
    for(int i = 0; i < total_cambounds; i ++)
    {
        if(!Cambounds[i].active)
        {
            Cambounds[i].active = true;
            Cambounds[i].dim.lft = lft;
            Cambounds[i].dim.top = top;
            Cambounds[i].dim.rgt = rgt;
            Cambounds[i].dim.bot = bot;
            Cambounds[i].flags = flags;
            return;
        }
    }
    Cambounds = (CAMBOUND *)realloc(Cambounds, sizeof(CAMBOUND) * (total_cambounds + 1));
    Cambounds[total_cambounds].active = true;
    Cambounds[total_cambounds].dim.lft = lft;
    Cambounds[total_cambounds].dim.top = top;
    Cambounds[total_cambounds].dim.rgt = rgt;
    Cambounds[total_cambounds].dim.bot = bot;
    Cambounds[total_cambounds].flags = flags;
    total_cambounds ++;
}

void Update_Cambounds()
{
    for(int i = 0; i < total_cambounds; i ++)
    {
        if(Cambounds[i].active)
        {
            if(Cambounds[i].flags & BOUND_LFT AND rect_clip(samvar.dim, 0, Cambounds[i].dim.top, Cambounds[i].dim.lft+1, Cambounds[i].dim.bot))
            {
                if(camera.rgt > Cambounds[i].dim.lft)
                {
                    camera_scroll.lft = camera.rgt - Cambounds[i].dim.lft;
                    camera_scroll.rgt = 0;
                    camera_save.lft = 1;
                }
            }
            if(Cambounds[i].flags & BOUND_TOP AND rect_clip(samvar.dim, Cambounds[i].dim.lft, 0, Cambounds[i].dim.rgt, Cambounds[i].dim.top+1))
            {
                if(camera.bot > Cambounds[i].dim.top)
                {
                    camera_scroll.top = camera.bot - Cambounds[i].dim.top;
                    camera_scroll.bot = 0;
                    camera_save.top = 1;
                }
            }
            if(Cambounds[i].flags & BOUND_RGT AND rect_clip(samvar.dim, Cambounds[i].dim.rgt-1, Cambounds[i].dim.top, Room->xsize*16, Cambounds[i].dim.bot))
            {
                if(camera.lft < Cambounds[i].dim.rgt)
                {
                    camera_scroll.rgt = Cambounds[i].dim.rgt - camera.lft;
                    camera_scroll.lft = 0;
                    camera_save.rgt = 1;
                }
            }
            if(Cambounds[i].flags & BOUND_BOT AND rect_clip(samvar.dim, Cambounds[i].dim.lft, Cambounds[i].dim.bot-1, Cambounds[i].dim.rgt, Room->ysize*16))
            {
                if(camera.top < Cambounds[i].dim.bot)
                {
                    camera_scroll.bot = Cambounds[i].dim.bot - camera.top;
                    camera_scroll.top = 0;
                    camera_save.bot = 1;
                }
            }
        }
    }
}

void Update_Hardened_Cambounds() //If the camera scrolled into the cambound during natural scrolling
{
    for(int i = 0; i < total_cambounds; i ++)
    {
        if(Cambounds[i].active)
        {
            if(Cambounds[i].flags & BOUND_LFT AND rect_clip(samvar.dim, 0, Cambounds[i].dim.top, Cambounds[i].dim.lft, Cambounds[i].dim.bot))
            {
                if(camera.rgt > Cambounds[i].dim.lft AND camera_save.lft == 0)
                {
                    camera.rgt = Cambounds[i].dim.lft;
                    camera.lft = camera.rgt - 256;
                    bg_start_x = bg_start_save_x;
                    bg_scroll_pos_x = bg_pos_save_x;
                }
            }
            if(Cambounds[i].flags & BOUND_TOP AND rect_clip(samvar.dim, Cambounds[i].dim.lft, 0, Cambounds[i].dim.rgt, Cambounds[i].dim.top))
            {
                if(camera.bot > Cambounds[i].dim.top AND camera_save.top == 0)
                {
                    camera.bot = Cambounds[i].dim.top;
                    camera.top = camera.bot - 256;
                    bg_start_y = bg_start_save_y;
                    bg_scroll_pos_y = bg_pos_save_y;
                }
            }
            if(Cambounds[i].flags & BOUND_RGT AND rect_clip(samvar.dim, Cambounds[i].dim.rgt-1, Cambounds[i].dim.top, Room->xsize*16, Cambounds[i].dim.bot))
            {
                if(camera.lft < Cambounds[i].dim.rgt AND camera_save.rgt == 0)
                {
                    camera.lft = Cambounds[i].dim.rgt;
                    camera.rgt = camera.lft + 256;
                    bg_start_x = bg_start_save_x;
                    bg_scroll_pos_x = bg_pos_save_x;
                }
            }
            if(Cambounds[i].flags & BOUND_BOT AND rect_clip(samvar.dim, Cambounds[i].dim.lft, Cambounds[i].dim.bot-1, Cambounds[i].dim.rgt, Room->ysize*16))
            {
                if(camera.top < Cambounds[i].dim.bot AND camera_save.bot == 0)
                {
                    camera.top = Cambounds[i].dim.bot;
                    camera.bot = camera.top + 256;
                    bg_start_y = bg_start_save_y;
                    bg_scroll_pos_y = bg_pos_save_y;
                }
            }
        }
    }
}
