void Detect_Samus_Collision()
{
    Update_Samus_Clips();
    //Check Left bound
    samvar.touch_lft = false;
    if(samvar.falling_lockout > 0 AND !samvar.ball_mode) samvar.dim.bot += 10;
    for(int y = samvar.dim.top; y < samvar.dim.bot; y ++)
    {
        if(cliparray[samvar.dim.lft-1][y] & samvar.cur_clip_detect)
        {
            samvar.touch_lft = true;
            y = samvar.dim.bot;
        }
    }
    if(samvar.falling_lockout > 0 AND !samvar.ball_mode) samvar.dim.bot -= 10;
    //Check Top bound
    samvar.touch_top = false;
    if(Scan_Clips_X(samvar.dim.lft, samvar.dim.rgt, samvar.dim.top-1, samvar.cur_clip_detect))
    {
        samvar.touch_top = true;
    }
    //Check Right bound
    samvar.touch_rgt = false;;
    if(samvar.falling_lockout > 0 AND !samvar.ball_mode) samvar.dim.bot += 10;
    for(int y = samvar.dim.top; y < samvar.dim.bot; y ++)
    {
        if(cliparray[samvar.dim.rgt+1][y] & samvar.cur_clip_detect)
        {
            samvar.touch_rgt = true;
            y = samvar.dim.bot;
        }
    }
    if(samvar.falling_lockout > 0 AND !samvar.ball_mode) samvar.dim.bot -= 10;
    //Check Bottom bound
    samvar.touch_bot = false;
    if(samvar.yspeed >= 0)
    {
        if(Scan_Clips_X(samvar.dim.lft, samvar.dim.rgt, samvar.dim.bot+1, samvar.cur_clip_detect))
        {
            samvar.touch_bot = true;
        }
    }
}

void Update_Samus_Clips()
{
    if(game_version == 2)
    {
        Update_Samus_Clips_Return();
        return;
    }
    if(samvar.ball_mode)
    {
        samvar.dim.lft = samvar.x;
        samvar.dim.rgt = samvar.x + 7;
        samvar.dim.top = samvar.y + 17;
        samvar.dim.bot = samvar.y + 30;
    }
    else
    {
        samvar.dim.lft = samvar.x;
        samvar.dim.rgt = samvar.x + 7;
        samvar.dim.top = samvar.y;
        if(!samvar.touch_bot) samvar.dim.bot = samvar.y + 23;
        else samvar.dim.bot = samvar.y + 30;
    }
}

void Update_Samus_Clips_Return() //Metroid 2:  Return of Samus
{
    if(samvar.ball_mode)
    {
        samvar.dim.lft = samvar.x;
        samvar.dim.rgt = samvar.x + 10;
        samvar.dim.top = samvar.y + 16;
        samvar.dim.bot = samvar.y + 32;
    }
    else
    {
        samvar.dim.lft = samvar.x;
        samvar.dim.rgt = samvar.x + 10;
        samvar.dim.top = samvar.y;
        if(!samvar.touch_bot) samvar.dim.bot = samvar.y + 24;
        else samvar.dim.bot = samvar.y + 32;
    }
}

void Lock_Samus_Speed(float xspeed, float yspeed)
{
    if(xspeed != -100)
    {
        samvar.xspeed = xspeed;
        samvar.xaccel = 0;
    }
    if(yspeed != -100)
    {
        samvar.yspeed = yspeed;
        samvar.yaccel = 0;
    }
}

void Move_Samus()
{
    int xmoved=0, ymoved=0;
    int emergency_counter = 100; //Prevent a crash from a bug
    int xremain = (int)samvar.xspeed;
    int yremain = (int)samvar.yspeed;
    samvar.xremainder += samvar.xspeed - xremain;
    samvar.yremainder += samvar.yspeed - yremain;

    if(samvar.xremainder > 1)
    {
        samvar.xremainder -= 1;
        xremain += 1;
    }
    else if(samvar.xremainder < -1)
    {
        samvar.xremainder += 1;
        xremain -= 1;
    }
    if(samvar.yremainder > 1)
    {
        samvar.yremainder -= 1;
        yremain += 1;
    }
    else if(samvar.yremainder < -1)
    {
        samvar.yremainder += 1;
        yremain -= 1;
    }
    if(samvar.hamper_movement)
    {
        if(xremain < -1) xremain = -1;
        if(xremain >  1) xremain = 1;
    }

    while(emergency_counter AND (xremain OR yremain))
    {
        emergency_counter --;
        Detect_Samus_Collision();
        if(xremain > 0)
        {
            if(!samvar.touch_rgt)
            {
                samvar.x ++;
                xmoved ++;
                xremain --;
            }
            else xremain = 0;
        }
        else if(xremain < 0)
        {
            if(!samvar.touch_lft)
            {
                samvar.x --;
                xmoved ++;
                xremain ++;
            }
            else xremain = 0;
        }
        Detect_Samus_Collision();
        if(yremain > 0)
        {
            if(!samvar.touch_bot)
            {
                samvar.y ++;
                ymoved ++;
                yremain --;
            }
            else yremain = 0;
        }
        else if(yremain < 0)
        {
            if(!samvar.touch_top)
            {
                samvar.y --;
                ymoved ++;
                yremain ++;
            }
            else yremain = 0;
        }
    }
    Update_Samus_Clips();
}
