void Init_Script_Engine(char path[])
{
    printf("[-]    Beginning Script Data dump    [-] \n");
    FILE *infile = fopen(path, "rb");
    char instr[256];
    int size = -1;
    int pos = 0;
    int cnt = 0;
    int i = 0;
    if(infile)
    {
        fseek(infile, 0, SEEK_END);
        size = ftell(infile);
        printf("Size of %s: %ld bytes.\n", path, size);
        if(size == -1)
        {
            printf("Critical error reading file size.  Aborting script execution.\n");
            return;
        }
        SCRIPT *Scp = Init_Script("Global Variables");
        fseek(infile, 0, SEEK_SET);
        while(cnt < size+1)
        {
            instr[i] = fgetc(infile);
            if(instr[i] == 13 OR cnt == size)
            {
                instr[i] = 0;
                Add_New_Line_To_Script(Scp, instr, i);
                pos ++;
                i = -1;
            }
            if(instr[i] == 10)
            {
                i--;
            }
            i ++; if (i>255) printf("*Alert*, Script_Engine overflow(%i>255)\n", i);
            cnt ++;
        }

        script_mode = true;
        Dump_Script_To_Console(Scp);
        Parse_Script_For_Variables(Scp);
        Destroy_Script(Scp);
        printf("Script mode engaged.\n");
        fclose(infile);
        infile = NULL;
    }
    else
    {
        printf("Error opening %s, script mode aborted for execution.\n", path);
    }
    printf("[-]        End of Script data        [-] \n");
    return;
}

SCRIPT *Init_Script(char name[])
{
    SCRIPT *Newscp = (SCRIPT *)malloc(sizeof(SCRIPT));
    Newscp->line = NULL;
    Newscp->total_lines = 0;
    Init_String(Newscp->internal_name, name, 80);
    return Newscp;
}

void Destroy_Script(SCRIPT *Script)
{
    for(int i = 0; i < Script->total_lines; i ++)
    {
        if(Script->line[i].str) free(Script->line[i].str);
        Script->line[i].str = NULL;
    }
    if(Script->line) free(Script->line);
    Script->line = NULL;
}

void Add_New_Line_To_Script(SCRIPT *Script, char string[], int len)
{
    if(!Script)
    {
        printf("Script doesn't exist, stupid!\n");
        return;
    }
    int i = Script->total_lines;
	if (Script->line)
		Script->line = (LINE *)realloc(Script->line, sizeof(LINE) * (i+1));
	else
		Script->line = (LINE *)malloc(sizeof(LINE) * (i+1));
    Script->line[i].str = (char *)malloc(sizeof(char) * (len+1));
    Script->line[i].len = len;
    Init_String(Script->line[i].str, string, len);
    Script->total_lines ++;
}

void Dump_Script_To_Console(SCRIPT *Script)
{
    printf("Dump of Script %s to console:\n", Script->internal_name);
    for(int i = 0; i < Script->total_lines; i ++)
    {
        printf("%i: %s: %i\n", i, Script->line[i].str, Script->line[i].len);
    }
    printf("Script dump complete\n");
}
