void Create_Key(char name[], char *key, char askey, char shkey, int *c, int *v)
{
    Init_String(Keylist[*v].name, name, 8);
    Keylist[*v].key = (char *)key;
    Keylist[*v].askey = askey;
    Keylist[*v].shkey = shkey;
    *c = *c + 1;
    *v = *v + 1;
}
void Create_Key(char name[], int *key, int *v)
{
    Init_String(Keylist[*v].name, name, 8);
    Keylist[*v].key = (char *)key;
    Keylist[*v].askey = 0;
    Keylist[*v].shkey = 0;
    *v = *v + 1;
}

void Create_Control(char name[], char keyname[], int *index)
{
    Controls = (CONTROLLIST *)realloc(Controls, sizeof(CONTROLLIST) * (total_controls + 1));
    Init_String(Controls[total_controls].name, name, 10);
    Controls[total_controls].key = NULL;
    for(int i = 0; i < total_keys; i ++)
    {
        if(!strcasecmp(keyname, Keylist[i].name))
        {
            Controls[total_controls].key = &Keylist[i];
            i = total_keys;
        }
    }
    *index = total_controls;
    total_controls ++;
}

void Assign_Control(char name[], char keyname[])
{
    int contnum = -1;
    for(int i = 0; i < total_controls; i ++) //Parse the controls list
    {
        if(!strcasecmp(name, Controls[i].name)) //If the control is found, assign the key to it
        {
            contnum = i;
            i = total_controls;
        }
    }
    if(contnum != -1)
    {
        for(int i = 0; i < total_keys; i ++)
        {
            if(!strcasecmp(keyname, Keylist[i].name))
            {
                Controls[contnum].key = &Keylist[i];
                i = total_keys;
            }
        }
    }
}

void Create_CVar_I(char name[], int value)
{
	if ((total_cvars + 1)%64==0)
		CVars = (CVAR *)realloc(CVars, sizeof(CVAR) * 64*((total_cvars + 1)/64+1));

    CVars[total_cvars].name = (char *)malloc(sizeof(char) * (strlen(name)+1));
    Init_String(CVars[total_cvars].name, name, strlen(name));

    CVars[total_cvars].is_int_type = true;
    CVars[total_cvars].valuei = value;

    total_cvars ++;
}

void Create_CVar_C(char name[], char value[])
{
	if ((total_cvars + 1)%64==0)
		CVars = (CVAR *)realloc(CVars, sizeof(CVAR) * 64*((total_cvars + 1)/64+1));

    CVars[total_cvars].name = (char *)malloc(sizeof(char) * (strlen(name)+1));
    Init_String(CVars[total_cvars].name, name, strlen(name));

    CVars[total_cvars].is_int_type = false;

    if(!strcmp(value, "NULL")) //String is meant to be initted to NULL
    {
        CVars[total_cvars].valuec = NULL;
    }
    else
    {
        CVars[total_cvars].valuec = (char *)malloc(sizeof(char) * (strlen(value)+1));
        Init_String(CVars[total_cvars].valuec, value, strlen(value));
    }

    total_cvars ++;
}

BITMAP * Create_Mask(BITMAP *source)
{
    BITMAP *mask = create_bitmap(source->w, source->h);
    clear_to_color(mask, transparent);
    for(int x = 0; x < source->w; x ++)
    {
        for(int y = 0; y < source->h; y ++)
        {
            if(getpixel(source, x, y) != transparent)
            {
                putpixel(mask, x, y, 0);
            }
        }
    }
    return mask;
}

CUSTOM_IMAGE * Create_Copy_Of_Custom_Image(CUSTOM_IMAGE *src, int lft, int top, int rgt, int bot)
{
    CUSTOM_IMAGE *NewImg = (CUSTOM_IMAGE *)malloc(sizeof(CUSTOM_IMAGE));
    //Get size
    NewImg->xsize    = rgt-lft;
    NewImg->ysize    = bot-top;
    NewImg->palettes = src->palettes;
    NewImg->colors   = src->colors;

    //Allocate space
    NewImg->image = (char **)malloc(sizeof(char *) * NewImg->xsize);
    for(int q = 0; q < NewImg->xsize; q ++)
    {
        NewImg->image[q] = (char *)malloc(sizeof(char) * NewImg->ysize);
    }
    NewImg->values = (int **)malloc(sizeof(int *) * NewImg->palettes);
    for(int q = 0; q < NewImg->palettes; q ++)
    {
        NewImg->values[q] = (int *)malloc(sizeof(int) * NewImg->colors);
    }

    //Fill the space
    for(int y = 0; y < NewImg->ysize; y ++)
    {
        for(int x = 0; x < NewImg->xsize; x ++)
        {
            NewImg->image[x][y] = src->image[x+lft][y+top];
        }
    }
    for(int y = 0; y < NewImg->colors; y ++)
    {
        for(int x = 0; x < NewImg->palettes; x ++)
        {
            NewImg->values[x][y] = src->values[x][y];
        }
    }

    return NewImg;
}
