void Destroy_Room()
{
    if(Room)
    {
        //Clipping Array
        for(int i = 0; i < Room->xsize * 16; i ++)
        {
            if(cliparray[i]) free(cliparray[i]);
            cliparray[i] = NULL;
        }
        if(cliparray) free(cliparray);
        cliparray = NULL;

        //Tiles Array
        for(int i = 0; i < Room->xsize; i ++)
        {
            if(Room->tiles[i]) free(Room->tiles[i]);
            Room->tiles[i] = NULL;
        }
        if(Room->tiles) free(Room->tiles);
        Room->tiles = NULL;

        //Clips Array
        for(int i = 0; i < Room->xsize; i ++)
        {
            if(Room->clips[i]) free(Room->clips[i]);
            Room->clips[i] = NULL;
        }
        if(Room->clips) free(Room->clips);
        Room->clips = NULL;
        if(Room) free(Room);
        Room = NULL;
    }
}

void Destroy_Cambounds()
{
    if(Cambounds) free(Cambounds);
    total_cambounds = 0;
    Cambounds = NULL;
}

void Destroy_Doors()
{
    for(int i = 0; i < total_doors; i ++)
    {
        if(Doors[i].name) free(Doors[i].name);
        Doors[i].name = NULL;
    }
    if(Doors) free(Doors);
    Doors = NULL;
    total_doors = 0;
}

void Destroy_Breakables()
{
    if(Breakables) free(Breakables);
    Breakables = NULL;
    total_breakables = 0;
}

void Destroy_Elevators()
{
    for(int i = 0; i < total_elevators; i ++)
    {
        if(Elevators[i].roomto) free(Elevators[i].roomto);
        Elevators[i].roomto = NULL;
    }
    if(Elevators) free(Elevators);
    total_elevators = 0;
    Elevators = NULL;
}

void Destroy_Enemies()
{
    for(int i = 0; i < total_enemies; i ++)
    {
        if(Enemies[i]->size_of_substructure != 0) free(Enemies[i]->substructure);
        Enemies[i]->substructure = NULL;
        if(Enemies[i]->immune.total_codes > 0) free(Enemies[i]->immune.codes);
        Enemies[i]->immune.codes = NULL;
        if(Enemies[i]) free(Enemies[i]);
        Enemies[i] = NULL;
    }
    if(Enemies) free(Enemies);
    Enemies = NULL;
    total_enemies = 0;
}

void Destroy_Miniguns()
{
    for(int i = 0; i < total_miniguns; i ++)
    {
        if(Minigun[i].total_lookups > 0) free(Minigun[i].lookup);
        Minigun[i].lookup = NULL;
    }
    if(Minigun) free(Minigun);
    Minigun = NULL;
    total_miniguns = 0;
}

void Destroy_Enemy_Spawners()
{
    if(Enemy_Spawner) free(Enemy_Spawner);
    Enemy_Spawner = NULL;
    total_enemy_spawners = 0;
}

void Destroy_Projectiles()
{
    for(int i = 0; i < total_projectiles; i ++)
    {
        if(Projectiles[i]->images) free(Projectiles[i]->images);
        Projectiles[i]->images = NULL;
        if(Projectiles[i]) free(Projectiles[i]);
        Projectiles[i] = NULL;
    }
    total_projectiles = 0;
}

void Destroy_Targets()
{
    for(int i = 0; i < total_targets; i ++)
    {
        if(Targets[i]) free(Targets[i]);
        Targets[i] = NULL;
    }
    if(Targets) free(Targets);
    Targets = NULL;
    total_targets = 0;
}

void Destroy_Sprites()
{
    for(int i = 0; i < total_sprites; i ++)
    {
        Deactive_Sprite(i);
    }
    if(Sprite_List) free(Sprite_List);
    Sprite_List = NULL;
    total_sprites = 0;
}

void Destroy_Sprite_Spawners()
{
    for(int i = 0; i < total_sprite_spawners; i ++)
    {
        if(Sprite_Spawner[i]) free(Sprite_Spawner[i]);
        Sprite_Spawner[i] = NULL;
    }
    if(Sprite_Spawner)free(Sprite_Spawner);
    Sprite_Spawner = NULL;
    total_sprite_spawners = 0;
}

void Destroy_Transitions()
{
    for(int i = 0; i < total_transitions; i ++)
    {
        if(Transitions[i].name) free(Transitions[i].name);
        Transitions[i].name = NULL;
        if(Transitions[i].roomto) free(Transitions[i].roomto);
        Transitions[i].roomto = NULL;
        if(Transitions[i].transto) free(Transitions[i].transto);
        Transitions[i].transto = NULL;
        Transitions[i].doorhook = NULL;
    }
    if(Transitions) free(Transitions);
    Transitions = NULL;
    total_transitions = 0;
}

void Destroy_Items()
{
    for(int i = 0; i < total_items; i ++)
    {
        if(Items[i].string) free(Items[i].string);
        Items[i].string = NULL;
    }
    if(Items) free(Items);
    Items = NULL;
    total_items = 0;
}

void Destroy_Water()
{
    for(int i = 0; i < total_water_zones; i ++)
    {
        if(Water[i].bmp) destroy_bitmap(Water[i].bmp);
        if(Water[i].bmp2) destroy_bitmap(Water[i].bmp2);
    }
    if(Water) free(Water);
    Water = NULL;
    total_water_zones = 0;
}

void Destroy_Savezone()
{
    Savezone.active = false;
}

void Destroy_Zebetites()
{
    if(Zebetite) free(Zebetite);
    Zebetite = NULL;
    total_zebetites = 0;
}

void Destroy_All()
{
    printf("S");
    Destroy_Room();
    printf("R");
    Destroy_Cambounds();
    printf("C");
    Destroy_Doors();
    printf("D");
    Destroy_Breakables();
    printf("B");
    Destroy_Elevators();
    printf("E");
    Destroy_Enemies();
    printf("E");
    Destroy_Miniguns();
    printf("M");
    Destroy_Enemy_Spawners();
    printf("!");
    Destroy_Projectiles();
    printf("P");
    Destroy_Targets();
    printf("T");
    Destroy_Sprites();
    printf("S");
    Destroy_Sprite_Spawners();
    printf("!");
    Destroy_Transitions();
    printf("T");
    Destroy_Items();
    printf("I");
    Destroy_Water();
    printf("W");
    Destroy_Savezone();
    printf("S");
    Destroy_Zebetites();
    printf("Z");
    samvar.hamper_movement = false;
    metroid_latch_count = 0;
    metroid_latch_index = -1;
    for(int i = 0; i < total_rinkas; i ++)
    {
        Rinka[i].active = false;
    }
    printf("?");
}
