void Create_Door(char name[], int x, int y, int facing)
{
    if(x == 0) x = 1;
    //if(x ==
    //printf("Allocating door from memory %i\n", Doors);
    Doors = (DOOR *)realloc(Doors, sizeof(DOOR) * (total_doors + 1));
    Doors[total_doors].name = (char *)malloc(strlen(name)+1);
    Init_String(Doors[total_doors].name, name, strlen(name));

    Doors[total_doors].active = true;
    Doors[total_doors].facing = facing;
    if(facing == LEFT)
    {
        Doors[total_doors].dim.lft = x;
        Doors[total_doors].dim.rgt = x + 24;
    }
    else if(facing == RIGHT)
    {
        Doors[total_doors].dim.lft = x-16;
        Doors[total_doors].dim.rgt = x + 8;
    }
    Doors[total_doors].dim.top = y;
    Doors[total_doors].dim.bot = y + 48;
    Doors[total_doors].openstatus = 0;
    Doors[total_doors].to_reclose = 0;

    if((Doors[total_doors].facing & 2) OR Get_Cvar_Value_I("door_missiles_mode") == 1)
    {
        Doors[total_doors].type = MISSILE_DOOR;
        Doors[total_doors].health = 5;
    }
    else
    {
        Doors[total_doors].type = NORMAL_DOOR;
        Doors[total_doors].health = 1;
    }

    Add_To_Target_List(TARGET_DOOR, total_doors);
    Clip_Area(Doors[total_doors].dim, 255 - STOP_PROJECTILE);
    Refresh_Door_Hooks();
    total_doors ++;
}

void Create_Transition_Zone(char name[], char doorhook[], int lft, int top, int rgt, int bot, int direction, char roomto[], char transto[])
{
    Transitions = (TRANSITION *)realloc(Transitions, sizeof(TRANSITION) * (total_transitions + 1));

    //The name of this transition
    Transitions[total_transitions].name = (char *)malloc((strlen(name)+1) * sizeof(char));
    Init_String(Transitions[total_transitions].name, name, strlen(name));

    //Roomto, the room this transition segues to
    Transitions[total_transitions].roomto = (char *)malloc((strlen(roomto)+1) * sizeof(char));
    Init_String(Transitions[total_transitions].roomto, roomto, strlen(roomto));

    //Which transition this links to, by name
    Transitions[total_transitions].transto = (char *)malloc((strlen(transto)+1) * sizeof(char));
    Init_String(Transitions[total_transitions].transto, transto, strlen(transto));

    //Hook to an existing door using it's name
    Transitions[total_transitions].doorhook = NULL;
    for(int i = 0; i < total_doors; i ++)
    {
        if(!strcasecmp(doorhook, Doors[i].name))
        {
            Transitions[total_transitions].doorhook = &Doors[i];
            Transitions[total_transitions].doorhookval = i;
            i = total_doors;
        }
    }

    Transitions[total_transitions].dim.lft = lft;
    Transitions[total_transitions].dim.rgt = rgt;
    Transitions[total_transitions].dim.top = top;
    Transitions[total_transitions].dim.bot = bot;
    Transitions[total_transitions].direction = direction;
    total_transitions ++;
}

void Update_Doors()
{
    for(int i = 0; i < total_doors; i ++)
    {
        if(Doors[i].active)
        {
            if(Doors[i].health < 1) //Door has been shot
            {
                if(Doors[i].openstatus > 0)
                {
                    Doors[i].openstatus --;
                    if(Doors[i].openstatus == 0)
                    {
                        BASS_ChannelPlay(Audio.Door_Open, true);
                        Open_Door(i);
                    }
                }
                else
                {
                    Doors[i].openstatus = 8;
                    Remove_From_Target_List(&Doors[i].health);
                    Doors[i].type = NORMAL_DOOR;
                }
            }
        }
        else if(Doors[i].to_reclose > 0) //Door recloses after it hits 0
        {
            Doors[i].to_reclose --;
            if(Doors[i].to_reclose == 0)
            {
                BASS_ChannelPlay(Audio.Door_Open, true);
                printf("Door %i has reclosed\n", i);
                Doors[i].active = true;
                Doors[i].health = 1;
                Doors[i].type = NORMAL_DOOR;
                Add_To_Target_List(TARGET_DOOR, i);
                Clip_Area(Doors[i].dim, 255 - STOP_PROJECTILE);

            }
        }
    }
}

void Refresh_Door_Hooks()
{
    for(int i = 0; i < total_transitions; i ++)
    {
        if(Transitions[i].doorhookval != -1)
        {
            Transitions[i].doorhook = &Doors[Transitions[i].doorhookval];
        }
    }
}

void Open_Door(int i)
{
    Doors[i].active = false;
    if(Doors[i].type == MISSILE_DOOR)
    {
        Add_Door_To_Opened_List(Saveout, curlev_name, Doors[i].name, 0);
    }
    Doors[i].type = NORMAL_DOOR;
    Doors[i].health = 0;
    Doors[i].to_reclose = 180;
    Clip_Area(Doors[i].dim, 0x00);
    if(Doors[i].facing == RIGHT) Clip_Area(Doors[i].dim.lft, Doors[i].dim.top, Doors[i].dim.lft, Doors[i].dim.bot, 255 - STOP_SAMUS - STOP_PROJECTILE - STOP_FREEZE);
    else if(Doors[i].facing == LEFT) Clip_Area(Doors[i].dim.rgt, Doors[i].dim.top, Doors[i].dim.rgt, Doors[i].dim.bot, 255 - STOP_SAMUS - STOP_PROJECTILE - STOP_FREEZE);
}

void Open_Door(DOOR *Door)
{
    Door->active = false;
    if(Door->type == MISSILE_DOOR)
    {
        Add_Door_To_Opened_List(Saveout, curlev_name, Door->name, 0);
    }
    Door->type = NORMAL_DOOR;
    Door->health = 0;
    Door->to_reclose = 180;
    Clip_Area(Door->dim, 0x00);
    if(Door->facing == RIGHT) Clip_Area(Door->dim.lft, Door->dim.top, Door->dim.lft, Door->dim.bot, 255 - STOP_SAMUS - STOP_PROJECTILE - STOP_FREEZE);
    else if(Door->facing == LEFT) Clip_Area(Door->dim.rgt, Door->dim.top, Door->dim.rgt, Door->dim.bot, 255 - STOP_SAMUS - STOP_PROJECTILE - STOP_FREEZE);
    printf("Door has been opened by address\n");
}

void Neutralize_Opened_Doors()
{
    for(int s = 0; s < Saveout->doors_saved; s ++)
    {
        if(!strcmp(Saveout->Door_Status_Save[s].roomname, curlev_name)) //Door is in 'this' room
        {
            for(int i = 0; i < total_doors; i ++)
            {
                if(Doors[i].active AND !strcmp(Saveout->Door_Status_Save[s].doorname, Doors[i].name))
                {
                    if(Saveout->Door_Status_Save[s].hit_status == 0)
                    {
                        Doors[i].type = NORMAL_DOOR;
                        Doors[i].health = 1;
                    }
                    else
                    {
                        Doors[i].health = Saveout->Door_Status_Save[s].hit_status;
                    }
                }
            }
        }
    }
}

void Update_Transitions()
{
    for(int i = 0; i < total_transitions; i ++)
    {
        if(rect_clip(samvar.dim, Transitions[i].dim)) //Samus is in a transition
        {
            door_distance_top = Transitions[i].dim.top;
            door_distance_bot = (Room->ysize*16) - Transitions[i].dim.bot;
            vertical_scroll_dif = Transitions[i].dim.top - (camera.top + 96);
            to_reach_vert = 0;
            transition_stage = 1;
            Init_String(transition_name, Transitions[i].roomto, 80);
            Init_String(transition_to, Transitions[i].transto, 80);
            trans_y_dif = samvar.y - Transitions[i].dim.top;
            transition_direction = Transitions[i].direction;
            i = total_transitions;
        }
    }
}
