void draw_sprite_palette(BITMAP *dest, CUSTOM_IMAGE *src, int xdest, int ydest, int pal_use)
{
    if(pal_use >= src->palettes OR pal_use < 0) pal_use = 0;
    for(int x = 0; x < src->xsize; x ++)
    {
        for(int y = 0; y < src->ysize; y ++)
        {
            if(src->image[x][y] != 0)
            {
                putpixel(dest, xdest+x, ydest+y, src->values[pal_use][src->image[x][y]-1]);
            }
        }
    }
}

void draw_sprite_h_flip_palette(BITMAP *dest, CUSTOM_IMAGE *src, int xdest, int ydest, int pal_use)
{
    if(pal_use >= src->palettes OR pal_use < 0) pal_use = 0;
    for(int x = 0; x < src->xsize; x ++)
    {
        for(int y = 0; y < src->ysize; y ++)
        {
            if(src->image[x][y] != 0)
            {
                putpixel(dest, xdest+src->xsize-x-1, ydest+y, src->values[pal_use][src->image[x][y]-1]);
            }
        }
    }
}

void draw_sprite_v_flip_palette(BITMAP *dest, CUSTOM_IMAGE *src, int xdest, int ydest, int pal_use)
{
    if(pal_use >= src->palettes OR pal_use < 0) pal_use = 0;
    for(int x = 0; x < src->xsize; x ++)
    {
        for(int y = 0; y < src->ysize; y ++)
        {
            if(src->image[x][y] != 0)
            {
                putpixel(dest, xdest+x, ydest+src->ysize-y-1, src->values[pal_use][src->image[x][y]-1]);
            }
        }
    }
}

void draw_sprite_vh_flip_palette(BITMAP *dest, CUSTOM_IMAGE *src, int xdest, int ydest, int pal_use)
{
    if(pal_use >= src->palettes OR pal_use < 0) pal_use = 0;
    for(int x = 0; x < src->xsize; x ++)
    {
        for(int y = 0; y < src->ysize; y ++)
        {
            if(src->image[x][y] != 0)
            {
                putpixel(dest, xdest+src->xsize-x-1, ydest+src->ysize-y-1, src->values[pal_use][src->image[x][y]-1]);
            }
        }
    }
}

void rotate_sprite_palette(BITMAP *dest, CUSTOM_IMAGE *src, int xdest, int ydest, int pal_use, fixed angle)
{
    if(pal_use >= src->palettes OR pal_use < 0) pal_use = 0;
    BITMAP *tmpbmp = create_bitmap(src->xsize, src->ysize);
    clear_to_color(tmpbmp, transparent);
    for(int x = 0; x < src->xsize; x ++)
    {
        for(int y = 0; y < src->ysize; y ++)
        {
            if(src->image[x][y] != 0)
            {
                putpixel(tmpbmp, x, y, src->values[pal_use][src->image[x][y]-1]);
            }
        }
    }
    rotate_sprite(dest, tmpbmp, xdest, ydest, angle);
    destroy_bitmap(tmpbmp);
}

void Draw_To_Screen(BITMAP *source)
{
    acquire_screen();
    if(screen_var == 0)
    {
       // blit(source, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
        stretch_blit(source, screen, 0, 0, source->w, source->h, 0, 0, SCREEN_W, SCREEN_H);
    }
    else
    {
        stretch_blit(source, screen, 0, 0, source->w, source->h, 0, 0, SCREEN_W, SCREEN_H);
    }
    release_screen();
}
