void Create_Elevator(int x, int y, char dir, char roomto[])
{
    //Note:  Unlike other things like sprites, Elevators cannot be rendered inactive and replaced.
    //Elevators that are not active are displayed but cannot be used, for effect.
    Elevators = (ELEVATOR *)realloc(Elevators, sizeof(ELEVATOR) * (total_elevators + 1));
    Elevators[total_elevators].active = true;

    Elevators[total_elevators].dim.lft = x * 16;
    Elevators[total_elevators].dim.top = y * 16;
    Elevators[total_elevators].dim.rgt = x * 16 + 32;
    Elevators[total_elevators].dim.bot = y * 16 + 16;

    Elevators[total_elevators].roomto = (char *)malloc(sizeof(char) * (strlen(roomto)+1));
    Init_String(Elevators[total_elevators].roomto, roomto, 0);

    Elevators[total_elevators].direction = dir;
    Elevators[total_elevators].cur_y = 0;
    Elevators[total_elevators].in_use = false;
    Elevators[total_elevators].lockout = 0;
    Clip_Area(Elevators[total_elevators].dim, 255);
    total_elevators ++;
}

void Update_Elevators()
{
    elevator_clear_level = false;
    for(int i = 0; i < total_elevators; i ++)
    {
        if(Elevators[i].active)
        {
            if(Elevators[i].lockout AND !Elevators[i].in_use) Elevators[i].lockout --;
            if(!Elevators[i].in_use AND !Elevators[i].lockout) //Detect if Samus is trying to use it
            {
                if(samvar.dim.lft > Elevators[i].dim.lft AND samvar.dim.rgt < Elevators[i].dim.rgt AND samvar.dim.bot > Elevators[i].dim.top - 3 AND samvar.dim.bot < Elevators[i].dim.top+3) //She's on the elevator
                {
                    samvar.ball_mode = false;
                    if(Elevators[i].direction == DOWN AND samvar.press_down) Elevators[i].in_use = true;
                    else if(Elevators[i].direction == UP AND samvar.press_up) Elevators[i].in_use = true;
                }
            }
            if(Elevators[i].in_use) //Update the elevator
            {
                do_not_draw_samus = true;
                samvar.lockout_controls = true;
                samvar.lockout_timer = 10;
                if(Elevators[i].direction == DOWN)
                {
                    Elevators[i].cur_y ++;
                    if(Elevators[i].cur_y > (Room->ysize * 16) + 48) //Passed into new room
                    {
                        Init_String(transition_name, Elevators[i].roomto, 80);
                        Destroy_All();
                        Read_Level(transition_name, &Room);
                        if(New_Music != Cur_Music)
                        {
                            elevator_swap_music = true;
                            music_fade_out = true;
                            music_fade_out_timer = 100;
                        }
                        samvar.x = 100;
                        samvar.y = 100;
                        transition_by_elevator = true;
                        if(total_elevators != 0)
                        {
                            Elevators[0].cur_y = -128;
                            Elevators[0].in_use = true;
                            Elevators[0].lockout = 30;
                        }
                    }
                }
                else if(Elevators[i].direction == UP)
                {
                    Elevators[i].cur_y --;
                    if(Elevators[i].cur_y < -256) //Passed into new room
                    {
                        Init_String(transition_name, Elevators[i].roomto, 80);
                        Destroy_All();
                        if(!strcmp(transition_name, ROOMS"CREDITS.mcl"))
                        {
                            escape_active = false;
                            escape_audio = false;
                            init_credits = true;
                            credits_running = true;
                            skip_drawing_credits_this_pulse = true;
                            elevator_clear_level = true;
                            Destroy_All();
                        }
                        else
                        {
                            Read_Level(transition_name, &Room);
                            if(New_Music != Cur_Music)
                            {
                                elevator_swap_music = true;
                                music_fade_out = true;
                                music_fade_out_timer = 100;
                            }
                            samvar.x = 100;
                            samvar.y = 100;
                            transition_by_elevator = true;
                            if(total_elevators != 0)
                            {
                                Elevators[0].cur_y = 128;
                                Elevators[0].in_use = true;
                                Elevators[0].lockout = 30;
                            }
                        }
                    }
                }
            }
        }
    }
}
