void Create_Enemy_Spawner(int x, int y, bool hardtype, int type, int cooldown, bool to_watch, int proxy_range)
{   
    for(int i = 0; i < total_enemy_spawners; i ++)
    {
        if(!Enemy_Spawner[i].active)
        {
            Place_Enemy_Spawner_In_Slot(i, x, y, hardtype, type, cooldown, to_watch, proxy_range);
            return;
        }
    }
    Enemy_Spawner = (ENEMY_SPAWNER *)realloc(Enemy_Spawner, sizeof(ENEMY_SPAWNER) * (total_enemy_spawners + 1));

    Place_Enemy_Spawner_In_Slot(total_enemy_spawners, x, y, hardtype, type, cooldown, to_watch, proxy_range);
    total_enemy_spawners ++;
    return;
}

void Place_Enemy_Spawner_In_Slot(int i, int x, int y, bool hardtype, int type, int cooldown, bool to_watch, int proxy_range)
{
    Enemy_Spawner[i].active = true;
    Enemy_Spawner[i].x = x;
    Enemy_Spawner[i].y = y;
    Enemy_Spawner[i].hardtype = hardtype;
    Enemy_Spawner[i].type = type;
    Enemy_Spawner[i].cooldown = cooldown;
    Enemy_Spawner[i].cooldown_timer = 0;

    if(to_watch)
    {
        Enemy_Spawner[i].one_enemy_only = true;
        Enemy_Spawner[i].enemy_to_watch = -1;
    }
    else
    {
        Enemy_Spawner[i].one_enemy_only = false;
    }

    if(proxy_range != -1)
    {
        Enemy_Spawner[i].proximity_mode = true;
        Enemy_Spawner[i].proximity_range = proxy_range;
    }
    else
    {
        Enemy_Spawner[i].proximity_mode = false;
    }

    if(rinka_flag)
    {
        Enemy_Spawner[i].create_pointer = &Create_Rinka;
        Enemy_Spawner[i].one_enemy_only = false;
        rinka_flag = false;
    }
    else
    {
        Enemy_Spawner[i].create_pointer = &Create_Zeb;
    }
}

void Update_Enemy_Spawners()
{
    for(int i = 0; i < total_enemy_spawners; i ++)
    {
        if(Enemy_Spawner[i].active)
        {
            if(!Enemy_Spawner[i].proximity_mode OR (samvar.dim.rgt > Enemy_Spawner[i].x - Enemy_Spawner[i].proximity_range AND samvar.dim.lft < Enemy_Spawner[i].x + Enemy_Spawner[i].proximity_range))
            {
                if(Enemy_Spawner[i].one_enemy_only) //Respawn when the enemy flags as dead
                {
                    if(Enemy_Spawner[i].enemy_to_watch == -1)
                    {
                        Enemy_Spawner[i].enemy_to_watch = Enemy_Spawner[i].create_pointer(Enemy_Spawner[i].x, Enemy_Spawner[i].y, Enemy_Spawner[i].hardtype, Enemy_Spawner[i].type);
                    }
                    else if(Enemies[Enemy_Spawner[i].enemy_to_watch]->active == false)
                    {
                        Enemy_Spawner[i].enemy_to_watch = Enemy_Spawner[i].create_pointer(Enemy_Spawner[i].x, Enemy_Spawner[i].y, Enemy_Spawner[i].hardtype, Enemy_Spawner[i].type);
                    }
                }
                else //Respawn when the cooldown timer hits 0
                {
                    Enemy_Spawner[i].cooldown_timer --;
                    if(Enemy_Spawner[i].cooldown_timer <= 0)
                    {
                        Enemy_Spawner[i].create_pointer(Enemy_Spawner[i].x, Enemy_Spawner[i].y, Enemy_Spawner[i].hardtype, Enemy_Spawner[i].type);
                        Enemy_Spawner[i].cooldown_timer = Enemy_Spawner[i].cooldown;
                    }
                }
            }
        }
    }
}
