void Update_Save_File_Roomname(SAVEFILE *Save, char name[])
{
    if(Save->roomname) free(Save->roomname);
    Save->roomname_len = strlen(name) + 1;
    Save->roomname = (char *)malloc(sizeof(char) * Save->roomname_len);
    Init_String(Save->roomname, name, Save->roomname_len);
}

void Update_Save_File_Stats(SAVEFILE *Save)
{
    Save->energy = samvar.energy;
    Save->energy_max = samvar.energy_max;
    Save->missiles = samvar.missiles;
    Save->missiles_max = samvar.missiles_max;
    Save->long_beam = samvar.Collected.long_beam + samvar.Using.long_beam*2;
    Save->charge_beam = samvar.Collected.charge_beam + samvar.Using.charge_beam*2;
    Save->ice_beam = samvar.Collected.ice_beam + samvar.Using.ice_beam*2;
    Save->wave_beam = samvar.Collected.wave_beam + samvar.Using.wave_beam*2;
    Save->spazer_beam = samvar.Collected.spazer_beam + samvar.Using.spazer_beam*2;
    Save->plasma_beam = samvar.Collected.plasma_beam + samvar.Using.plasma_beam*2;
    Save->helix_beam = samvar.Collected.helix_beam + samvar.Using.helix_beam*2;
    Save->burn_beam = samvar.Collected.burn_beam + samvar.Using.burn_beam*2;
    Save->shock_beam = samvar.Collected.shock_beam + samvar.Using.shock_beam*2;
    Save->varia_suit = samvar.Collected.varia_suit + samvar.Using.varia_suit*2;
    Save->gravity_suit = samvar.Collected.gravity_suit + samvar.Using.gravity_suit*2;
    Save->morph_ball = samvar.Collected.morph_ball + samvar.Using.morph_ball*2;
    Save->bombs = samvar.Collected.bombs + samvar.Using.bombs*2;
    Save->spring_ball = samvar.Collected.spring_ball + samvar.Using.spring_ball*2;
    Save->screw_attack = samvar.Collected.screw_attack + samvar.Using.screw_attack*2;
    Save->high_jump = samvar.Collected.high_jump + samvar.Using.high_jump*2;
    Save->space_jump = samvar.Collected.space_jump + samvar.Using.space_jump*2;
    Save->speed_booster = samvar.Collected.speed_booster + samvar.Using.speed_booster*2;
    Save->ridley_dead = samvar.ridley_dead;
    Save->kraid_dead = samvar.kraid_dead;
}


void Write_Save_File(SAVEFILE *Save, char path[])
{
    FILE *output = fopen(path, "wb+");
    if(!output)
    {
        printf("FAILURE:  File %s could not be opened.\n", path);
        return;
    }
    char *version = (char *)malloc(sizeof(char) * 15);
    Init_String(version, "Save File v1.0", 15);
    fwrite(version, sizeof(char) * 15, 1, output);
    fwrite(&curlev_len, sizeof(int), 1, output);
    fwrite(curlev_name, sizeof(char) * curlev_len, 1, output);
    fwrite(&Save->energy, sizeof(int), 1, output);
    fwrite(&Save->energy_max, sizeof(int), 1, output);
    fwrite(&Save->missiles, sizeof(int), 1, output);
    fwrite(&Save->missiles_max, sizeof(int), 1, output);
    fwrite(&Save->long_beam, sizeof(int), 1, output);
    fwrite(&Save->charge_beam, sizeof(int), 1, output);
    fwrite(&Save->ice_beam, sizeof(int), 1, output);
    fwrite(&Save->wave_beam, sizeof(int), 1, output);
    fwrite(&Save->spazer_beam, sizeof(int), 1, output);
    fwrite(&Save->plasma_beam, sizeof(int), 1, output);
    fwrite(&Save->helix_beam, sizeof(int), 1, output);
    fwrite(&Save->burn_beam, sizeof(int), 1, output);
    fwrite(&Save->shock_beam, sizeof(int), 1, output);
    fwrite(&Save->varia_suit, sizeof(int), 1, output);
    fwrite(&Save->gravity_suit, sizeof(int), 1, output);
    fwrite(&Save->morph_ball, sizeof(int), 1, output);
    fwrite(&Save->bombs, sizeof(int), 1, output);
    fwrite(&Save->spring_ball, sizeof(int), 1, output);
    fwrite(&Save->screw_attack, sizeof(int), 1, output);
    fwrite(&Save->high_jump, sizeof(int), 1, output);
    fwrite(&Save->space_jump, sizeof(int), 1, output);
    fwrite(&Save->speed_booster, sizeof(int), 1, output);
    fwrite(&Save->ridley_dead, sizeof(bool), 1, output);
    fwrite(&Save->kraid_dead, sizeof(bool), 1, output);

    //Doors
    fwrite(&Save->doors_saved, sizeof(int), 1, output);
    for(int i = 0; i < Save->doors_saved; i ++)
    {
        fwrite(&Save->Door_Status_Save[i].roomname_len, sizeof(int), 1, output);
        fwrite(Save->Door_Status_Save[i].roomname, sizeof(char) * Save->Door_Status_Save[i].roomname_len, 1, output);
        fwrite(&Save->Door_Status_Save[i].doorname_len, sizeof(int), 1, output);
        fwrite(Save->Door_Status_Save[i].doorname, sizeof(char) * Save->Door_Status_Save[i].doorname_len, 1, output);
        fwrite(&Save->Door_Status_Save[i].hit_status, sizeof(int), 1, output);
    }

    //Collected items
    fwrite(&Save->objects_saved, sizeof(int), 1, output);
    for(int i = 0; i < Save->objects_saved; i ++)
    {
        fwrite(&Save->Object_Status_Save[i].roomname_len, sizeof(int), 1, output);
        fwrite(Save->Object_Status_Save[i].roomname, sizeof(char) * Save->Object_Status_Save[i].roomname_len, 1, output);
        fwrite(&Save->Object_Status_Save[i].object_pos, sizeof(int), 1, output);
    }

    //Maps
    fwrite(&Save->maps_accessed, sizeof(int), 1, output);
    for(int i = 0; i < Save->maps_accessed; i ++)
    {
        fwrite(&Save->Savemap[i].name_len, sizeof(int), 1, output);
        fwrite(Save->Savemap[i].name, sizeof(char) * Save->Savemap[i].name_len, 1, output);
        fwrite(&Save->Savemap[i].xsize, sizeof(int), 1, output);
        fwrite(&Save->Savemap[i].ysize, sizeof(int), 1, output);
        for(int x = 0; x < Save->Savemap[i].xsize; x ++)
        {
            for(int y = 0; y < Save->Savemap[i].ysize; y ++)
            {
                fwrite(&Save->Savemap[i].vals[x][y], sizeof(short), 1, output);
            }
        }
    }

    fclose(output);
}

void Add_Door_To_Opened_List(SAVEFILE *Save, char roomname[], char doorname[], int hit_status)
{
    bool success_flag = false;
    for(int i = 0; i < Save->doors_saved; i ++)
    {
        if(!strcmp(Save->Door_Status_Save[i].roomname, roomname) AND !strcmp(Save->Door_Status_Save[i].doorname, doorname))
        {
            Save->Door_Status_Save[i].hit_status = hit_status; //Existing door updated
            success_flag = true;
        }
    }
    if(!success_flag)
    {
        Save->Door_Status_Save = (OPENED_DOOR *)realloc(Save->Door_Status_Save, sizeof(OPENED_DOOR) * (Save->doors_saved+1));
        int i = Save->doors_saved;
        Save->Door_Status_Save[i].roomname_len = strlen(roomname)+1;
        Save->Door_Status_Save[i].roomname = (char *)malloc(sizeof(char) * Save->Door_Status_Save[i].roomname_len);
        Init_String(Save->Door_Status_Save[i].roomname, roomname, Save->Door_Status_Save[i].roomname_len);
        Save->Door_Status_Save[i].doorname_len = strlen(doorname)+1;
        Save->Door_Status_Save[i].doorname = (char *)malloc(sizeof(char) * Save->Door_Status_Save[i].doorname_len);
        Init_String(Save->Door_Status_Save[i].doorname, doorname, Save->Door_Status_Save[i].doorname_len);
        Save->Door_Status_Save[i].hit_status = hit_status;
        Save->doors_saved ++;
    }
}

void Clear_Save_Data(SAVEFILE *Save)
{
    Save->energy = 0;
    Save->energy_max = 0;
    Save->missiles = 0;
    Save->missiles_max = 0;
    Save->long_beam = 0;
    Save->charge_beam = 0;
    Save->ice_beam = 0;
    Save->wave_beam = 0;
    Save->spazer_beam = 0;
    Save->plasma_beam = 0;
    Save->helix_beam = 0;
    Save->burn_beam = 0;
    Save->shock_beam = 0;
    Save->varia_suit = 0;
    Save->gravity_suit = 0;
    Save->morph_ball = 0;
    Save->bombs = 0;
    Save->spring_ball = 0;
    Save->screw_attack = 0;
    Save->high_jump = 0;
    Save->space_jump = 0;
    Save->speed_booster = 0;
    Save->ridley_dead = 0;
    Save->kraid_dead = 0;
    Save->roomname_len = 0;
    if(Save->roomname) free(Save->roomname);
    Save->doors_saved = 0;
    if(Save->Door_Status_Save) free(Save->Door_Status_Save);
    Save->Door_Status_Save = NULL;
    Save->objects_saved = 0;
    if(Save->Object_Status_Save) free(Save->Object_Status_Save);
    Save->Object_Status_Save = NULL;
}

void Add_Saved_Object(SAVEFILE *Save, int position)
{
    Save->Object_Status_Save = (SAVED_OBJECT *)realloc(Save->Object_Status_Save, sizeof(SAVED_OBJECT) * (Save->objects_saved+1));
    int i = Save->objects_saved;

    Save->Object_Status_Save[i].roomname_len = strlen(curlev_name)+1;
    Save->Object_Status_Save[i].roomname = (char *)malloc(sizeof(char) * Save->Object_Status_Save[i].roomname_len);
    Init_String(Save->Object_Status_Save[i].roomname, curlev_name, Save->Object_Status_Save[i].roomname_len);
    Save->Object_Status_Save[i].object_pos = position;

    Save->objects_saved ++;
}

void Add_Saved_Map(SAVEFILE *Save, char name[], int xsize, int ysize)
{
    int i = Save->maps_accessed;
    Save->Savemap = (SAVEMAP *)realloc(Save->Savemap, sizeof(SAVEMAP) * (i+1));
    Save->Savemap[i].name = (char *)malloc(sizeof(char) * (strlen(name) + 1));
    Init_String(Save->Savemap[i].name, name, 0);
    Save->Savemap[i].name_len = strlen(name) + 1;

    Save->Savemap[i].xsize = xsize;
    Save->Savemap[i].ysize = ysize;
    Save->Savemap[i].vals = (short **)malloc(sizeof(short *) * xsize);
    for(int x = 0; x < xsize; x ++)
    {
        Save->Savemap[i].vals[x] = (short *)malloc(sizeof(short) * ysize);
        for(int y = 0; y < ysize; y ++) Save->Savemap[i].vals[x][y] = 0; //Clear to undiscovered
    }

    Save->maps_accessed ++;
}

void Update_Saved_Map(SAVEFILE *Save, char name[], MAP *Map)
{
    for(int i = 0; i < Save->maps_accessed; i ++)
    {
        if(!strcmp(Save->Savemap[i].name, name))
        {
            for(int x = 0; x < Save->Savemap[i].xsize; x ++)
            {
                for(int y = 0; y < Save->Savemap[i].ysize; y ++)
                {
                    Save->Savemap[i].vals[x][y] = Map->vals[x][y];
                }
            }
        }
    }
}

void Create_Save_Zone(int lft, int top, int rgt, int bot)
{
    Savezone.active = true;
    Savezone.dim.lft = lft;
    Savezone.dim.top = top;
    Savezone.dim.rgt = rgt;
    Savezone.dim.bot = bot;
    Savezone.cooldown = 0;
    Savezone.show_message = false;
    Savezone.show_message_saved = false;
}

void Update_Save_Zone()
{
    if(Savezone.active)
    {
        if(Savezone.cooldown > 0)
        {
            Savezone.cooldown --;
            Savezone.show_message = false;
            if(Savezone.cooldown > 150) Savezone.show_message_saved = true;
            else Savezone.show_message_saved = false;
        }
        else
        {
            if(rect_clip(samvar.dim, Savezone.dim))
            {
                if(samvar.press_saveout)
                {
                    //printf("Saving\n");
                    Update_Save_File_Roomname(Saveout, curlev_name);
                    //printf("Stats updating\n");
                    Update_Save_File_Stats(Saveout);
                    //printf("Stats updated\n");
                    Write_Save_File(Saveout, Saveout_path);
                    //printf("Written\n");
                    Savezone.cooldown = 300;
                    Savezone.show_message_saved = true;
                    Savezone.show_message = false;
                }
                else
                {
                    Savezone.show_message = true;
                }
            }
            else
            {
                Savezone.show_message = false;
            }
        }
    }
}
