////////////////////////////////////////////////////////////////////////////////
//  Geemers
//
//  Geemers do not have a substructure, because they're so damned simple
////////////////////////////////////////////////////////////////////////////////

// 0 = Zoomer
// 1 = Nova
// 2 = Zeela
// 3 = Viola
int Create_Geemer(int x, int y, bool hardtype, int type)
{
    for(int i = 0; i < total_enemies; i ++) //Scan the old enemies to see if one is unused
    {
        if(!Enemies[i]->active)
        {
            Place_Geemer_In_Slot(i, x, y, hardtype, type);
            return i;
        }
    }
    Enemies = (ENEMY **)realloc(Enemies, sizeof(ENEMY *) * (total_enemies + 1));
    Enemies[total_enemies] = (ENEMY *)malloc(sizeof(ENEMY));
    Enemies[total_enemies]->substructure = NULL;
    Enemies[total_enemies]->display.images = NULL;
    Enemies[total_enemies]->immune.codes = NULL;

    Place_Geemer_In_Slot(total_enemies, x, y, hardtype, type);
    total_enemies ++;
    return total_enemies - 1;
}

void Place_Geemer_In_Slot(int i, int x, int y, bool hardtype, int type)
{
    Enemies[i]->active = true;
    Enemies[i]->type_flag = GEEMER;
    Enemies[i]->funcptr = &Update_Geemer;
    Enemies[i]->substructure = NULL;
    Enemies[i]->size_of_substructure = 0;
    Enemies[i]->coord.x = x;
    Enemies[i]->coord.y = y;
    Enemies[i]->bound.lft = Enemies[i]->coord.x;
    Enemies[i]->bound.rgt = Enemies[i]->coord.x + 16;
    Enemies[i]->bound.top = Enemies[i]->coord.y;
    Enemies[i]->bound.bot = Enemies[i]->coord.y + 16;
    Enemies[i]->coord.orientation = RIGHT;
    Enemies[i]->stats.health = 2;
    if(hardtype) Enemies[i]->stats.health *= 2;
    Enemies[i]->stats.hardtype = hardtype;
    Enemies[i]->stats.damage = 8;
    Enemies[i]->stats.speed_modifier = 1;
    Enemies[i]->stats.vulnerabilities = BEAM_ALL;
    if(Enemies[i]->display.images) free(Enemies[i]->display.images);
    Enemies[i]->display.to_show = 0;
    Enemies[i]->display.rotation = 0;
    Enemies[i]->display.draw_cnt = 0;
    Enemies[i]->team = 1;
    Enemies[i]->Sound = &Audio.Injured_Small;
    Enemies[i]->stun_timer = 0;
    Enemies[i]->freeze_timer = 0;
    Enemies[i]->refreeze_timer = 0;
    Enemies[i]->palette = 0;
    Add_To_Target_List(TARGET_ENEMY, i);

    if(Enemies[i]->immune.codes) free(Enemies[i]->immune.codes);
    Enemies[i]->immune.codes = NULL;
    Enemies[i]->immune.total_codes = 0;
    if(type == 0) //Zoomer and Geemer
    {
        Enemies[i]->display.images = (CUSTOM_IMAGE **)malloc(sizeof(CUSTOM_IMAGE *) * 1);
        Enemies[i]->display.images[0] = Enemy_Images[0];
        Enemies[i]->display.update = Update_Geemer_GFX;
    }
    else if(type == 1) //Nova
    {
        Enemies[i]->display.images = (CUSTOM_IMAGE **)malloc(sizeof(CUSTOM_IMAGE *) * 2);
        Enemies[i]->display.images[0] = Enemy_Images[1];
        Enemies[i]->display.images[1] = Enemy_Images[2];
        Enemies[i]->display.update = Update_Nova_GFX;
    }
    else if(type == 2) //Zeela
    {
        Enemies[i]->display.images = (CUSTOM_IMAGE **)malloc(sizeof(CUSTOM_IMAGE *) * 1);
        Enemies[i]->display.images[0] = Enemy_Images[3];
        Enemies[i]->display.update = Update_Zeela_GFX;
    }
    else if(type == 3) //Viola
    {
        Enemies[i]->display.images = (CUSTOM_IMAGE **)malloc(sizeof(CUSTOM_IMAGE *) * 1);
        Enemies[i]->display.images[0] = Enemy_Images[4];
        Enemies[i]->display.update = Update_Viola_GFX;
    }
}

void Update_Geemer(int i) //Geemer is assumed to be active
{
    if(Enemies[i]->stats.health <= 0) //Geemer is dead :(
    {
        Create_Random_Item(Enemies[i]->bound, SMALLTYPE, false);
        int spritenum = Create_Sprite(((Enemies[i]->bound.lft+Enemies[i]->bound.rgt)/2)-16, ((Enemies[i]->bound.top+Enemies[i]->bound.bot)/2)-16, 3, 2, 6);
        if(spritenum != -1) Imagize_Sprite_Explosion(spritenum);
        Enemies[i]->active = false;
        Remove_From_Target_List(&Enemies[i]->stats.health);
        Unclip_Area(Enemies[i]->bound, STOP_FREEZE);
        return;
    }
    if(Enemies[i]->stun_timer > 0)
    {
        Enemies[i]->stun_timer --;
        if(Enemies[i]->stats.hardtype) Enemies[i]->palette = 0;
        else Enemies[i]->palette = 1;
        return;
    }
    if(Enemies[i]->freeze_timer > 0)
    {
        Freeze_Clip_Area(Enemies[i]->bound, STOP_FREEZE);
        Enemies[i]->freeze_timer --;
        if(Enemies[i]->freeze_timer == 0) Unclip_Area(Enemies[i]->bound, STOP_FREEZE);
        if(Enemies[i]->freeze_timer < 50)
        {
            if((Enemies[i]->freeze_timer % 4) < 2)
            {
                Enemies[i]->palette = 2;
            }
            else
            {
                if(Enemies[i]->stats.hardtype) Enemies[i]->palette = 1;
                else Enemies[i]->palette = 0;
            }
        }
        else
        {
            Enemies[i]->palette = 2;
        }
        return;
    }
    if(Enemies[i]->stats.hardtype) Enemies[i]->palette = 1;
    else Enemies[i]->palette = 0;

    Enemies[i]->display.draw_cnt ++;
    if(Enemies[i]->display.draw_cnt == 10) Enemies[i]->display.draw_cnt = 0;

    if(Enemies[i]->coord.orientation == RIGHT) Enemies[i]->display.rotation = 0;
    else if(Enemies[i]->coord.orientation == LEFT) Enemies[i]->display.rotation = 128;
    else if(Enemies[i]->coord.orientation == UP) Enemies[i]->display.rotation = 192;
    else if(Enemies[i]->coord.orientation == DOWN) Enemies[i]->display.rotation = 64;
    else if(Enemies[i]->coord.orientation == 5) Enemies[i]->display.rotation = 0;

    Enemies[i]->bound.lft = Enemies[i]->coord.x;
    Enemies[i]->bound.rgt = Enemies[i]->coord.x + 16;
    Enemies[i]->bound.top = Enemies[i]->coord.y;
    Enemies[i]->bound.bot = Enemies[i]->coord.y + 16;

    if(Enemies[i]->coord.orientation == 5)
    {
        if(Scan_Clips_X(Enemies[i]->bound.lft, Enemies[i]->bound.rgt, Enemies[i]->bound.bot+1, 0x02))
        {
            Enemies[i]->coord.orientation = RIGHT;
            Enemies[i]->coord.y ++;
            Enemies[i]->bound.lft = Enemies[i]->coord.x;
            Enemies[i]->bound.rgt = Enemies[i]->coord.x + 16;
            Enemies[i]->bound.top = Enemies[i]->coord.y;
            Enemies[i]->bound.bot = Enemies[i]->coord.y + 16;
        }
    }

    if(Enemies[i]->coord.orientation == RIGHT)
    {
        if(Enemies[i]->display.draw_cnt < 5) Enemies[i]->display.hflip = true;
        else if(Enemies[i]->display.draw_cnt < 10) Enemies[i]->display.hflip = false;
        Enemies[i]->display.vflip = false;

        if(!Scan_Clips_X(Enemies[i]->bound.lft, Enemies[i]->bound.rgt, Enemies[i]->bound.bot, 0x02))
        {
            Enemies[i]->coord.orientation = DOWN;
            Enemies[i]->coord.x --;
            Enemies[i]->coord.y ++;
        }
        else if(Scan_Clips_Y(Enemies[i]->bound.top+2, Enemies[i]->bound.bot-2, Enemies[i]->bound.rgt, 0x02)) //Geemer is touching a wall
        {
            Enemies[i]->coord.orientation = UP;
        }
        else
        {
            Enemies[i]->coord.x++;
        }
    }
    else if(Enemies[i]->coord.orientation == UP)
    {
        if(Enemies[i]->display.draw_cnt < 5) Enemies[i]->display.vflip = true;
        else if(Enemies[i]->display.draw_cnt < 10) Enemies[i]->display.vflip = false;
        Enemies[i]->display.hflip = false;

        if(!Scan_Clips_Y(Enemies[i]->bound.top, Enemies[i]->bound.bot, Enemies[i]->bound.rgt, 0x02))
        {
            Enemies[i]->coord.orientation = RIGHT;
            Enemies[i]->coord.y ++;
            Enemies[i]->coord.x ++;
        }
        else if(Scan_Clips_X(Enemies[i]->bound.lft+2, Enemies[i]->bound.rgt-2, Enemies[i]->bound.top, 0x02)) //Geemer is touching a ceiling
        {
            Enemies[i]->coord.orientation = LEFT;
        }
        else
        {
            Enemies[i]->coord.y--;
        }
    }
    else if(Enemies[i]->coord.orientation == DOWN)
    {
        if(Enemies[i]->display.draw_cnt < 5) Enemies[i]->display.vflip = true;
        else if(Enemies[i]->display.draw_cnt < 10) Enemies[i]->display.vflip = false;
        Enemies[i]->display.hflip = false;

        if(!Scan_Clips_Y(Enemies[i]->bound.top, Enemies[i]->bound.bot, Enemies[i]->bound.lft, 0x02))
        {
            Enemies[i]->coord.orientation = LEFT;
            Enemies[i]->coord.y --;
            Enemies[i]->coord.x --;
        }
        else if(Scan_Clips_X(Enemies[i]->bound.lft+2, Enemies[i]->bound.rgt-2, Enemies[i]->bound.bot, 0x02)) //Geemer is touching a floor
        {
            Enemies[i]->coord.orientation = RIGHT;
        }
        else
        {
            Enemies[i]->coord.y++;
        }
    }
    else if(Enemies[i]->coord.orientation == LEFT)
    {
        if(Enemies[i]->display.draw_cnt < 5) Enemies[i]->display.hflip = true;
        else if(Enemies[i]->display.draw_cnt < 10) Enemies[i]->display.hflip = false;
        Enemies[i]->display.vflip = false;

        if(!Scan_Clips_X(Enemies[i]->bound.lft, Enemies[i]->bound.rgt, Enemies[i]->bound.top, 0x02))
        {
            Enemies[i]->coord.orientation = UP;
            Enemies[i]->coord.x ++;
            Enemies[i]->coord.y --;
        }
        else if(Scan_Clips_Y(Enemies[i]->bound.top+2, Enemies[i]->bound.bot-2, Enemies[i]->bound.lft, 0x02)) //Geemer is touching a wall
        {
            Enemies[i]->coord.orientation = DOWN;
        }
        else
        {
            Enemies[i]->coord.x--;
        }
    }

    Enemies[i]->bound.lft = Enemies[i]->coord.x;
    Enemies[i]->bound.rgt = Enemies[i]->coord.x + 16;
    Enemies[i]->bound.top = Enemies[i]->coord.y;
    Enemies[i]->bound.bot = Enemies[i]->coord.y + 16;

    if(!Scan_Clips_X(Enemies[i]->bound.lft-1, Enemies[i]->bound.rgt+1, Enemies[i]->bound.top-1, 0x02) AND
       !Scan_Clips_X(Enemies[i]->bound.lft-1, Enemies[i]->bound.rgt+1, Enemies[i]->bound.bot+1, 0x02) AND
       !Scan_Clips_Y(Enemies[i]->bound.top-1, Enemies[i]->bound.bot+1, Enemies[i]->bound.lft-1, 0x02) AND
       !Scan_Clips_Y(Enemies[i]->bound.top-1, Enemies[i]->bound.bot+1, Enemies[i]->bound.rgt+1, 0x02))
    {
        Enemies[i]->coord.orientation = 5;
        Enemies[i]->coord.y ++;
    }

    Enemies[i]->display.update(i);
}

void Update_Geemer_GFX(int i)
{
    Enemies[i]->display.to_show = 0;
}

void Update_Nova_GFX(int i)
{
    if(Enemies[i]->display.draw_cnt % 5 < 2) Enemies[i]->display.to_show = 0;
    else Enemies[i]->display.to_show = 1;
}

void Update_Zeela_GFX(int i)
{
    Enemies[i]->display.to_show = 0;
}

void Update_Viola_GFX(int i)
{
    Enemies[i]->display.to_show = 0;
}

void Move_Enemy(int i, int xdist, int ydist)
{
    int emergency_counter = 100; //Prevent a crash from a bug
    while(emergency_counter AND (xdist OR ydist))
    {
        emergency_counter --;
        if(xdist > 0)
        {
            if(!Scan_Clips_Y(Enemies[i]->bound.top, Enemies[i]->bound.bot, Enemies[i]->bound.rgt+1, 0x02))
            {
                Enemies[i]->coord.x ++;
                Enemies[i]->bound.rgt ++;
                Enemies[i]->bound.lft ++;
                xdist --;
            }
            else xdist = 0;
        }
        else if(xdist < 0)
        {
            if(!Scan_Clips_Y(Enemies[i]->bound.top, Enemies[i]->bound.bot, Enemies[i]->bound.lft-1, 0x02))
            {
                Enemies[i]->coord.x --;
                Enemies[i]->bound.rgt --;
                Enemies[i]->bound.lft --;
                xdist ++;
            }
            else xdist = 0;
        }
        if(ydist > 0)
        {
            if(!Scan_Clips_X(Enemies[i]->bound.lft, Enemies[i]->bound.rgt, Enemies[i]->bound.bot+1, 0x02))
            {
                Enemies[i]->coord.y ++;
                Enemies[i]->bound.top ++;
                Enemies[i]->bound.bot ++;
                ydist --;
            }
            else ydist = 0;
        }
        else if(ydist < 0)
        {
            if(!Scan_Clips_X(Enemies[i]->bound.lft, Enemies[i]->bound.rgt, Enemies[i]->bound.top-1, 0x02))
            {
                Enemies[i]->coord.y --;
                Enemies[i]->bound.top --;
                Enemies[i]->bound.bot --;
                ydist ++;
            }
            else ydist = 0;
        }
    }
}

void Move_Enemy_Bounce(int i, int xdist, int ydist, unsigned char *xvar, unsigned char *yvar)
{
    int emergency_counter = 100; //Prevent a crash from a bug
    while(emergency_counter AND (xdist OR ydist))
    {
        emergency_counter --;
        if(xdist > 0)
        {
            if(!Scan_Clips_Y(Enemies[i]->bound.top, Enemies[i]->bound.bot, Enemies[i]->bound.rgt+1, 0x02))
            {
                Enemies[i]->coord.x ++;
                Enemies[i]->bound.rgt ++;
                Enemies[i]->bound.lft ++;
                xdist --;
            }
            else
            {
                xdist *= -1;
                *xvar = 0;
            }
        }
        else if(xdist < 0)
        {
            if(!Scan_Clips_Y(Enemies[i]->bound.top, Enemies[i]->bound.bot, Enemies[i]->bound.lft-1, 0x02))
            {
                Enemies[i]->coord.x --;
                Enemies[i]->bound.rgt --;
                Enemies[i]->bound.lft --;
                xdist ++;
            }

            else
            {
                xdist *= -1;
                *xvar = 1;
            }
        }
        if(ydist > 0)
        {
            if(!Scan_Clips_X(Enemies[i]->bound.lft, Enemies[i]->bound.rgt, Enemies[i]->bound.bot+1, 0x02))
            {
                Enemies[i]->coord.y ++;
                Enemies[i]->bound.top ++;
                Enemies[i]->bound.bot ++;
                ydist --;
            }
            else
            {
                ydist *= -1;
                *yvar = 0;
            }
        }
        else if(ydist < 0)
        {
            if(!Scan_Clips_X(Enemies[i]->bound.lft, Enemies[i]->bound.rgt, Enemies[i]->bound.top-1, 0x02))
            {
                Enemies[i]->coord.y --;
                Enemies[i]->bound.top --;
                Enemies[i]->bound.bot --;
                ydist ++;
            }
            else
            {
                ydist *= -1;
                *yvar = 1;
            }
        }
    }
}

