//Needles fired horizontally
void Create_Kraid_Needle(int x, int y, int facing)
{
    for(int i = 0; i < total_needles; i ++)
    {
        if(!Needles[i].active)
        {
            Place_Needle_In_Slot(i, x, y, facing);
            return;
        }
    }
    Needles = (KRAID_NEEDLE *)realloc(Needles, sizeof(KRAID_NEEDLE) * (total_needles + 1));

    Place_Needle_In_Slot(total_needles, x, y, facing);
    total_needles ++;
    return;
}

void Place_Needle_In_Slot(int i, int x, int y, int facing)
{
    Needles[i].active = true;
    Needles[i].x = x; 
    Needles[i].y = y;
    if(facing == LEFT) Needles[i].facing_left = true;
    else Needles[i].facing_left = false;
    Needles[i].destroy_timer = 30;
    Needles[i].launch_timer = 30;
    Needles[i].stuck_in_wall = false;
    Add_To_Target_List(TARGET_KRAID_NEEDLE, i);
}

void Update_Kraid_Needles()
{
    for(int i = 0; i < total_needles; i ++)
    {
        if(Needles[i].active)
        {
            Needles[i].dim.lft = (int)Needles[i].x;
            Needles[i].dim.top = (int)Needles[i].y;
            Needles[i].dim.rgt = (int)Needles[i].x+8;
            Needles[i].dim.bot = (int)Needles[i].y+3;
            if(!rect_clip(camera_max, Needles[i].dim))
            {
                Needles[i].active = false;
                Remove_From_Target_List(&Needles[i].health);
            }
            if(Needles[i].stuck_in_wall) //Has impacted a wall
            {
                Needles[i].destroy_timer --;
                if(Needles[i].destroy_timer < 1)
                {
                    Needles[i].active = false;
                }
            }
            else if(Needles[i].launch_timer > 0) //Waiting to fire
            {
                Needles[i].launch_timer --;
                if(Needles[i].facing_left)
                {
                    Needles[i].x = Kraid.dim.lft-3;
                }
                else
                {
                    Needles[i].x = Kraid.dim.rgt-5;
                }
            }
            else //Flying
            {
                if(!samvar.invincible_timer AND samvar.screw_attack_active == -1 AND rect_clip(samvar.dim, Needles[i].dim))
                {
                    Injure_Samus(Kraid.damage);
                }
                if(Needles[i].facing_left)
                {
                    Needles[i].x -= 1.5;
                    if(Scan_Clips_Y(Needles[i].y, Needles[i].y+3, Needles[i].x, STOP_SAMUS))
                    {
                        Needles[i].stuck_in_wall = true;
                    }
                }
                else
                {
                    Needles[i].x += 1.5;
                    if(Scan_Clips_Y(Needles[i].y, Needles[i].y+3, Needles[i].x+8, STOP_SAMUS))
                    {
                        Needles[i].stuck_in_wall = true;
                    }
                }
            }
        }
    }
}

//Hooks that fire in an upwards arc
void Create_Kraid_Hook(int x, int y, int facing)
{
    for(int i = 0; i < total_hooks; i ++)
    {
        if(!Hooks[i].active)
        {
            Place_Hook_In_Slot(i, x, y, facing);
            return;
        }
    }
    Hooks = (KRAID_HOOK *)realloc(Hooks, sizeof(KRAID_HOOK) * (total_hooks + 1));

    Place_Hook_In_Slot(total_hooks, x, y, facing);
    total_hooks ++;
    return;
}

void Place_Hook_In_Slot(int i, int x, int y, int facing)
{
    Hooks[i].active = true;
    Hooks[i].x = x; 
    Hooks[i].y = y;
    Hooks[i].health = 1;
    if(facing == LEFT)
    {
        Hooks[i].xspeed = -1.0;
        Hooks[i].xforce = -0.25;
    }
    else
    {
        Hooks[i].xspeed = 1.0;
        Hooks[i].xforce = 0.25;
    }
    Hooks[i].yspeed = -5.0;
    Hooks[i].yforce = 0.25;
    Hooks[i].timer = 30;
    Add_To_Target_List(TARGET_KRAID_HOOK, i);
}

void Update_Kraid_Hooks()
{
    for(int i = 0; i < total_hooks; i ++)
    {
        if(Hooks[i].active)
        {
            Hooks[i].dim.lft = (int)Hooks[i].x;
            Hooks[i].dim.top = (int)Hooks[i].y;
            Hooks[i].dim.rgt = (int)Hooks[i].x+8;
            Hooks[i].dim.bot = (int)Hooks[i].y+8;
            if(!rect_clip(camera_max, Hooks[i].dim))
            {
                Hooks[i].active = false;
                Remove_From_Target_List(&Hooks[i].health);
            }
            if(Hooks[i].timer > 0) //Waiting to fire
            {
                Hooks[i].timer --;
                if(Hooks[i].xspeed > 0)
                {
                    Hooks[i].x = Kraid.dim.lft-3;
                }
                else
                {
                    Hooks[i].x = Kraid.dim.rgt-5;
                }
            }
            else //Flying
            {
                if(!samvar.invincible_timer AND samvar.screw_attack_active == -1 AND rect_clip(samvar.dim, Hooks[i].dim))
                {
                    Injure_Samus(Kraid.damage);
                }
                Hooks[i].x += Hooks[i].xspeed;
                Hooks[i].y += Hooks[i].yspeed;
                Hooks[i].xspeed += Hooks[i].xforce;
                Hooks[i].yspeed += Hooks[i].yforce;
                if(Hooks[i].xspeed < -2) Hooks[i].xspeed = -2;
                if(Hooks[i].xspeed > 2) Hooks[i].xspeed = 2;
                if(Hooks[i].yspeed > 3) Hooks[i].yspeed = 3;
                if(Hooks[i].xspeed > 0)
                {
                    Hooks[i].angle += itofix(4);
                    if(Hooks[i].angle > itofix(128)) Hooks[i].angle -= itofix(128);
                }
                else
                {
                    Hooks[i].angle -= itofix(4);
                    if(Hooks[i].angle < itofix(0)) Hooks[i].angle += itofix(128);
                }
            }
        }
    }
}

void Draw_Kraid_Support(BITMAP *output)
{
    for(int i = 0; i < total_needles; i ++)
    {
        if(Needles[i].active)
        {
            if(Needles[i].facing_left) draw_sprite_h_flip_palette(output, Kraid.needle_img, Needles[i].x-camera.lft, Needles[i].y-camera.top, 0);
            else draw_sprite_palette(output, Kraid.needle_img, Needles[i].x-camera.lft, Needles[i].y-camera.top, 0);
        }
    }
    for(int i = 0; i < total_hooks; i ++)
    {
        if(Hooks[i].active)
        {
            rotate_sprite_palette(output, Kraid.hook_img, Hooks[i].x-camera.lft, Hooks[i].y-camera.top, 0, Hooks[i].angle);
            if(samvar.draw_collision) rect(output, Hooks[i].dim.lft-camera.lft, Hooks[i].dim.top-camera.top, Hooks[i].dim.rgt-camera.lft, Hooks[i].dim.bot-camera.top, makecol(0, 128, 0));
        }
    }
}
