void Create_Simple_Level() //Creates a simple 16x16 level, for testing
{
    Room = (ROOM *)calloc(1, sizeof(ROOM));
    Room->xsize = 32;
    Room->ysize = 16;

    camera_max.lft = 0;
    camera_max.top = 0;
    camera_max.rgt = Room->xsize * 16;
    camera_max.bot = Room->ysize * 16;

    //Create the physical clipping array
    cliparray = (unsigned char **)calloc(Room->xsize * 16, sizeof(unsigned char *));
    for(int i = 0; i < Room->xsize * 16; i ++)
    {
        cliparray[i] = (unsigned char *)calloc(Room->ysize * 16, sizeof(unsigned char));
    }
    printf("1");

    //Create the tiles array
    Room->tiles = (int **)malloc(Room->xsize * sizeof(int *));
    for(int i = 0; i < Room->xsize; i ++) Room->tiles[i] = (int *)malloc(Room->ysize * sizeof(int));
    printf("2");

    //Create the clips array
    Room->clips = (int **)malloc(Room->xsize * sizeof(int *));
    for(int i = 0; i < Room->xsize; i ++) Room->clips[i] = (int *)malloc(Room->ysize * sizeof(int));
    printf("3\n");

    for(int x = 0; x < Room->xsize; x ++)
    {
        for(int y = 0; y < Room->ysize; y ++)
        {
            Room->tiles[x][y] = 0;
        }
    }

    //Set the tiles
    for(int x = 0; x < Room->xsize; x ++)
    {
        Room->tiles[x][0] =  1;
        Room->clips[x][0] =  1;
        Room->tiles[x][Room->ysize-1] = 1;
        Room->clips[x][Room->ysize-1] = 1;
    }
    for(int y = 0; y < Room->ysize; y ++)
    {
        Room->tiles[0][y] =  1;
        Room->clips[0][y] =  1;
        Room->tiles[Room->xsize-1][y] = 1;
        Room->clips[Room->xsize-1][y] = 1;
    }
    printf("4");
    //Room->tiles[14][14] = 1;
    //Room->clips[14][14] = 1;

    //Create_Door("Door1", 224, 176, LEFT);

    Create_Clips(Room->xsize, Room->ysize, Room->clips);
}

void Read_Level(char name[], ROOM **LoadRoom)
{
    if(campaign_mode AND !random_game)
    {
        Load_Level_From_Campaign(name, LoadRoom);
        return;
    }
    if(name[strlen(name)-4] != '.')
    {
        strcat(name, ".mcl");
    }
    int p = 0;
    printf("Read_Level: %s\n", name);
    FILE *input = NULL;
    input = fopen(name, "rb");

    if(curlev_name) free(curlev_name);
    curlev_name = (char *)malloc(sizeof(char) * (strlen(name)+1));
    Init_String(curlev_name, name, strlen(name));
    String_Shift(curlev_name, 6);
    curlev_len = strlen(name) + 1 - 6 - 4;
    curlev_name[Char_Search(curlev_name, '.')] = 0;

    bool first_music_set = false;
    if(Cur_Music == NULL) first_music_set = true;
    if(!strncmp("BrinRe", curlev_name, 6))
    {
        Curmap = Maps[0];
        if(Cur_Music == NULL) Cur_Music = &Audio.Red_Brinstar_Music;
        cur_palette = 3;
    }
    else if(!strncmp("Bri", curlev_name, 3))
    {
        Curmap = Maps[1];
        if(Cur_Music == NULL) Cur_Music = &Audio.Brinstar_Music;
        cur_palette = 0;
    }
    else if(!strncmp("Kra", curlev_name, 3))
    {
        Curmap = Maps[2];
        if(Cur_Music == NULL) Cur_Music = &Audio.Kraid_Music;
    }
    else if(!strncmp("Tou", curlev_name, 3))
    {
        Curmap = Maps[3];
        if(Cur_Music == NULL) Cur_Music = &Audio.Tourian_Music;
    }
    else if(!strncmp("Nor", curlev_name, 3))
    {
        Curmap = Maps[4];
        if(Cur_Music == NULL) Cur_Music = &Audio.Norfair_Music;
    }
    else if(!strncmp("Rid", curlev_name, 3))
    {
        Curmap = Maps[5];
        if(Cur_Music == NULL) Cur_Music = &Audio.Ridley_Music;
    }
    else
    {
        Curmap = Maps[1];
        if(Cur_Music == NULL) Cur_Music = &Audio.Brinstar_Music;
    }
    New_Music = Cur_Music;

    if(input)
    {
        *LoadRoom = (ROOM *)calloc(1, sizeof(ROOM));

        char inbyte[5];
        //Seek through the Version data
        fread(inbyte, sizeof(char), 4, input);
        inbyte[4] = 0;
        printf("Level version: %s\n", inbyte);
        if(strncasecmp(inbyte, "V1.3\0", 5))
        {
            printf("--- WARNING:  ILLEGAL LEVEL VERSION/FILE, ABORTING ---\n");
            fclose(input);
            Create_Simple_Level();
            return;
        }
        p ++;

        //Read the posinfo data
        //for(int i = 0; i < 10; i ++) fread(&inbyte, sizeof(int), 1, input);
        fread((*LoadRoom)->posinfo, sizeof(int), 7, input);
        p ++;

        //Read the level's x/y data
        fread(&(*LoadRoom)->xsize, sizeof(int), 1, input);
        fread(&(*LoadRoom)->ysize, sizeof(int), 1, input);
        fread(&(*LoadRoom)->xpos, sizeof(int), 1, input);
        fread(&(*LoadRoom)->ypos, sizeof(int), 1, input);
        p ++;

        camera_max.lft = 0;
        camera_max.top = 0;
        camera_max.rgt = Room->xsize * 16;
        camera_max.bot = Room->ysize * 16;

        //Create the physical clipping array
        cliparray = (unsigned char **)calloc((*LoadRoom)->xsize * 16, sizeof(unsigned char *));
        for(int i = 0; i < (*LoadRoom)->xsize * 16; i ++)
        {
            cliparray[i] = (unsigned char *)calloc((*LoadRoom)->ysize * 16, sizeof(unsigned char));
        }

        //Create the tiles array
        (*LoadRoom)->tiles = (int **)malloc((*LoadRoom)->xsize * sizeof(int *));
        for(int i = 0; i < (*LoadRoom)->xsize; i ++) (*LoadRoom)->tiles[i] = (int *)malloc((*LoadRoom)->ysize * sizeof(int));

        //Create the clips array
        (*LoadRoom)->clips = (int **)malloc((*LoadRoom)->xsize * sizeof(int *));
        for(int i = 0; i < (*LoadRoom)->xsize; i ++) (*LoadRoom)->clips[i] = (int *)malloc((*LoadRoom)->ysize * sizeof(int));

        //Tiles data
        for(int y = 0; y < (*LoadRoom)->ysize; y ++)
        {
            for(int x = 0; x < (*LoadRoom)->xsize; x ++)
            {
                fread(&(*LoadRoom)->tiles[x][y], sizeof(int), 1, input);
            }
        }
        //Clips Data
        for(int y = 0; y < (*LoadRoom)->ysize; y ++)
        {
            for(int x = 0; x < (*LoadRoom)->xsize; x ++)
            {
                fread(&(*LoadRoom)->clips[x][y], sizeof(int), 1, input);
                if((*LoadRoom)->tiles[x][y] == 64 OR (*LoadRoom)->tiles[x][y] == 65 OR (*LoadRoom)->tiles[x][y] == 66 OR (*LoadRoom)->tiles[x][y] == 70)
                {
                    (*LoadRoom)->clips[x][y] = 2;
                }
            }
        }

        printf("\nPosinfo: ");
        for(int i = 0; i < 7; i ++)
        {
            printf("%i ", (*LoadRoom)->posinfo[i]);
        }
        printf("\n");

        if((*LoadRoom)->posinfo[3]) //Load elevators data
        {
            ; //Don't do shit
        }

        //Reset the water values
        water_ent_a_lft = -1;
        water_ent_a_top = -1;
        water_ent_a_rgt = -1;
        water_ent_a_bot = -1;
        water_ent_b_lft = -1;
        water_ent_b_top = -1;
        water_ent_b_rgt = -1;
        water_ent_b_bot = -1;
        water_ent_c_lft = -1;
        water_ent_c_top = -1;
        water_ent_c_rgt = -1;
        water_ent_c_bot = -1;

        if((*LoadRoom)->posinfo[5]) //Load object data
        {
            int tempvar = 0;
            int tempx, tempy, temptype;

            fseek(input, (*LoadRoom)->posinfo[5], SEEK_SET);
            fread(&tempvar, sizeof(int), 1, input);
            for(int i = 0; i < tempvar; i ++)
            {
                fread(&temptype, sizeof(int), 1, input);
                fread(&tempx, sizeof(int), 1, input);
                fread(&tempy, sizeof(int), 1, input);
                if(temptype < 17)
                {
                    int l = Create_Item(tempx*16, tempy*16, temptype, "BLANK", i);
                    if((*LoadRoom)->tiles[tempx][tempy] > 0)
                    {
                        int o = Create_Breakable(tempx, tempy, 240, 0, false, (*LoadRoom)->tiles[tempx][tempy]-1);
                        (*LoadRoom)->tiles[tempx][tempy] = 0;
                        Hook_Item_To_Breakable(l, o);
                    }
                }
                else if(temptype == 19)
                {
                    Create_Breakable(tempx, tempy, 240, 0, false, (*LoadRoom)->tiles[tempx][tempy]-1);
                    (*LoadRoom)->tiles[tempx][tempy] = 0;
                }
                else if(temptype == 20) Create_Geemer(tempx*16, tempy*16, false, 0);
                else if(temptype == 21) Create_Reo(tempx*16, tempy*16, false);
                else if(temptype == 22) Create_Ripper(tempx*16, tempy*16, false, 0);
                else if(temptype == 23) Create_Shriekbat(tempx*16, tempy*16, false);
                else if(temptype == 24) Create_Waver(tempx*16, tempy*16, false);
                else if(temptype == 25) Create_Geruta(tempx*16, tempy*16, false, 0);
                else if(temptype == 26) Create_Sidehopper(tempx*16, tempy*16, false, 0);
                else if(temptype == 27 AND use_Samstart_this_push) Create_Samstart(tempx*16, (tempy*16)+1);
                else if(temptype == 28) (*LoadRoom)->clips[tempx][tempy] = 0;
                else if(temptype == 29) Create_Firehorse(tempx*16, tempy*16, false);
                else if(temptype == 30)
                {
                    if(!strncmp(curlev_name, "BrinRe", 6)) New_Music = &Audio.Red_Brinstar_Music;
                    else New_Music = &Audio.Brinstar_Music;
                }
                else if(temptype == 31) New_Music = &Audio.Norfair_Music;
                else if(temptype == 32) New_Music = &Audio.Ridley_Music;
                else if(temptype == 33) New_Music = &Audio.Kraid_Music;
                else if(temptype == 34) New_Music = &Audio.Tourian_Music;
                else if(temptype == 35) New_Music = &Audio.Item_Music;
                else if(temptype == 36) Create_Geruta(tempx*16, tempy*16, false, 1);
                else if(temptype == 37) Create_Multiviola(tempx*16, tempy*16, false);
                else if(temptype == 38) Create_Squeept(tempx*16, tempy*16, false);
                else if(temptype == 39)
                {
                    rinka_flag = true;
                    Create_Enemy_Spawner(tempx*16+8, tempy*16, false, 0, rnd(50, 50), false, 50);
                }
                else if(temptype == 40) Create_Geemer(tempx*16, tempy*16, false, 1);
                else if(temptype == 41) Create_Geemer(tempx*16, tempy*16, false, 2);
                else if(temptype == 42) Create_Geemer(tempx*16, tempy*16, false, 3);
                else if(temptype == 43) Create_Ripper(tempx*16, tempy*16, false, 1);
                else if(temptype == 44) Create_Sidehopper(tempx*16, tempy*16, false, 1);
                else if(temptype == 45) Create_Enemy_Spawner(tempx*16+8, tempy*16, false, 0, 250, false, 100);
                else if(temptype == 46) Create_Enemy_Spawner(tempx*16+8, tempy*16, false, 1, 250, false, 100);
                else if(temptype == 47) Create_Enemy_Spawner(tempx*16+8, tempy*16, false, 2, 250, false, 100);
                else if(temptype == 48) Create_Enemy_Spawner(tempx*16+8, tempy*16, false, 3, 250, false, 100);
                else if(temptype == 49) Create_Metroid(tempx*16, tempy*16, false);
                else if(temptype == 50) Create_Save_Zone(tempx*16, tempy*16-8, tempx*16+16, tempy*16+16);
                else if(temptype == 51) Create_Minigun(tempx*16, tempy*16, 0);
                else if(temptype == 52) Create_Minigun(tempx*16, tempy*16, 1);
                else if(temptype == 53) Create_Minigun(tempx*16, tempy*16, 2);
                else if(temptype == 54)
                {
                    water_ent_a_lft = tempx*16;
                    water_ent_a_top = tempy*16 + 8;
                }
                else if(temptype == 55)
                {
                    water_ent_a_rgt = tempx*16 + 16;
                    water_ent_a_bot = tempy*16 + 16;
                }
                else if(temptype == 56)
                {
                    water_ent_b_lft = tempx*16;
                    water_ent_b_top = tempy*16 + 8;
                }
                else if(temptype == 57)
                {
                    water_ent_b_rgt = tempx*16 + 16;
                    water_ent_b_bot = tempy*16 + 16;
                }
                else if(temptype == 58)
                {
                    water_ent_c_lft = tempx*16;
                    water_ent_c_top = tempy*16 + 8;
                }
                else if(temptype == 59)
                {
                    water_ent_c_rgt = tempx*16 + 16;
                    water_ent_c_bot = tempy*16 + 16;
                }
                else if(temptype == 60)
                {
                    Create_Zebetite(tempx*16, tempy*16, tempx*16+16, tempy*16+32, 160);
                }
                else if(temptype == 61)
                {
                    if(!samvar.kraid_dead AND !Kraid.active) Init_Kraid(tempx, tempy, false);
                }
                else if(temptype == 62)
                {
                    if(!Kraid.active) Init_Kraid(tempx, tempy, true);
                }
                else if(temptype == 63)
                {
                    if(!samvar.ridley_dead AND !Ridley.active) Init_Ridley(tempx, tempy);
                }
            }
        }
        if(escape_audio)
        {
            Cur_Music = &Audio.Escape_Music;
        }
        else if(first_music_set)
        {
            Cur_Music = New_Music;
        }

        use_Samstart_this_push = false;
        Clear_Collected_Items();
        if(water_ent_a_lft != -1 AND water_ent_a_rgt != -1)
        {
            Create_Water_Zones(water_ent_a_lft, water_ent_a_top, water_ent_a_rgt, water_ent_a_bot, 1);
        }
        if(water_ent_b_lft != -1 AND water_ent_b_rgt != -1)
        {
            Create_Water_Zones(water_ent_b_lft, water_ent_b_top, water_ent_b_rgt, water_ent_b_bot, 1);
        }
        if(water_ent_c_lft != -1 AND water_ent_c_rgt != -1)
        {
            Create_Water_Zones(water_ent_c_lft, water_ent_c_top, water_ent_c_rgt, water_ent_c_bot, 0);
        }
        printf("Water done\n");

        Create_Clips((*LoadRoom)->xsize, (*LoadRoom)->ysize, (*LoadRoom)->clips);
        printf("Clips done\n");

        //Doors
        if((*LoadRoom)->posinfo[4])
        {
            int tempvar = 0;
            char tempname[11];
            char temproomto[11];
            char finalroomto[80];
            char tempdoorto[11];
            int tempx, tempy, tempfacing;
            int tempflags = 0;
            tempname[10] = 0;
            temproomto[10] = 0;
            tempdoorto[10] = 0;

            fseek(input, (*LoadRoom)->posinfo[4], SEEK_SET);
            fread(&tempvar, sizeof(int), 1, input);
            for(int i = 0; i < tempvar; i ++)
            {
                Init_String(finalroomto, ROOMS, 80);
                fread(tempname  , sizeof(char), 10, input);
                fread(temproomto, sizeof(char), 10, input);
                fread(tempdoorto, sizeof(char), 10, input);
                fread(&tempx, sizeof(int), 1, input);
                fread(&tempy, sizeof(int), 1, input);
                fread(&tempfacing, sizeof(int), 1, input);
                fread(&tempflags, sizeof(int), 1, input);
                strcat(finalroomto, temproomto);
                strcat(finalroomto, ".mcl");
                if(tempfacing == LEFT)
                {
                    Create_Door(tempname, (tempx*16)+8, tempy*16, tempfacing);
                    Create_Transition_Zone(tempname, tempname, (tempx*16)+24, tempy*16, (tempx*16)+32, (tempy*16)+48, RIGHT, finalroomto, tempdoorto);
                }
                else if(tempfacing == RIGHT)
                {
                    Create_Door(tempname, tempx*16, tempy*16, tempfacing);
                    Create_Transition_Zone(tempname, tempname, (tempx*16)-16, tempy*16, (tempx*16)-8, (tempy*16)+48, LEFT, finalroomto, tempdoorto);
                }
                else if(tempfacing == UP)
                {
                    Create_Elevator(tempx, tempy, UP, finalroomto);
                }
                else if(tempfacing == DOWN)
                {
                    Create_Elevator(tempx, tempy, DOWN, finalroomto);
                }
            }
            Neutralize_Opened_Doors();
        }
        printf("Doors done\n");

        //Cambounds
        if((*LoadRoom)->posinfo[6])
        {
            fseek(input, (*LoadRoom)->posinfo[6], SEEK_SET);
            int cambounds_found = 0;
            fread(&cambounds_found, sizeof(int), 1, input);
            for(int i = 0; i < cambounds_found; i ++)
            {
                int lftvar, topvar, rgtvar, botvar, flagvar;
                fread(&topvar, sizeof(int), 1, input);
                fread(&rgtvar, sizeof(int), 1, input);
                fread(&botvar, sizeof(int), 1, input);
                fread(&lftvar, sizeof(int), 1, input);
                fread(&flagvar, sizeof(int), 1, input);
                Create_Cambound(lftvar*16, topvar*16, (rgtvar*16)+16, (botvar*16)+16, flagvar);
            }
        }
        printf("Cambounds done\n");

        fclose(input);
        printf("Level loaded successfully\n");
        Apply_Special_Features_To_Level();
        printf("Special features applied\n");
    }
    else
    {
        printf("--- WARNING:  ILLEGAL LEVEL NAME, AVERTING ROOM CREATED\n");
        LoadRoom = NULL;
        Create_Simple_Level();
    }
    printf("Exiting room loading routine\n");
}

void Load_Level_From_Campaign(char name[], ROOM **LoadRoom)
{
    /*printf("Loading level %s from campaign\n", name);
    int useflag = -1;
    for(int i = 0; i < Campaign->total_rooms; i ++)
    {
        if(!strcmp(Campaign->room_names[i], name))
        {
            useflag = i;
            i = Campaign->total_rooms;
        }
    }

    FILE *infile = fopen(Get_Cvar_Value_C("campaign"), "rb");

    if(useflag != -1)
    {
        fseek(infile, Campaign->room_pos_info[useflag], SEEK_SET);
    }
    else
    {
        printf("Level was not found in the campaign file, aborting\n");
        fclose(infile);
        Create_Simple_Level();
        return;
    }

    if(curlev_name) free(curlev_name);
    curlev_name = (char *)malloc(sizeof(char) * (strlen(name) + 1));
    Init_String(curlev_name, name, 0);
    curlev_len = strlen(name) + 1;

    *LoadRoom = (ROOM *)calloc(1, sizeof(ROOM));

    //Skip the room name
    fseek(infile, strlen(Campaign->room_names[useflag])+1, SEEK_CUR);

    //Read the posinfo data
    fread((*LoadRoom)->posinfo, sizeof(int), 10, infile);

    //Read the level's x/y data
    fread(&(*LoadRoom)->xsize, sizeof(int), 1, infile);
    fread(&(*LoadRoom)->ysize, sizeof(int), 1, infile);
    fread(&(*LoadRoom)->xpos, sizeof(int), 1, infile);
    fread(&(*LoadRoom)->ypos, sizeof(int), 1, infile);

    camera_max.lft = 0;
    camera_max.top = 0;
    camera_max.rgt = Room->xsize * 16;
    camera_max.bot = Room->ysize * 16;

    //Create the physical clipping array
    cliparray = (unsigned char **)calloc((*LoadRoom)->xsize * 16, sizeof(unsigned char *));
    for(int i = 0; i < (*LoadRoom)->xsize * 16; i ++)
    {
        cliparray[i] = (unsigned char *)calloc((*LoadRoom)->ysize * 16, sizeof(unsigned char));
    }

    //Create the tiles array
    (*LoadRoom)->tiles = (int **)malloc((*LoadRoom)->xsize * sizeof(int *));
    for(int i = 0; i < (*LoadRoom)->xsize; i ++) (*LoadRoom)->tiles[i] = (int *)malloc((*LoadRoom)->ysize * sizeof(int));

    //Create the clips array
    (*LoadRoom)->clips = (int **)malloc((*LoadRoom)->xsize * sizeof(int *));
    for(int i = 0; i < (*LoadRoom)->xsize; i ++) (*LoadRoom)->clips[i] = (int *)malloc((*LoadRoom)->ysize * sizeof(int));

    //Tiles data
    for(int x = 0; x < (*LoadRoom)->xsize; x ++)
    {
        for(int y = 0; y < (*LoadRoom)->ysize; y ++)
        {
            fread(&(*LoadRoom)->tiles[x][y], sizeof(int), 1, infile);
        }
    }

    //Clips Data
    for(int x = 0; x < (*LoadRoom)->xsize; x ++)
    {
        for(int y = 0; y < (*LoadRoom)->ysize; y ++)
        {
            fread(&(*LoadRoom)->clips[x][y], sizeof(int), 1, infile);
            if((*LoadRoom)->tiles[x][y] >= 64)
            {
                (*LoadRoom)->clips[x][y] = 0;
                (*LoadRoom)->tiles[x][y] = 0;
            }
        }
    }

    Create_Clips((*LoadRoom)->xsize, (*LoadRoom)->ysize, (*LoadRoom)->clips);

    printf("\nPosinfo: ");
    for(int i = 0; i < 10; i ++)
    {
        printf("%i ", (*LoadRoom)->posinfo[i]);
    }
    printf("\n");

    if((*LoadRoom)->posinfo[3]) //Load elevators data
    {
        ;
    }
    else
    {
        printf("No elevator data found in this room\n");
    }
    /////////////////////////////////////////////////////
    // Makeshift Elevators stuff                       //
    if(!strcmp(name, "Tour00"))
    {
        Create_Elevator(112/16, 128/16, UP, "Brin06");
    }
    if(!strcmp(name, "Brin06"))
    {
        Create_Elevator(112/16, 144/16, DOWN, "Tour00");
    }

    if((*LoadRoom)->posinfo[4]) //Load doors data
    {
        printf("Reading door data... \n");
        int tempvar = 0;
        char tempname[11];
        char temproomto[11];
        char finalroomto[80];
        char tempdoorto[11];
        int tempx, tempy, tempfacing, temproperties;
        tempname[10] = 0;
        temproomto[10] = 0;
        tempdoorto[10] = 0;

        fseek(infile, (*LoadRoom)->posinfo[4], SEEK_SET);
        fread(&tempvar, sizeof(int), 1, infile);
        printf("Doors: %i at position %i\n", tempvar, (*LoadRoom)->posinfo[4]);
        for(int i = 0; i < tempvar; i ++)
        {
            Init_String(finalroomto, "", 80);
            fread(tempname  , sizeof(char), 10, infile);
            fread(temproomto, sizeof(char), 10, infile);
            fread(tempdoorto, sizeof(char), 10, infile);
            fread(&tempx, sizeof(int), 1, infile);
            fread(&tempy, sizeof(int), 1, infile);
            fread(&tempfacing, sizeof(int), 1, infile);
            fread(&temproperties, sizeof(int), 1, infile);
            strcat(finalroomto, temproomto);
            if(tempfacing == LEFT)
            {
                Create_Door(tempname, (tempx*16)+8, tempy*16, tempfacing);
                Create_Transition_Zone(tempname, tempname, (tempx*16)+24, tempy*16, (tempx*16)+32, (tempy*16)+48, RIGHT, finalroomto, tempdoorto);
            }
            else if(tempfacing == RIGHT)
            {
                Create_Door(tempname, tempx*16, tempy*16, tempfacing);
                Create_Transition_Zone(tempname, tempname, (tempx*16)-16, tempy*16, (tempx*16)-8, (tempy*16)+48, LEFT, finalroomto, tempdoorto);
            }
            else if(tempfacing == DOWN)
            {
            }
            else if(tempfacing == UP)
            {
            }
        }
        Neutralize_Opened_Doors();
        printf("Door data read successfully\n");
    }
    else
    {
        printf("No door data found in this room\n");
    }
    Apply_Special_Features_To_Level();

    fclose(infile);*/
}

void Apply_Special_Features_To_Level()
{
    if(!strcmp(curlev_name, "Tour05"))
    {
        New_Music = &Audio.Escape_Music;
    }

    if(!strncmp(curlev_name, "Dep", 3))
    {
        Curmap = Maps[6];
    }
    /*if(!strcmp(curlev_name, "Brin04"))
    {
        for(int i = 0; i < total_doors; i ++)
        {
            if(!strcmp(Transitions[i].name, "Brin04D01"))
            {
                if(!samvar.kraid_dead AND !samvar.ridley_dead)
                {
                    Transitions[i].roomto[12] = 'a';
                }
                else if(samvar.kraid_dead AND !samvar.ridley_dead)
                {
                    Transitions[i].roomto[12] = 'b';
                }
                else if(!samvar.kraid_dead AND samvar.ridley_dead)
                {
                    Transitions[i].roomto[12] = 'c';
                }
                else if(samvar.kraid_dead AND samvar.ridley_dead)
                {
                    Transitions[i].roomto[12] = 'd';
                }
            }
        }
    }*/

    /*if(!strcmp(curlev_name, "Ridl17"))
    {
        if(!samvar.ridley_dead) Init_Ridley();
    }
    else
    {
        Ridley.active = false;
    }*/
    /*if(!strcmp(curlev_name, "Kraid18"))
    {
        if(!samvar.kraid_dead) Init_Kraid();
    }
    else
    {
        Kraid.active = false;
    }*/
    if(!strcmp(curlev_name, "Tour04"))
    {
        Init_Mother_Brain();
    }
    else
    {
        Mbrain.active = false;
    }
}
