MCI_FILE *Open_MCI_File(char path[])
{
    MCI_FILE *Mci_File;
    FILE *infile = fopen(path, "rb");
    if(!infile) return NULL;

    Mci_File = (MCI_FILE *)malloc(sizeof(MCI_FILE));

    //Consider the file info to be identical
    fread(Mci_File->version_info, sizeof(char), 20, infile);
    printf("Loaded %s, %s\n", path, Mci_File->version_info);
    fread(&Mci_File->total_images, sizeof(int), 1, infile);
    printf("There are %i images in this file\n", Mci_File->total_images);

    Mci_File->image_index = (INDEX *)malloc(sizeof(INDEX) * Mci_File->total_images);
    int c;
    char inchar = -1;
    char tempstring[257];
    for(int i = 0; i < Mci_File->total_images; i ++)
    {
        strclr(tempstring, 256);
        c = 0;
        fread(&inchar, sizeof(char), 1, infile);
        while(inchar != 0)
        {
            tempstring[c] = inchar;
            c ++; if (c>256) printf("*ALERT* %i>256\n", c);
            fread(&inchar, sizeof(char), 1, infile);
        }
        tempstring[c] = inchar;
        Mci_File->image_index[i].name = (char *)malloc(sizeof(char) * (strlen(tempstring)+1));
        Init_String(Mci_File->image_index[i].name, tempstring, strlen(tempstring));
        fread(&Mci_File->image_index[i].position, sizeof(int), 1, infile);
        //printf("Image Name: %s  Position: %i\n", Mci_File->image_index[i].name, Mci_File->image_index[i].position);
    }
    fclose(infile);
    printf("Mci file opened!\n");
    return Mci_File;
}

/*CUSTOM_IMAGE *Create_Image_From_MCI(FILE *input_mci, int *ctr, bool increase)
{
    CUSTOM_IMAGE *NewImg = (CUSTOM_IMAGE *)malloc(sizeof(CUSTOM_IMAGE));

    //Get size
    fread(&NewImg->xsize, sizeof(int), 1, input_mci);
    fread(&NewImg->ysize, sizeof(int), 1, input_mci);
    fread(&NewImg->palettes, sizeof(int), 1, input_mci);
    fread(&NewImg->colors, sizeof(int), 1, input_mci);

    //Allocate space
    NewImg->image = (char **)malloc(sizeof(char *) * NewImg->xsize);
    for(int q = 0; q < NewImg->xsize; q ++)
    {
        NewImg->image[q] = (char *)malloc(sizeof(char) * NewImg->ysize);
    }
    NewImg->values = (int **)malloc(sizeof(int *) * NewImg->palettes);
    for(int q = 0; q < NewImg->palettes; q ++)
    {
        NewImg->values[q] = (int *)malloc(sizeof(int) * NewImg->colors);
    }

    //Fill the space
    for(int y = 0; y < NewImg->ysize; y ++)
    {
        for(int x = 0; x < NewImg->xsize; x ++)
        {
            fread(&NewImg->image[x][y], sizeof(char), 1, input_mci);
        }
    }
    for(int y = 0; y < NewImg->colors; y ++)
    {
        for(int x = 0; x < NewImg->palettes; x ++)
        {
            fread(&NewImg->values[x][y], sizeof(int), 1, input_mci);
        }
    }
    if(increase) (*ctr) = (*ctr) + 1;
    return NewImg;
}*/

CUSTOM_IMAGE *Create_Image_From_MCI(MCI_FILE *Mci_File, char name[], int flip_flag)
{
    int indexspot_img = -1;
    CUSTOM_IMAGE *NewImg = (CUSTOM_IMAGE *)malloc(sizeof(CUSTOM_IMAGE));
    for(int i = 0; i < Mci_File->total_images; i ++)
    {
        if(!strcasecmp(Mci_File->image_index[i].name, name))
        {
            indexspot_img = i;
        }
    }
    if(indexspot_img == -1) return NULL; //Name wasn't found

    FILE *infile = fopen(IMAGES"Images.mci", "rb");
    if(!infile)
    {
        printf("Failed to locate Images.mci, aborting program\n");
        exit(1);
    }
    fseek(infile, Mci_File->image_index[indexspot_img].position, SEEK_SET);
    
    //Get size
    fread(&NewImg->xsize, sizeof(int), 1, infile);
    fread(&NewImg->ysize, sizeof(int), 1, infile);
    fread(&NewImg->palettes, sizeof(int), 1, infile);
    fread(&NewImg->colors, sizeof(int), 1, infile);

    //Allocate space
    NewImg->image = (char **)malloc(sizeof(char *) * NewImg->xsize);
    for(int q = 0; q < NewImg->xsize; q ++)
    {
        NewImg->image[q] = (char *)malloc(sizeof(char) * NewImg->ysize);
    }
    NewImg->values = (int **)malloc(sizeof(int *) * NewImg->palettes);
    for(int q = 0; q < NewImg->palettes; q ++)
    {
        NewImg->values[q] = (int *)malloc(sizeof(int) * NewImg->colors);
    }

    //Fill the space
    if(flip_flag == 0) Fill_Data(NewImg, infile);
    else if(flip_flag == 1) Fill_Data_h_flip(NewImg, infile);
    else if(flip_flag == 2) Fill_Data_v_flip(NewImg, infile);
    else if(flip_flag == 3) Fill_Data_vh_flip(NewImg, infile);
    else Fill_Data(NewImg, infile);
    for(int y = 0; y < NewImg->colors; y ++)
    {
        for(int x = 0; x < NewImg->palettes; x ++)
        {
            fread(&NewImg->values[x][y], sizeof(int), 1, infile);
        }
    }

    fclose(infile);
    return NewImg;
}

void Fill_Data(CUSTOM_IMAGE *NewImg, FILE *infile)
{
    for(int y = 0; y < NewImg->ysize; y ++)
    {
        for(int x = 0; x < NewImg->xsize; x ++)
        {
            fread(&NewImg->image[x][y], sizeof(char), 1, infile);
        }
    }
}

void Fill_Data_h_flip(CUSTOM_IMAGE *NewImg, FILE *infile)
{
    for(int y = 0; y < NewImg->ysize; y ++)
    {
        for(int x = NewImg->xsize-1; x > -1; x --)
        {
            fread(&NewImg->image[x][y], sizeof(char), 1, infile);
        }
    }
}

void Fill_Data_v_flip(CUSTOM_IMAGE *NewImg, FILE *infile)
{
    for(int y = NewImg->ysize-1; y > -1; y --)
    {
        for(int x = 0; x < NewImg->xsize; x ++)
        {
            fread(&NewImg->image[x][y], sizeof(char), 1, infile);
        }
    }
}

void Fill_Data_vh_flip(CUSTOM_IMAGE *NewImg, FILE *infile)
{
    for(int y = NewImg->ysize-1; y > -1; y --)
    {
        for(int x = NewImg->xsize-1; x > -1; x --)
        {
            fread(&NewImg->image[x][y], sizeof(char), 1, infile);
        }
    }
}



CUSTOM_IMAGE *Create_Blank_Custom_Image(int xsize, int ysize, int palettes, int colors)
{
    CUSTOM_IMAGE *NewImg = (CUSTOM_IMAGE *)malloc(sizeof(CUSTOM_IMAGE));
    NewImg->xsize = xsize;
    NewImg->ysize = ysize;
    NewImg->palettes = palettes;
    NewImg->colors = colors;
    NewImg->image = (char **)malloc(sizeof(char *) * NewImg->xsize);
    for(int q = 0; q < NewImg->xsize; q ++)
    {
        NewImg->image[q] = (char *)malloc(sizeof(char) * NewImg->ysize);
    }
    NewImg->values = (int **)malloc(sizeof(int *) * NewImg->palettes);
    for(int q = 0; q < NewImg->palettes; q ++)
    {
        NewImg->values[q] = (int *)malloc(sizeof(int) * NewImg->colors);
    }
    return NewImg;
}

//MAKE SURE THEY HAVE THE SAME PALETTE DATA FIRST, DAMNIT
void Copy_Custom_Image_Palette_Data(CUSTOM_IMAGE *src, CUSTOM_IMAGE *dest)
{
    for(int p = 0; p < src->palettes; p ++)
    {
        for(int c = 0; c < src->colors; c ++)
        {
            dest->values[p][c] = src->values[p][c];
        }
    }
}

BITMAP *Create_Bitmap_From_MCI(MCI_FILE *Mci_File, char name[])
{
    int indexspot_img = -1;
    CUSTOM_IMAGE *NewImg = (CUSTOM_IMAGE *)malloc(sizeof(CUSTOM_IMAGE));
    for(int i = 0; i < Mci_File->total_images; i ++)
    {
        if(!strcasecmp(Mci_File->image_index[i].name, name))
        {
            indexspot_img = i;
        }
    }
    if(indexspot_img == -1) return NULL; //Name wasn't found

    FILE *infile = fopen(IMAGES"Images.mci", "rb");
    if(!infile)
    {
        printf("Failed to locate Images.mci, aborting program\n");
        exit(1);
    }
    fseek(infile, Mci_File->image_index[indexspot_img].position, SEEK_SET);
    
    //Get size
    fread(&NewImg->xsize, sizeof(int), 1, infile);
    fread(&NewImg->ysize, sizeof(int), 1, infile);
    fread(&NewImg->palettes, sizeof(int), 1, infile);
    fread(&NewImg->colors, sizeof(int), 1, infile);

    //Allocate space
    NewImg->image = (char **)malloc(sizeof(char *) * NewImg->xsize);
    for(int q = 0; q < NewImg->xsize; q ++)
    {
        NewImg->image[q] = (char *)malloc(sizeof(char) * NewImg->ysize);
    }
    NewImg->values = (int **)malloc(sizeof(int *) * NewImg->palettes);
    for(int q = 0; q < NewImg->palettes; q ++)
    {
        NewImg->values[q] = (int *)malloc(sizeof(int) * NewImg->colors);
    }

    //Fill the space
    for(int y = 0; y < NewImg->ysize; y ++)
    {
        for(int x = 0; x < NewImg->xsize; x ++)
        {
            fread(&NewImg->image[x][y], sizeof(char), 1, infile);
        }
    }
    for(int y = 0; y < NewImg->colors; y ++)
    {
        for(int x = 0; x < NewImg->palettes; x ++)
        {
            fread(&NewImg->values[x][y], sizeof(int), 1, infile);
        }
    }

    fclose(infile);

    BITMAP *RetImg = create_bitmap(NewImg->xsize, NewImg->ysize);
    clear_to_color(RetImg, transparent);
    draw_sprite_palette(RetImg, NewImg, 0, 0, 0);
    free(NewImg);
    return RetImg;
}

