#include "MTC.h"
#include "Include.h"
int main(int argc, char *argv[])
{
	#ifndef NOMW
    mwInit();
	#endif
    Initialize_Everything();
    Use_Command_Line(argc, argv);
    while(!quit)
    {
		#ifndef NOMW
        mwDoFlush(1);
		#endif
        while(speed_counter > 0)
        {
            poll_keyboard();
            Accept_Keys();

            map_timer ++;
            if(map_timer >= 32) map_timer = 0;

            if(intro_running)
                Intro_Processes();
            else if(credits_running)
                Credits_Processes();
            else if(game_paused)
                Pause_Processes();
            else if(subscreen_up)
                Subscreen_Processes();
            else if(game_over_mode)
                Game_Over_Processes();
            else
            {
                Game_Processes();
            }

            if(key[KEY_F12])
            {
                Destroy_All();
				#ifndef NOMW
                mwTerm();
				#endif
                return 0;
            }
            speed_counter --;
        }
//if (!intro_running) printf("credits=%i, game_over=%i, subscreen=%i, transition=%i\n", credits_running, game_over_mode, subscreen_up, transition_stage);
        if(debug_write) printf("Draw ");
        if(intro_running)
        {
            if(debug_write) printf("I ");
            Draw_Intro(buffer); //Located in Intro.h, not Draw.h
            Draw_To_Screen(buffer);
            if(debug_write) printf("I");
        }
        else if(credits_running)
        {
            if(debug_write) printf("C ");
            if(!skip_drawing_credits_this_pulse) Draw_Credits(buffer);
            Draw_To_Screen(buffer);
            if(debug_write) printf("C");
        }
        else if(game_over_mode)
        {
            if(debug_write) printf("G ");
            Game_Over_Draw(buffer);
            Draw_To_Screen(buffer);
            if(debug_write) printf("G");
        }
        else if(subscreen_up)
        {
            if(debug_write) printf("S ");
            if(draw_to_reserve_buffer_this_pulse)
            {
                Draw_Everything(subscreen_reserve_buffer);
                draw_to_reserve_buffer_this_pulse = false;
            }
            Draw_Subscreen(buffer);
            Draw_To_Screen(buffer);
            if(debug_write) printf("S");
        }
        else if(transition_stage == 0)
        {
            if(debug_write) printf("E ");
            Draw_Everything(buffer);
            Draw_To_Screen(buffer);
            if(debug_write) printf("E");
        }
        else if(transition_stage)
        {
            if(debug_write) printf("T ");
            Draw_Transition(buffer);
            Draw_To_Screen(buffer);
            if(debug_write) printf("T");
        }
        if(debug_write) printf("\n");
    }
    printf("All switches clear, exiting program\n");
    Destroy_All();
	#ifndef NOMW
    mwTerm();
	#endif
    return 0;
}
END_OF_MAIN()
