void Update_Map_Clearing(MAP *Map, int x, int y, int val)
{
    Map->vals[x][y] = val;
    for(int i = 0; i < Saveout->maps_accessed; i ++)
    {
        if(!strcmp(Saveout->Savemap[i].name, Map->name))
        {
            Saveout->Savemap[i].vals[x][y] = val;
        }
    }
}

MAP *Create_Map(char name[], int xsize, int ysize, BITMAP *base)
{
    MAP *Newmap = (MAP *)malloc(sizeof(MAP));
    Newmap->name = (char *)malloc(sizeof(char) * (strlen(name)+1));
    Init_String(Newmap->name, name, strlen(name));
    Newmap->xsize = xsize;
    Newmap->ysize = ysize;
    Newmap->vals = (short **)malloc(sizeof(short *) * xsize);
    for(int x = 0; x < xsize; x ++)
    {
        Newmap->vals[x] = (short *)malloc(sizeof(short) * ysize);
        for(int y = 0; y < ysize; y ++) Newmap->vals[x][y] = 0; //Clear to undiscovered
    }
    Newmap->base = base;

    Add_Saved_Map(Saveout, name, xsize, ysize);
    return Newmap;
}

void Display_Map(BITMAP *output, MAP *Map, int xpos, int ypos, int map_x, int map_y)
{
    for(int x = 0; x < 5; x ++)
    {
        for(int y = 0; y < 3; y ++)
        {
            if(x+map_x > -1 AND x+map_x < Map->xsize AND y+map_y > -1 AND y+map_y < Map->ysize AND Map->vals[x+map_x][y+map_y] == 1)
            {
                if(x == 2 AND y == 1)
                    Recolor_Blit(Map->base, output, (x+map_x)*8, (y+map_y)*8, xpos+(x*8), ypos+(y*8), 8, 8, Map_Recolor, map_timer/16);
                else
                    blit(Map->base, output, (x+map_x)*8, (y+map_y)*8, xpos+(x*8), ypos+(y*8), 8, 8);
            }
        }
    }
}

void Display_Map(BITMAP *output, MAP *Map, int xpos, int ypos)
{
    for(int x = 0; x < Map->xsize; x ++)
    {
        for(int y = 0; y < Map->ysize; y ++)
        {
            if(Map->vals[x][y] == 1)
            {
                blit(Map->base, output, x*8, y*8, xpos+(x*8), ypos+(y*8), 8, 8);
            }
        }
    }
    int x = cur_map_pos_x, y = cur_map_pos_y;
    int scaler = cursor_array[map_timer/4];
    draw_sprite(output, map_cursor, (x*8)-2+xpos-scaler, (y*8)-2+ypos-scaler);//Top left
    draw_sprite_h_flip(output, map_cursor, (x*8)+4+xpos+scaler, (y*8)-2+ypos-scaler);//Top right
    draw_sprite_v_flip(output, map_cursor, (x*8)-2+xpos-scaler, (y*8)+4+ypos+scaler);//Bottom left
    draw_sprite_vh_flip(output, map_cursor, (x*8)+4+xpos+scaler, (y*8)+4+ypos+scaler);//Bottom right
}
