void Create_Minigun(int x, int y, int direction_code)
{
    for(int i = 0; i < total_miniguns; i ++)
    {
        if(!Minigun[i].active)
        {
            Place_Minigun_In_Slot(i, x, y, direction_code);
        }
    }
    Minigun = (MINIGUN *)realloc(Minigun, sizeof(MINIGUN) * (total_miniguns +1));
    Minigun[total_miniguns].lookup = NULL;
    Place_Minigun_In_Slot(total_miniguns, x, y, direction_code);
    total_miniguns ++;
}

void Place_Minigun_In_Slot(int i, int x, int y, int direction_code)
{
    Minigun[i].active = true;
    Minigun[i].x = x;
    Minigun[i].y = y;
    Minigun[i].dim.lft = x;
    Minigun[i].dim.top = y;
    Minigun[i].dim.rgt = x+16;
    Minigun[i].dim.bot = y+16;
    Minigun[i].timer = rnd(0, 31);
    Minigun[i].cur_lookup = rnd(0, 7);
    Minigun[i].direction_code = direction_code;
    if(Minigun[i].lookup) free(Minigun[i].lookup);
    if(direction_code == 0) //Left
    {
        //U, UL, L, DL, D, DL, L, UL
        Minigun[i].total_lookups = 8;
        Minigun[i].lookup = (MINIGUN_LOOKUP *)malloc(sizeof(MINIGUN_LOOKUP) * 8);
        Set_Lookup_Vals(i, 0,  6, -6,  0,  0, false,  true, Minigun_V, false);//U
        Set_Lookup_Vals(i, 1, -3, -3,  0,  0,  true,  true, Minigun_D, false);//UL
        Set_Lookup_Vals(i, 2, -5,  6,  0,  0, false, false, Minigun_H, false);//L
        Set_Lookup_Vals(i, 3, -3, 13, -9, 14,  true, false, Minigun_D,  true);//DL
        Set_Lookup_Vals(i, 4,  6, 14,  0,  0, false, false, Minigun_V, false);//D
        Set_Lookup_Vals(i, 5, -3, 13,  0,  0,  true, false, Minigun_D, false);//DL
        Set_Lookup_Vals(i, 6, -5,  6,  0,  0, false, false, Minigun_H, false);//L
        Set_Lookup_Vals(i, 7, -3, -3,  0,  0,  true,  true, Minigun_D, false);//UL
    }
    else if(direction_code == 1) //Right
    {
        //U, UR, R, DR, D, DR, R, UR
        Minigun[i].total_lookups = 8;
        Minigun[i].lookup = (MINIGUN_LOOKUP *)malloc(sizeof(MINIGUN_LOOKUP) * 8);
        Set_Lookup_Vals(i, 0,  6, -6,  0,  0, false,  true, Minigun_V, false);//U
        Set_Lookup_Vals(i, 1, 13, -3,  0,  0, false,  true, Minigun_D, false);//UR
        Set_Lookup_Vals(i, 2, 14,  6,  0,  0, false, false, Minigun_H, false);//R
        Set_Lookup_Vals(i, 3, 13, 13, 16, 14, false, false, Minigun_D,  true);//DR
        Set_Lookup_Vals(i, 4,  6, 14,  0,  0, false, false, Minigun_V, false);//D
        Set_Lookup_Vals(i, 5, 13, 13,  0,  0, false, false, Minigun_D, false);//DR
        Set_Lookup_Vals(i, 6, 14,  6,  0,  0, false, false, Minigun_H, false);//R
        Set_Lookup_Vals(i, 7, 13, -3,  0,  0, false,  true, Minigun_D, false);//UR
    }
    else if(direction_code == 2) //DOWN
    {
        //L, DL, D, DR, R, DR, D, DL
        Minigun[i].total_lookups = 8;
        Minigun[i].lookup = (MINIGUN_LOOKUP *)malloc(sizeof(MINIGUN_LOOKUP) * 8);
        Set_Lookup_Vals(i, 0, -5,  6,  0,  0, false, false, Minigun_H, false);//L
        Set_Lookup_Vals(i, 1, -3, 13,  0,  0,  true, false, Minigun_D, false);//DL
        Set_Lookup_Vals(i, 2,  6, 14,  5, 15, false, false, Minigun_V,  true);//D
        Set_Lookup_Vals(i, 3, 13, 13,  0,  0, false, false, Minigun_D, false);//DR
        Set_Lookup_Vals(i, 4, 14,  6,  0,  0, false, false, Minigun_H, false);//R
        Set_Lookup_Vals(i, 5, 13, 13,  0,  0, false, false, Minigun_D, false);//DR
        Set_Lookup_Vals(i, 6,  6, 14,  0,  0, false, false, Minigun_V, false);//D
        Set_Lookup_Vals(i, 7, -3, 13,  0,  0,  true, false, Minigun_D, false);//DL
    }
}

void Set_Lookup_Vals(int i, int p, int draw_x, int draw_y, int spawn_x, int spawn_y, bool hflip, bool vflip, CUSTOM_IMAGE *img, bool fire)
{
    Minigun[i].lookup[p].draw_x = draw_x;
    Minigun[i].lookup[p].draw_y = draw_y;
    Minigun[i].lookup[p].spawn_x = spawn_x;
    Minigun[i].lookup[p].spawn_y = spawn_y;
    Minigun[i].lookup[p].hflip = hflip;
    Minigun[i].lookup[p].vflip = vflip;
    Minigun[i].lookup[p].img = img;
    Minigun[i].lookup[p].fire_on_this_frame = fire;
}

void Update_Miniguns()
{
    for(int i = 0; i < total_miniguns; i ++)
    {
        if(Minigun[i].active)
        {
            Minigun[i].timer ++;
            if(Minigun[i].timer == 31 AND Minigun[i].lookup[Minigun[i].cur_lookup].fire_on_this_frame)
            {
                int q = Minigun[i].cur_lookup;
                int p = Create_Sprite(Minigun[i].x+Minigun[i].lookup[q].spawn_x, Minigun[i].y+Minigun[i].lookup[q].spawn_y, Minigun[i].x+Minigun[i].lookup[q].spawn_x+7, Minigun[i].y+Minigun[i].lookup[q].spawn_y+7, 1, 1, -1);
                if(p != -1) Imagize_Sprite_Minigun_Shot(p,  Minigun[i].direction_code);
            }
            else if(Minigun[i].timer > 63)
            {
                Minigun[i].timer = 0;
                Minigun[i].cur_lookup ++;
                if(Minigun[i].cur_lookup >= Minigun[i].total_lookups)
                {
                    Minigun[i].cur_lookup = 0;
                }
            }
        }
    }
}

void Draw_Miniguns(BITMAP *output)
{
    for(int i = 0; i < total_miniguns; i ++)
    {
        if(Minigun[i].active)
        {
            if(Minigun[i].lookup[Minigun[i].cur_lookup].hflip AND Minigun[i].lookup[Minigun[i].cur_lookup].vflip)
            {
                draw_sprite_vh_flip_palette(output, Minigun[i].lookup[Minigun[i].cur_lookup].img, Minigun[i].x+Minigun[i].lookup[Minigun[i].cur_lookup].draw_x-camera.lft, Minigun[i].y+Minigun[i].lookup[Minigun[i].cur_lookup].draw_y-camera.top, 0);
            }
            else if(Minigun[i].lookup[Minigun[i].cur_lookup].hflip)
            {
                draw_sprite_h_flip_palette(output, Minigun[i].lookup[Minigun[i].cur_lookup].img, Minigun[i].x+Minigun[i].lookup[Minigun[i].cur_lookup].draw_x-camera.lft, Minigun[i].y+Minigun[i].lookup[Minigun[i].cur_lookup].draw_y-camera.top, 0);
            }
            else if(Minigun[i].lookup[Minigun[i].cur_lookup].vflip)
            {
                draw_sprite_v_flip_palette(output, Minigun[i].lookup[Minigun[i].cur_lookup].img, Minigun[i].x+Minigun[i].lookup[Minigun[i].cur_lookup].draw_x-camera.lft, Minigun[i].y+Minigun[i].lookup[Minigun[i].cur_lookup].draw_y-camera.top, 0);
            }
            else
            {
                draw_sprite_palette(output, Minigun[i].lookup[Minigun[i].cur_lookup].img, Minigun[i].x+Minigun[i].lookup[Minigun[i].cur_lookup].draw_x-camera.lft, Minigun[i].y+Minigun[i].lookup[Minigun[i].cur_lookup].draw_y-camera.top, 0);
            }
        }
    }
}
