struct
{
    bool active;
    int x, y;
    DIMENSION dim;
    int health;
    int vulnerabilities; //BEAM_MISSILE and that's about it
    CUSTOM_IMAGE *images[6];
    int to_show;
    int to_show_timer;
    int to_show_stage; //As the brain gets more injured, it starts cycling its images faster.
    HSTREAM *Sound;
    int palette;
}Mbrain;

void Init_Mother_Brain()
{
    Mbrain.active = true;
    Mbrain.x = 48;
    Mbrain.y = 96;
    Room->tiles[2][6] = 82;
    Room->clips[2][6] = 1;
    Room->tiles[2][7] = 83;
    Room->clips[2][7] = 1;
    Room->tiles[2][8] = 83;
    Room->clips[2][8] = 1;
    Room->tiles[2][9] = 84;
    Room->clips[2][9] = 1;
    Room->clips[3][6] = 1;
    Room->clips[3][7] = 1;
    Room->clips[3][8] = 1;
    Room->clips[3][9] = 1;
    Room->clips[4][6] = 1;
    Room->clips[4][7] = 1;
    Room->clips[4][8] = 1;
    Room->clips[4][9] = 1;

    Room->tiles[6][6] = 85;
    Room->tiles[6][9] = 87;

    Room->clips[6][6] = 1;
    Create_Breakable(6, 7, -154, 0, false, 85);
    Room->clips[6][7] = 1;
    Create_Breakable(6, 8, -154, 0, false, 85);
    Room->clips[6][8] = 1;
    Room->clips[6][9] = 1;
    Create_Clips(Room->xsize, Room->ysize, Room->clips);
    Mbrain.health = 30 * 16;
    Mbrain.vulnerabilities = BEAM_MISSILE;
    Mbrain.images[0] = Create_Image_From_MCI(Master_MCI, "MBrainOn", 0);
    Mbrain.images[1] = Create_Image_From_MCI(Master_MCI, "MBrainOff", 0);
    Mbrain.images[2] = Create_Image_From_MCI(Master_MCI, "MBrainH0", 0);
    Mbrain.images[3] = Create_Image_From_MCI(Master_MCI, "MBrainH1", 0);
    Mbrain.images[4] = Create_Image_From_MCI(Master_MCI, "MBrainH2", 0);
    Mbrain.images[5] = Create_Image_From_MCI(Master_MCI, "MBrainH3", 0);
    Mbrain.to_show = 0; //Flips between 0 and 1 until HP drops below max.
    Mbrain.to_show_timer = 0;
    Mbrain.to_show_stage = 0; //The speed of the flipping
    Mbrain.Sound = &Audio.Injured_Boss;
    Mbrain.palette = 0;
    Add_To_Target_List(TARGET_MOTHER_BRAIN, 0);
}

void Destroy_Mother_Brain()
{
    countdown_timer = 1000;
    brain_remove_timer = 120;
    Remove_From_Target_List(&Mbrain.health);
    //Do the escape sequence right here!
    escape_audio = true;
    Room->tiles[2][6] = 0;
    Room->tiles[2][7] = 0;
    Room->tiles[2][8] = 0;
    Room->tiles[2][9] = 0;
    Room->tiles[6][6] = 0;
    Room->tiles[6][9] = 0;
    Room->clips[2][6] = 0;
    Room->clips[2][7] = 0;
    Room->clips[2][8] = 0;
    Room->clips[2][9] = 0;
    Room->clips[3][6] = 0;
    Room->clips[3][7] = 0;
    Room->clips[3][8] = 0;
    Room->clips[3][9] = 0;
    Room->clips[4][6] = 0;
    Room->clips[4][7] = 0;
    Room->clips[4][8] = 0;
    Room->clips[4][9] = 0;
    Room->clips[6][6] = 0;
    Room->clips[6][7] = 0;
    Room->clips[6][8] = 0;
    Room->clips[6][9] = 0;
    Create_Clips(Room->xsize, Room->ysize, Room->clips);
    for(int i = 0; i < total_miniguns; i ++)
    {
        if(Minigun[i].active) Minigun[i].active = false;
    }
    for(int i = 0; i < total_rinkas; i ++)
    {
        if(Rinka[i].active) Rinka[i].active = false;
    }
    for(int i = 0; i < total_enemy_spawners; i ++)
    {
        if(Enemy_Spawner[i].active) Enemy_Spawner[i].active = false;
    }
    for(int i = 0; i < total_water_zones; i ++)
    {
        if(Water[i].active) Water[i].active = false;
    }
    Cut_All_Audio_Switches();
    escape_active = true;
}

void Damage_Mother_Brain(int p)
{
    Mbrain.health -= Projectiles[p]->damage;
    BASS_ChannelPlay(*Mbrain.Sound, true);
    Projectiles[p]->terminate = true;
}

void Update_Mother_Brain()
{
    if(Mbrain.active)
    {
        Mbrain.dim.lft = Mbrain.x;
        Mbrain.dim.top = Mbrain.y;
        Mbrain.dim.rgt = Mbrain.x+48;
        Mbrain.dim.bot = Mbrain.y+64;

        if(Mbrain.health < 0 AND !escape_active)
        {
            Destroy_Mother_Brain();
            return;
        }
        else if(Mbrain.health < 120) Mbrain.to_show_stage = 4;
        else if(Mbrain.health < 240) Mbrain.to_show_stage = 3;
        else if(Mbrain.health < 360) Mbrain.to_show_stage = 2;
        else if(Mbrain.health < 480) Mbrain.to_show_stage = 1;
        else Mbrain.to_show_stage = 0;

        if(Mbrain.health < 480 AND Mbrain.to_show_timer > 10) Mbrain.to_show_timer = 10;

        Mbrain.to_show_timer --;
        if(Mbrain.to_show_timer < 1) //Flips from 0 to 1 and back
        {
            if(Mbrain.to_show_stage == 0)
            {
                if(Mbrain.to_show == 0) Mbrain.to_show = 1;
                else Mbrain.to_show = 0;
                Mbrain.to_show_timer = 300;
            }
            else
            {
                Mbrain.to_show ++;
                if(Mbrain.to_show > 5) Mbrain.to_show = 2;
                if(Mbrain.to_show_stage == 1) Mbrain.to_show_timer = 10;
                else if(Mbrain.to_show_stage == 2) Mbrain.to_show_timer = 8;
                else if(Mbrain.to_show_stage == 3) Mbrain.to_show_timer = 6;
                else if(Mbrain.to_show_stage == 4) Mbrain.to_show_timer = 4;
            }
        }
    }
}

void Draw_Mother_Brain(BITMAP *output)
{
    if(Mbrain.active)
    {
        draw_sprite_palette(output, Mbrain.images[Mbrain.to_show], Mbrain.x-camera.lft, Mbrain.y-camera.top, Mbrain.palette);
    }
}
