void Game_Processes()
{
    if(debug_write) printf("Base start\n");
    if(Get_Cvar_Value_I("debug_mode") == 1)
    {
        debug_mode = true;
    }
    else
    {
        debug_mode = false;
    }

    do_not_draw_samus = false;
    if(music_fade_out)
    {
        music_fade_out_timer --;
        BASS_ChannelSetAttribute(*Cur_Music, BASS_ATTRIB_VOL, (float)(music_fade_out_timer/100.0));
        if(music_fade_out_timer < 1)
        {
            music_fade_out = false;
            music_fade_out_timer = 0;
            BASS_ChannelStop(*Cur_Music);
            Cur_Music = New_Music;
            New_Music = NULL;
        }
    }
    if(music_fade_in)
    {
        if(music_fade_in_timer == 0)
        {
            BASS_ChannelPlay(*Cur_Music, true);
        }
        music_fade_in_timer ++;
        BASS_ChannelSetAttribute(*Cur_Music, BASS_ATTRIB_VOL, (float)(music_fade_in_timer/100.0));
        if(music_fade_in_timer > 99)
        {
            BASS_ChannelSetAttribute(*Cur_Music, BASS_ATTRIB_VOL, 1.00);
            music_fade_in = false;
            music_fade_in_timer = 0;
        }
    }
    if(item_lockout_timer > 0)
    {
        item_lockout_timer --;
        if(item_lockout_timer == 0)
        {
            BASS_ChannelPlay(*Cur_Music, true);
            kill_audio = false;
        }
        return;
    }

    if(kill_audio) Cut_All_Audio_Switches();
    if(debug_write) printf("A");
    if(transition_stage == 0 AND !transition_by_elevator)
    {
        if(elevator_trans_cooldown > 0) elevator_trans_cooldown --;
        /////////////////
        // Death Code  //
        /////////////////
        if(samvar.energy < 1)
        {
            game_over_fade_image = create_bitmap(256, 256);
            do_not_draw_samus = true;
            Draw_Everything(game_over_fade_image);
            game_over_black_buf = create_bitmap(256, 256);
            clear_to_color(game_over_black_buf, 0);
            do_not_draw_samus = false;
            game_over_mode = true;
            music_fade_out_timer = 255;
            game_over_fade = 255;
            sam_screen_x = samvar.x + sam_img_offset_x[samvar.frame] - camera.lft;
            sam_screen_y = samvar.y + sam_img_offset_y[samvar.frame] - camera.top;
            show_game_over_text = false;
        }
        if(debug_write) printf("D");
        /////////////////
        // Escape Code //
        /////////////////
        if(escape_active)
        {
            if(brain_remove_timer > 0)
            {
                brain_remove_timer --;
                Cur_Music = NULL;
                Mbrain.palette = brain_remove_timer % 4;
            }
            else if(brain_remove_timer == 0)
            {
                if(countdown_timer == 1000) //Splatter the Mother Brain
                {
                    Mbrain.active = false;
                    countdown_timer --;
                    Cur_Music = &Audio.Escape_Music;
                    BASS_ChannelPlay(*Cur_Music, true);
                }
                else
                {
                    if(countdown_sub_timer > 0)
                    {
                        countdown_sub_timer --;
                    }
                    else
                    {
                        countdown_timer --;
                        countdown_sub_timer = 8;
                    }
                }
            }
        }
        if(debug_write) printf("E");

        // End of escape code
        samvar.cur_clip_detect = STOP_SAMUS + STOP_FREEZE;
        if(key[KEY_F11])
        {
            init_credits = true;
            credits_running = true;
            skip_drawing_credits_this_pulse = true;
        }
        cur_map_pos_x = (samvar.x/256) + Room->xpos;
        cur_map_pos_y = (samvar.y/256) + Room->ypos;
        Update_Map_Clearing(Curmap, cur_map_pos_x, cur_map_pos_y, 1);
        //Debug Code
        if(samvar.press_debug AND !Controls[keys.debug_draw].pressing)
        {
            samvar.draw_debug ++;
            if(samvar.draw_debug > 7) samvar.draw_debug = 0;
            Controls[keys.debug_draw].pressing = true;
        }
        if(debug_write) printf("M");
        ////////////////////////////////////////////////////
        // Samus movement code                            //
        ////////////////////////////////////////////////////
        frame ++;
        if(use_Samstart)
        {
            if(debug_write) printf("S");
            Update_Samstart();
            samvar.lockout_controls = true;
            samvar.lockout_timer = 2;
            if(debug_write) printf("S");
        }
        else
        {
            if(debug_write) printf("Q");
            if(first_level_audio_switch)
            {
                first_level_audio_switch = false;
                BASS_ChannelPlay(*Cur_Music, true);
                kill_audio = false;
            }
            // Check if Samus is still in the water, if she was to begin with //
            if(samvar.is_in_water)
            {
                samvar.is_in_water = false;
                for(int i = 0; i < total_water_zones; i ++)
                {
                    if(rect_clip(Water[i].dim, samvar.dim.lft, samvar.dim.bot, samvar.dim.rgt, samvar.dim.bot+1))
                    {
                        samvar.is_in_water = true;
                        break;
                    }
                }
            }
            if(debug_write) printf("W");
            Detect_Samus_Collision();
            if(samvar.press_up) samvar.aim_up = true;
            else samvar.aim_up = false;

            if(samvar.touch_top AND samvar.yspeed < 0) samvar.yspeed = 0;
            if(samvar.yspeed < 3)
            {
                samvar.yspeed += gravity;
            }
            else samvar.yspeed = 3;
            samvar.boost_timer --;
            samvar.falling_lockout --;
            if(debug_write) printf("P");

            //Jumping code
            if(samvar.press_jump AND !samvar.ball_mode)
            {
                if(samvar.jump AND !samvar.cant_jump) //Samus is jumping already, so boost her
                {
                    samvar.cant_jump = false;
                    samvar.jump_cnt ++;
                    if(samvar.boost_timer > 0) samvar.yspeed -= gravity;
                    if(samvar.jump == 1) //Lift off, frame is stand frame
                    {
                        if(samvar.aim_up) samvar.frame = 5;
                        else samvar.frame = 1;

                        if(samvar.jump_cnt >= 3)
                        {
                            samvar.jump = 2;
                            samvar.jump_cnt = 0;
                        }
                    }
                    else if(samvar.jump == 2) //Mid lift,  frame is run right 1
                    {
                        if(samvar.aim_up) samvar.frame = 15;
                        else samvar.frame = 3;
                        if(samvar.jump_cnt >= 2)
                        {
                            samvar.jump = 3;
                            samvar.jump_cnt = 0;
                            if(samvar.spin_jump) //Clincher frame, if the player is pressing left or right, they keep going
                            {
                                if(samvar.press_right OR samvar.press_left)
                                {
                                    if(samvar.press_right) samvar.xaccel = 0.5;
                                    else if(samvar.press_left) samvar.xaccel = -0.5;
                                }
                                else
                                {
                                    Lock_Samus_Speed(0, -100);
                                }
                            }
                        }
                    }
                    else if(samvar.jump == 3) //Full jump mode
                    {
                        if(samvar.aim_up) samvar.frame = 9;
                        else if(samvar.press_fire) samvar.frame = 10;
                        else samvar.frame = 6;
                        if(samvar.jump_cnt >= 18) //Enough jumping, time to fall
                        {
                            samvar.jump = 0;
                            samvar.jump_cnt = 0;
                            samvar.falling = true;
                            samvar.cant_jump = true;
                        }
                    }
                }
                else if(!samvar.falling AND samvar.release_jump) //Samus is starting to jump
                {
                    BASS_ChannelPlay(Audio.Jump, true);
                    samvar.rejump = false;
                    samvar.release_jump = false;
                    samvar.began_jump = true;
                    samvar.boost_timer = 60;
                    samvar.jump = 1;
                    samvar.jump_cnt = 0;
                    samvar.yspeed = -3.20;
                    if(samvar.Using.high_jump) samvar.yspeed -= .70;
                    samvar.touch_bot = false;
                    samvar.cant_jump = false;
                    samvar.disable_spin_draw = false;
                    if(samvar.press_right OR samvar.press_left)
                    {
                        samvar.spin_jump = true;
                    }
                    samvar.launch_height = samvar.dim.bot;
                }
                else if(samvar.Using.space_jump AND samvar.yspeed > 1 AND samvar.spin_jump AND samvar.release_jump)
                {
                    BASS_ChannelPlay(Audio.Jump, true);
                    samvar.rejump = true;
                    samvar.release_jump = false;
                    samvar.began_jump = true;
                    samvar.boost_timer = 60;
                    samvar.jump = 1;
                    samvar.jump_cnt = 0;
                    samvar.yspeed = -3.20;
                    if(samvar.Using.high_jump) samvar.yspeed -= .40;
                    samvar.touch_bot = false;
                    samvar.cant_jump = false;
                    samvar.disable_spin_draw = false;
                    samvar.launch_height = 10000;
                }
            }
            else
            {
                if(!samvar.cant_jump)
                {
                    samvar.yspeed = 0;
                    samvar.cant_jump = true;
                }
                samvar.jump = 0;
            }
            if(samvar.rejump)
            {
                if(samvar.spin_jump < 4) samvar.frame = 7;
                else if(samvar.spin_jump < 7) samvar.frame = 8;
                if(samvar.press_right AND !samvar.press_left) samvar.facing = RIGHT;
                if(samvar.press_left AND !samvar.press_right) samvar.facing = LEFT;
            }
            if(debug_write) printf("J");

            //Falling Code
            if(!samvar.touch_bot)
            {
                if(samvar.dim.bot > samvar.launch_height)
                {
                    samvar.spin_jump = false;
                    samvar.launch_height = -1;
                }
                if(!samvar.jump)
                {
                    if(samvar.aim_up) samvar.frame = 9;
                    else if(samvar.press_fire) samvar.frame = 10;
                    else samvar.frame = 6;
                    if(!samvar.falling) samvar.boost_timer = 10;
                    if(!samvar.falling AND !samvar.began_jump) samvar.falling_lockout = 20;
                    samvar.falling = true;
                    samvar.cant_jump = true;
                    if(samvar.yspeed < 3)
                    {
                        samvar.yspeed += gravity;
                    }
                    else samvar.yspeed = 3;
                }
                else
                {
                    if(samvar.yspeed < 3)
                    {
                        samvar.yspeed += gravity;
                    }
                    else samvar.yspeed = 3;
                }
            }
            else if(samvar.touch_bot)
            {
                if(!samvar.ball_mode)
                {
                    if(!samvar.press_jump) samvar.release_jump = true;
                    samvar.began_jump = false;
                    samvar.launch_height = -1;
                    if(samvar.falling)
                    {
                        samvar.spin_jump = false;
                        samvar.y -= 7;
                        Update_Samus_Clips();
                    }
                    samvar.boost_timer = 0;
                    samvar.falling = false;
                    samvar.cant_jump = false;
                    samvar.yspeed = 0;
                }
                else
                {
                    samvar.falling = false;
                    samvar.cant_jump = false;
                    samvar.yspeed = 0;
                }
            }
            if(samvar.Using.space_jump AND !samvar.press_jump) samvar.release_jump = true;

            if(samvar.spin_jump)
            {
                if(samvar.press_fire) samvar.spin_jump = -1;
                samvar.spin_jump ++;
                if(samvar.spin_jump >= 13) samvar.spin_jump = 1;
                if((samvar.jump == 0 OR samvar.jump == 3) AND !samvar.shot_cnt AND !samvar.press_fire AND !samvar.disable_spin_draw)
                {
                    if(samvar.spin_jump < 4) samvar.frame = 7;
                    else if(samvar.spin_jump < 7) samvar.frame = 8;
                }
                if(samvar.Using.screw_attack)
                {
                    samvar.screw_attack_active ++;
                    if(samvar.screw_attack_active > 4) samvar.screw_attack_active = 0;
                    samvar.cur_clip_detect = STOP_SAMUS;
                }
            }
            else
            {
                samvar.screw_attack_active = -1;
            }
            if(debug_write) printf("A");

            if((!samvar.touch_lft AND samvar.press_left) OR (!samvar.touch_rgt AND samvar.press_right)) //Samus is moving left or right
            {
                if(samvar.touch_bot)
                {
                    if(samvar.run_frameup >= 3)
                    {
                        samvar.run_frameup = 0;
                        if(samvar.runframe < 2) samvar.runframe ++; //Alternate Samus between the run frames
                        else samvar.runframe = 0;
                    }
                    else
                        samvar.run_frameup ++;
                    if(samvar.aim_up) samvar.frame = samvar.runframe + 14;
                    else if(samvar.press_fire) samvar.frame = samvar.runframe + 11;
                    else samvar.frame = samvar.runframe + 2;
                }
            }
            else //Samus is standing still
            {
                samvar.xremainder = 0;
                if(samvar.touch_bot)
                {
                    Lock_Samus_Speed(0, -100);
                    if(samvar.aim_up) samvar.frame = 5;
                    else samvar.frame = 1;
                    if(samvar.press_down)
                    {
                        if(game_version == 2)
                        {
                            if(!samvar.crouch_mode)
                            {
                                samvar.crouch_mode = true;
                                samvar.crouch_release_flag = false;
                            }
                            else if(samvar.crouch_mode AND samvar.crouch_release_flag)
                            {
                                if(samvar.Using.morph_ball AND !samvar.ball_mode)
                                {
                                    samvar.crouch_mode = false;
                                    BASS_ChannelPlay(Audio.Morph, true);
                                    samvar.ball_mode = true;
                                    samvar.ball_frame = -3;
                                }
                            }
                        }
                        else
                        {
                            if(samvar.Using.morph_ball AND !samvar.ball_mode)
                            {
                                BASS_ChannelPlay(Audio.Morph, true);
                                samvar.ball_mode = true;
                                samvar.ball_frame = -3;
                            }
                        }
                        samvar.crouch_release_flag = false;
                    }
                    else
                    {
                        samvar.crouch_release_flag = true;
                    }
                }
                else
                {
                    if(!samvar.spin_jump AND !samvar.lockout_controls) Lock_Samus_Speed(0, -100);
                }
            }
            if(samvar.press_right)
            {
                if(!samvar.spin_jump OR samvar.disable_spin_draw) samvar.facing = RIGHT;
                if(!samvar.touch_bot)
                {
                    //if(!samvar.spin_jump) Lock_Samus_Speed(1, -100);
                    //else samvar.xaccel = 0.125;
                    Lock_Samus_Speed(1, -100);
                }
                else
                    Lock_Samus_Speed(1.25, -100);
            }
            else if(samvar.press_left)
            {
                if(!samvar.spin_jump OR samvar.disable_spin_draw) samvar.facing = LEFT;
                if(!samvar.touch_bot)
                {
                    //if(!samvar.spin_jump) Lock_Samus_Speed(-1, -100);
                    //else samvar.xaccel = -0.125;
                    Lock_Samus_Speed(-1, -100);
                }
                else
                    Lock_Samus_Speed(-1.25, -100);
            }

            samvar.xspeed += samvar.xaccel;
            if(samvar.xspeed > 1.5) samvar.xspeed = 1.5;
            if(samvar.xspeed < -1.5) samvar.xspeed = -1.5;
            if(debug_write) printf("R");

            //Morph Ball Code
            if(samvar.ball_mode)
            {
                samvar.ball_frame ++;
                if(samvar.ball_frame == 12) samvar.ball_frame = 0;
                if(samvar.press_up)
                {
                    if(!Scan_Clips_Rect(samvar.x, samvar.y, samvar.x + 7, samvar.y+17, STOP_SAMUS + STOP_FREEZE))
                        samvar.ball_mode = false;
                }
                samvar.frame = 17;
                samvar.aim_up = false;
                samvar.falling = false;
                samvar.spin_jump = false;
                samvar.jump = 0;
                samvar.cant_jump = true;
                samvar.falling_lockout = 0;
                if(samvar.Using.bombs)
                {
                    if(!samvar.press_fire) samvar.release_fire = true;
                    if(samvar.press_fire AND !samvar.shot_cnt AND samvar.release_fire AND samvar.Using.bombs)
                    {
                        samvar.release_fire = false;
                        samvar.shot_cnt = 40;
                        Create_Bomb(samvar.dim.lft, samvar.dim.top + 7);
                    }
                    if(samvar.shot_cnt) samvar.shot_cnt --;
                }
            }

            if(samvar.is_in_water AND !samvar.Using.gravity_suit) samvar.hamper_movement = true;
            else samvar.hamper_movement = false;
            Move_Samus();
            if(debug_write) printf("M");
        }

        ////////////////////
        // Firing Code    //
        ////////////////////
        if(samvar.missiles == 0)
        {
            samvar.missile_mode = false;
            if(samvar.Using.gravity_suit) samvar.palette = 4;
            else if(samvar.Using.varia_suit) samvar.palette = 2;
            else samvar.palette = 0;
            samvar.qpalette = samvar.palette;
        }
        if(samvar.press_switchitem)
        {
            if(samvar.release_switchitem)
            {
                samvar.release_switchitem = false;
                if(!samvar.missile_mode AND samvar.missiles > 0)
                {
                    samvar.missile_mode = true;
                    if(samvar.Using.gravity_suit) samvar.palette = 5;
                    else if(samvar.Using.varia_suit) samvar.palette = 3;
                    else samvar.palette = 1;
                    samvar.qpalette = samvar.palette;
                }
                else
                {
                    samvar.missile_mode = false;
                    if(samvar.Using.gravity_suit) samvar.palette = 4;
                    else if(samvar.Using.varia_suit) samvar.palette = 2;
                    else samvar.palette = 0;
                    samvar.qpalette = samvar.palette;
                }
            }
        }
        else
        {
            samvar.release_switchitem = true;
        }
        if(samvar.screw_attack_active % 4 > 1 AND samvar.screw_attack_active != -1) samvar.palette = 6;
        else samvar.palette = samvar.qpalette;
        samvar.hamper_movement = false;
        if(metroid_latch_index != -1)
        {
            samvar.hamper_movement = true;
            if(samvar.screw_attack_active == -1) metroid_latch_count --;
            if(metroid_latch_count < 1)
            {
                metroid_latch_count = 12;
                if(samvar.Using.varia_suit) metroid_latch_count = 24;
                samvar.energy --;
            }
            samvar.palette = 6;
        }

        //Normal beam firing code
        if(samvar.press_fire AND !samvar.shot_cnt AND !samvar.ball_mode)
        {
            Assemble_Samus_Beam_Data();
            BASS_ChannelPlay(*samvar.Beam_Data.Sound, true);
            if(samvar.Beam_Data.create_flag == 0) //Normal beams
            {
                if(!samvar.Beam_Data.penetrate_enemy) samvar.Beam_Data.not_less_than_pos = -1;
                if(samvar.Beam_Data.wave_flag) Create_Projectile(samvar.shot_reverse, 1);
                else Create_Projectile(0, 0);
                if(samvar.missile_mode) samvar.missiles --;
            }
            else if(samvar.Beam_Data.create_flag == 1) //Spazer beams
            {
                if(samvar.Beam_Data.wave_flag)
                {
                    if(!samvar.aim_up AND samvar.facing == LEFT) samvar.Beam_Data.origin_x -= 4;
                    if(!samvar.aim_up) samvar.Beam_Data.origin_y += 2;
                    Create_Projectile(0, 0);
                    if(!samvar.aim_up) samvar.Beam_Data.origin_y += 1;
                    Create_Projectile(0, 2);
                    Create_Projectile(1, 2);
                }
                else
                {
                    if(samvar.aim_up)
                    {
                        Create_Projectile(0, 0);
                        samvar.Beam_Data.origin_x += 6;
                        Create_Projectile(0, 0);
                        samvar.Beam_Data.origin_x -= 12;
                        Create_Projectile(0, 0);
                    }
                    else
                    {
                        if(samvar.facing == LEFT) samvar.Beam_Data.origin_x -= 4;
                        samvar.Beam_Data.origin_y += 2;
                        Create_Projectile(0, 0);
                        samvar.Beam_Data.origin_y += 6;
                        Create_Projectile(0, 0);
                        samvar.Beam_Data.origin_y -= 12;
                        Create_Projectile(0, 0);
                    }
                }
            }
            else if(samvar.Beam_Data.create_flag == 2) //Plasma/Wave beam
            {
                if(!samvar.aim_up) samvar.Beam_Data.origin_y += 2;
                Create_Projectile(0, 3);
                Create_Projectile(1, 3);
                global_projectiles_fired ++;
            }
            else if(samvar.Beam_Data.create_flag == 3) //Helix Beam
            {
                if(!samvar.aim_up)
                {
                    samvar.Beam_Data.origin_y += 3;
                }
                else
                {
                    samvar.Beam_Data.origin_x -= 10;
                }
                if(samvar.Beam_Data.palette == -1)
                {
                    samvar.Beam_Data.palette = 2;
                    samvar.Beam_Data.properties = BEAM_DAMAGE + BEAM_ICE;
                    Create_Projectile(0, 4);
                    samvar.Beam_Data.palette = 1;
                    samvar.Beam_Data.properties = BEAM_DAMAGE + BEAM_BURN;
                    Create_Projectile(1, 4);
                }
                else
                {
                    Create_Projectile(0, 4);
                    Create_Projectile(1, 4);
                }
            }

            samvar.shot_cnt = samvar.Beam_Data.refire_rate;
        }
        if(samvar.shot_cnt) samvar.shot_cnt --;
        if(debug_write) printf("End samus physics\n");
        Update_Projectiles();
        if(debug_write) printf("P");
        Update_Target_List();
        if(debug_write) printf("T");
        Update_Ridley();
        if(debug_write) printf("R");
        Update_Kraid();
        if(debug_write) printf("K");
        Update_Mother_Brain();
        if(debug_write) printf("B");
        Update_Kraid_Needles();
        if(debug_write) printf("N");
        Update_Kraid_Hooks();
        if(debug_write) printf("H");
        Compare_Targets_To_Projectiles();
        if(debug_write) printf("P");
        Update_Breakables();
        if(debug_write) printf("B");
        Update_Doors();
        if(debug_write) printf("D");
        Terminate_Projectiles();
        if(debug_write) printf("P");

        //Samstarts
        if(use_Samstart)
        {
            samvar.frame = 0;
        }

        //If the lockout is above 0, you can't move until it hits 0
        if(samvar.lockout_timer)
        {
            samvar.lockout_timer --;
            if(samvar.lockout_timer == 0) samvar.lockout_controls = false;
        }
        if(samvar.invincible_timer)
        {
            samvar.invincible_timer --;
        }

        Update_Spawners();
        if(debug_write) printf("S");

        if(!Samstart.active) Update_Enemies();
        if(!samvar.invincible_timer AND !Samstart.active) Compare_Enemy_Collision();
        if(samvar.screw_attack_active != -1) Compare_Targets_To_Screw_Attack();
        Update_Items();
        if(debug_write) printf("I");
        Update_Elevators();
        if(debug_write) printf("E");
        Update_Miniguns();
        if(debug_write) printf("M");
        if(elevator_clear_level) return;
        if(elevator_swap_music AND !music_fade_out)
        {
            elevator_swap_music = false;
            music_fade_in = true;
            music_fade_in_timer = 0;
        }
        Update_Transitions();
        if(debug_write) printf("T");
        samvar.is_in_acid = false;
        Update_Water_Zones();
        if(debug_write) printf("W");
        if(!samvar.is_in_acid)
        {
            samvar.acid_damage_timer = 60;
            BASS_ChannelStop(Audio.Acid);
        }
        else
        {
            BASS_ChannelPlay(Audio.Acid, false);
            samvar.acid_damage_timer --;
            if(samvar.acid_damage_timer < 1)
            {
                samvar.acid_damage_timer = 30;
                if(samvar.Using.varia_suit) samvar.acid_damage_timer = 60;
                samvar.energy --;
            }
        }

        Update_Sprites();
        if(debug_write) printf("S");
        Scroll_Camera();
        if(debug_write) printf("C");
        Lock_Camera_Within_Bounds();
        Update_Save_Zone();
        if(debug_write) printf("S");
        if(game_version == 1) Decide_Samus_Frame_Metroid();
        else if(game_version == 2) Decide_Samus_Frame_Return();
        if(debug_write) printf("F");
        if(debug_write) printf("\n");

        //Makes sure Samus has no more than max hp/missiles and no less than 1
        if(samvar.missiles > samvar.missiles_max) samvar.missiles = samvar.missiles_max;
        if(samvar.energy > samvar.energy_max) samvar.energy = samvar.energy_max;
    }
    ///////////////////////////////
    // Room Transition Code      //
    ///////////////////////////////
    else if(transition_stage == 1)
    {
        clear_to_color(transition_buffer_old, 0);
        clear_to_color(black_buf_old, 0);
        Update_Water_Zones();
        Draw_Water(transition_buffer_old, 1);
        Draw_Tiles(transition_buffer_old);
        Draw_Breakables(transition_buffer_old);
        Draw_Water(transition_buffer_old, 0);
        Unfade_Tiles(black_buf_old, vertical_scroll_dif % 16);

        printf("Destroying all\n");
        Destroy_All();
        printf("Destroyed all\n");
        bg_start_x = 0;
        bg_start_y = 0;
        if(random_game)
        {
            Create_Random_Level(false, false, rnd(5, 10), 0);
            transition_to[0] = 0;
        }
        else
        {
            Read_Level(transition_name, &Room);
        }

        //Music
        if(New_Music != Cur_Music)
        {
            music_fade_out = true;
            music_fade_out_timer = 100;
            music_fading_process = true;
        }

        if(transition_direction == LEFT)
        {
            camera.rgt = Room->xsize * 16;
            camera.lft = camera.rgt - 256;
        }
        else if(transition_direction == RIGHT)
        {
            camera.lft = 0;
            camera.rgt = 256;
        }

        if(transition_to[0] != 0)
        {
            int p = Retrieve_Transition(transition_to);
            if(p == -1)
            {
                printf("--- WARNING ILLEGAL DOOR VALUE DETECTED, DUMPING TO DOOR 0 ---\n");
                p = 0;
            }
            if(Transitions[p].doorhookval != -1)
            {
                if(Room->ysize == 16)
                {
                    camera.top = 0;
                    camera.bot = 256;
                }
                else
                {
                    camera.top = Transitions[p].doorhook->dim.top - 96;
                    camera.bot = Transitions[p].doorhook->dim.top - 96 + 256;
                }
                Lock_Camera_Within_Bounds();
                exit_distance_top = Transitions[p].dim.top;
                exit_distance_bot = (Room->ysize*16) - Transitions[p].dim.bot;
                Doors[Transitions[p].doorhookval].to_reclose = 180;
                Open_Door(Transitions[p].doorhookval);
                Update_Target_List();
                Remove_From_Target_List(&Doors[Transitions[p].doorhookval].health);
                use_Samstart = false;
                Samstart.active = false;
                if((Transitions[p].doorhook->facing & 1) == LEFT)
                {
                    samvar.x = Transitions[p].dim.lft - 8;
                    samvar.y = Transitions[p].dim.top + trans_y_dif;
                    camera.rgt = Transitions[p].dim.rgt;
                    camera.lft = camera.rgt - 256;
                }
                else if((Transitions[p].doorhook->facing & 1) == RIGHT)
                {
                    samvar.x = Transitions[p].dim.rgt+1;
                    samvar.y = Transitions[p].dim.top + trans_y_dif;
                    camera.lft = Transitions[p].dim.lft;
                    camera.rgt = camera.lft + 256;
                }
                cur_map_pos_x = (samvar.x/256) + Room->xpos;
                cur_map_pos_y = (samvar.y/256) + Room->ypos;
            }
        }
        else
        {
            if(random_game)
            {
                samvar.x = 32;
                samvar.y = 144 - trans_y_dif;
            }
            else
            {
                samvar.x = 100;
                samvar.y = 100;
            }
        }

        clear_to_color(transition_buffer_new, 0);
        clear_to_color(black_buf_new, 0);
        Update_Water_Zones();
        Draw_Water(transition_buffer_new, 1);
        Draw_Tiles(transition_buffer_new);
        Draw_Breakables(transition_buffer_new);
        Draw_Water(transition_buffer_new, 0);
        Unfade_Tiles(black_buf_new, 0);

        transition_stage = 2;
        transition_counter = 252;
        strclr(transition_to, 0);
        strclr(transition_name, 0);
    }
    else if(transition_stage == 2)//Fade out
    {
        transition_counter -= 4;
        if(transition_counter == 0)
        {
            transition_stage = 20;
            transition_counter = 0;
        }
    }
    else if(transition_stage == 20)
    {
        if(door_distance_bot == exit_distance_bot OR door_distance_top == exit_distance_top)
        {
            transition_counter = 0;
            vertical_scroll_dif = 0;
        }
        if(transition_counter < vertical_scroll_dif) transition_counter ++;
        else if(transition_counter > vertical_scroll_dif) transition_counter --;

        if(transition_counter == vertical_scroll_dif)
        {
            transition_stage = 3;
            transition_counter = 256;
        }
    }
    else if(transition_stage == 3)//Shift the rooms right or left
    {
        transition_counter -= 4;
        if(transition_counter == 0)
        {
            transition_stage = 4;
            transition_counter = 256;
        }
    }
    else if(transition_stage == 4)//Fade in
    {
        if(music_fading_process)
        {
            music_fading_process = false;
            music_fade_in = true;
            music_fade_in_timer = 0;
        }
        transition_counter -= 4;
        if(transition_counter == 0)
        {
            transition_stage = 0;
            //printf("Transition complete\n");
        }
    }
    else if(transition_by_elevator)
    {
        cur_map_pos_x = (samvar.x/256) + Room->xpos;
        cur_map_pos_y = (samvar.y/256) + Room->ypos;
        if(total_elevators == 0)
        {
            printf("ERROR:  Corresponding elevator not found!\n");
            transition_by_elevator = false;
            do_not_draw_samus = false;
            samvar.lockout_controls = false;
            samvar.lockout_timer = 0;
        }
        else
        {
            do_not_draw_samus = true;
            samvar.lockout_controls = true;
            samvar.lockout_timer = 10;
            if(Elevators[0].active)
            {
                Update_Water_Zones();
                elevator_trans_cooldown = 5;
                if(Elevators[0].direction == UP)
                {
                    Elevators[0].cur_y ++;
                    if(Elevators[0].cur_y >= 0)
                    {
                        do_not_draw_samus = false;
                        samvar.lockout_controls = false;
                        samvar.lockout_timer = 0;
                        samvar.x = Elevators[0].dim.lft + 12;
                        samvar.y = Elevators[0].dim.top - 30;
                        transition_by_elevator = false;
                        Elevators[0].in_use = false;
                    }
                }
                else if(Elevators[0].direction == DOWN)
                {
                    Elevators[0].cur_y --;
                    if(Elevators[0].cur_y <= 0)
                    {
                        do_not_draw_samus = false;
                        samvar.lockout_controls = false;
                        samvar.lockout_timer = 0;
                        samvar.x = Elevators[0].dim.lft + 12;
                        samvar.y = Elevators[0].dim.top - 30;
                        transition_by_elevator = false;
                        Elevators[0].in_use = false;
                    }
                }
            }
        }
    }
}
