void Create_Random_Level(bool starting, bool enters_from_left, int size, int items)
{
    Room = (ROOM *)calloc(1, sizeof(ROOM));
    Room->xsize = size * 16;
    Room->ysize = 16;

    camera_max.lft = 0;
    camera_max.top = 0;
    camera_max.rgt = Room->xsize * 16;
    camera_max.bot = Room->ysize * 16;

    //Create the physical clipping array
    cliparray = (unsigned char **)calloc(Room->xsize * 16, sizeof(unsigned char *));
    for(int i = 0; i < Room->xsize * 16; i ++)
    {
        cliparray[i] = (unsigned char *)calloc(Room->ysize * 16, sizeof(unsigned char));
    }

    //Create the tiles array
    Room->tiles = (int **)malloc(Room->xsize * sizeof(int *));
    for(int i = 0; i < Room->xsize; i ++) Room->tiles[i] = (int *)malloc(Room->ysize * sizeof(int));

    //Create the clips array
    Room->clips = (int **)malloc(Room->xsize * sizeof(int *));
    for(int i = 0; i < Room->xsize; i ++) Room->clips[i] = (int *)malloc(Room->ysize * sizeof(int));

    for(int x = 0; x < Room->xsize; x ++)
    {
        for(int y = 0; y < Room->ysize; y ++)
        {
            Room->tiles[x][y] = 0;
        }
    }
    if(starting)
    {
        FILE *input = NULL;
		#ifdef PANDORA
        input = fopen("Rooms/Random/Brinstar/Horizontal/Starting.mcl", "rb");
		#else
        input = fopen("Rooms\\Random\\Brinstar\\Horizontal\\Starting.mcl", "rb");
		#endif
        if(input)
        {
            int inbyte = 0;
            //Seek through the Version data
            fread(&inbyte, sizeof(char), 4, input);

            //Read the posinfo data
            fread(Room->posinfo, sizeof(int), 10, input);

            //Skip the x/y data
            fread(&inbyte, sizeof(int), 1, input);
            fread(&inbyte, sizeof(int), 1, input);

            //Tiles data
            for(int y = 0; y < 16; y ++)
            {
                for(int x = 0; x < 48; x ++)
                {
                    fread(&Room->tiles[x][y], sizeof(int), 1, input);
                }
            }
            //Clips Data
            for(int y = 0; y < 16; y ++)
            {
                for(int x = 0; x < 48; x ++)
                {
                    fread(&Room->clips[x][y], sizeof(int), 1, input);
                }
            }

            Create_Clips(Room->xsize, Room->ysize, Room->clips);
            Create_Door("Rnd01", 736, 96, RIGHT);

            printf("\nPosinfo: ");
            for(int i = 0; i < 7; i ++)
            {
                printf("%i ", Room->posinfo[i]);
            }
            printf("\n");
            fclose(input);
        }
    }
    else
    {
        char path[300];
        int number = 0;
        char numbuffer[3];
        for(int xpos = 0; xpos < size; xpos ++)
        {
			#ifdef PANDORA
            Init_String(path, "Rooms/Random/Brinstar/Horizontal/", 300);
			#else
            Init_String(path, "Rooms\\Random\\Brinstar\\Horizontal\\", 300);
			#endif
            strclr(numbuffer, 3);
            if(xpos == 0) //Entry
            {
                strcat(path, "EntryL0");
                number = rnd(0, 2);
                itoa(number, numbuffer, 10);
                strcat(path, numbuffer);
                strcat(path, ".mcl");
            }
            else if(xpos == size-1) //Exit
            {
                strcat(path, "ExitR0");
                number = rnd(0, 2);
                itoa(number, numbuffer, 10);
                strcat(path, numbuffer);
                strcat(path, ".mcl");
            }
            else //Middle
            {
                strcat(path, "Mid0");
                number = rnd(0, 5);
                itoa(number, numbuffer, 10);
                strcat(path, numbuffer);
                strcat(path, ".mcl");
            }
            printf("Read_Level: %s\n", path);
            FILE *input = NULL;
            input = fopen(path, "rb");
            if(input)
            {
                int inbyte = 0;
                //Seek through the Version data
                fread(&inbyte, sizeof(char), 4, input);

                //Read the posinfo data
                fread(Room->posinfo, sizeof(int), 10, input);

                //Skip the x/y data
                fread(&inbyte, sizeof(int), 1, input);
                fread(&inbyte, sizeof(int), 1, input);

                //Tiles data
                for(int y = 0; y < 16; y ++)
                {
                    for(int x = 0; x < 16; x ++)
                    {
                        fread(&Room->tiles[x+(xpos*16)][y], sizeof(int), 1, input);
                    }
                }
                //Clips Data
                for(int y = 0; y < 16; y ++)
                {
                    for(int x = 0; x < 16; x ++)
                    {
                        fread(&Room->clips[x+(xpos*16)][y], sizeof(int), 1, input);
                    }
                }

                printf("\nPosinfo: ");
                for(int i = 0; i < 7; i ++)
                {
                    printf("%i ", Room->posinfo[i]);
                }
                printf("\n");
            }
            fclose(input);
        }
        Create_Clips(Room->xsize, Room->ysize, Room->clips);
        Create_Door("Rnd01", (size*256)-24, 96, LEFT);
        Create_Transition_Zone("Random", "Rnd01", (size*256)-16, 96, (size*256), 144, RIGHT, "Random", "None");
    }
}
