void Init_Ridley(int x, int y)
{
    Ridley.active = true;
    Ridley.x = x * 16;
    Ridley.y = (y * 16) - 46;
    Ridley.dim.lft = Ridley.x;
    Ridley.dim.rgt = Ridley.x + 31;
    Ridley.dim.top = Ridley.y;
    Ridley.dim.bot = Ridley.y + 46;
    Ridley.health = 288;
    Ridley.damage = 6;
    Ridley.speed_modifier = 1;
    Ridley.vulnerabilities = BEAM_DAMAGE + BEAM_MISSILE + BEAM_BOMB + BEAM_BURN;
    Ridley.images[0] = Create_Image_From_MCI(Master_MCI, "Ridley_Stand0", 0);
    Ridley.images[1] = Create_Image_From_MCI(Master_MCI, "Ridley_Stand1", 0);
    Ridley.images[2] = Create_Image_From_MCI(Master_MCI, "Ridley_Jump0", 0);
    Ridley.images[3] = Create_Image_From_MCI(Master_MCI, "Ridley_Jump1", 0);
    Ridley.fireball_img = Ridley_Fireball;
    Ridley.to_show = 0;
    Ridley.to_show_timer = 0;
    Ridley.team = 1;
    Ridley.Sound = &Audio.Injured_Boss;
    Ridley.stun_timer = 0;
    Ridley.immune.codes = NULL;
    Ridley.immune.total_codes = 0;

    Ridley.jumping = false;
    Ridley.jump_up= false;;
    Ridley.timer = 0;
    for(int i = 0; i < 5; i ++)
    {
        Ridley.Fireball[i].active = false;
    }
    Ridley.fireball_timer = 0;
    Add_To_Target_List(TARGET_RIDLEY, 0);
}

void Destroy_Ridley()
{
    Ridley.active = false;
    if(Ridley.immune.codes) free(Ridley.immune.codes);
    Ridley.immune.codes = NULL;
    Remove_From_Target_List(&Ridley.health);
    samvar.ridley_dead = true;
}

void Immunize_Ridley_From_Beam(int beamcode)
{
    for(int e = 0; e < Ridley.immune.total_codes; e ++)
    {
        if(Ridley.immune.codes[e] == beamcode) //Already immune to this one
        {
            return;
        }
    }
    //If the beam isn't already in the array, add it
    Ridley.immune.codes = (int *)realloc(Ridley.immune.codes, sizeof(int) * (Ridley.immune.total_codes+1));
    Ridley.immune.codes[Ridley.immune.total_codes] = beamcode;
    Ridley.immune.total_codes ++;
}

void Update_Ridley()
{
    for(int i = 0; i < 5; i ++)
    {
        if(Ridley.Fireball[i].active)
        {
            Ridley.Fireball[i].lifespan --;
            if(Ridley.Fireball[i].lifespan <= 0) Ridley.Fireball[i].active = false;
            Ridley.Fireball[i].xspeed += Ridley.Fireball[i].xforce;
            Ridley.Fireball[i].yspeed += Ridley.Fireball[i].yforce;
            Move_Fireball(i, Ridley.Fireball[i].xspeed, Ridley.Fireball[i].yspeed);
            if(!samvar.invincible_timer AND samvar.screw_attack_active == -1 AND rect_clip(samvar.dim, Ridley.Fireball[i].x, Ridley.Fireball[i].y, Ridley.Fireball[i].x+7, Ridley.Fireball[i].y+7) AND Ridley.Fireball[i].active)
            {
                Injure_Samus(16);
            }
        }
    }
    if(Ridley.active)
    {
        if(Ridley.health < 1)
        {
            Tear_Ridley_Into_Giblets(2, 2);
            Destroy_Ridley();Cut_All_Audio_Switches();
            kill_audio = true;
            BASS_ChannelPlay(Audio.Get_Item_Music, true);
            item_lockout_timer = 300;
            samvar.missiles += 75;
            samvar.missiles_max += 75;
        }
        if(Ridley.stun_timer > 0)
        {
            Ridley.stun_timer --;
            Ridley.palette = 1;
            return;
        }
        Ridley.palette = 0;
        Ridley.timer ++;
        Ridley.to_show_timer ++;
        if(Ridley.to_show_timer > 7) Ridley.to_show_timer = 0;
        if(!Ridley.jumping)//On the ground
        {
            if(Ridley.timer == 60 OR Ridley.timer == 55 OR Ridley.timer == 50 OR Ridley.timer == 45 OR Ridley.timer == 40)
                Create_Ridley_Fireball(Ridley.x+31, Ridley.y+8, (float)rnd(10, 5)/(10.0), (float)rnd(30, 10)/(-10.0), 0, 0.2);
            if(Ridley.timer >= 64)
            {
                Ridley.timer = 0;
                Ridley.jumping = true;
                Ridley.jump_up = true;
                Ridley.to_show = (Ridley.to_show_timer / 4) + 2;
            }
            else
            {
                Ridley.to_show = Ridley.to_show_timer / 4;
            }
        }
        else //In the air
        {
            if(Ridley.jump_up) //Rising
            {
                if(Ridley.y <= 66)
                {
                    Ridley.jump_up = false;
                }
                else if(Ridley.y < 76)
                {
                    Ridley.y --;
                }
                else
                {
                    Ridley.y -= 2;
                }
                Ridley.to_show = (Ridley.to_show_timer / 4) + 2;
            }
            else //Falling
            {
                if(Ridley.y >= 98)
                {
                    Ridley.jumping = false;
                    Ridley.timer = 0;
                    Ridley.to_show = Ridley.to_show_timer / 4;
                }
                else if(Ridley.y > 76)
                {
                    Ridley.y += 2;
                    Ridley.to_show = (Ridley.to_show_timer / 4) + 2;
                }
                else
                {
                    Ridley.y ++;
                    Ridley.to_show = (Ridley.to_show_timer / 4) + 2;
                }
            }
        }
        Ridley.dim.lft = Ridley.x + 15;
        Ridley.dim.rgt = Ridley.x + 31;
        Ridley.dim.top = Ridley.y + 7;
        Ridley.dim.bot = Ridley.y + 45;
        if(!samvar.invincible_timer AND samvar.screw_attack_active == -1 AND rect_clip(samvar.dim, Ridley.dim) AND Ridley.active)
        {
            Injure_Samus(Ridley.damage);
        }
    }
}

void Damage_Ridley(int p)
{
    for(int i = 0; i < Ridley.immune.total_codes; i ++)
    {
        if(Ridley.immune.codes[i] == Projectiles[p]->beamcode) return;
    }
    Ridley.stun_timer = 3;
    Ridley.health -= Projectiles[p]->damage;
    BASS_ChannelPlay(*Ridley.Sound, true);
    if(!Projectiles[p]->penetrate_enemy) Projectiles[p]->terminate = true;
    else Immunize_Ridley_From_Beam(Projectiles[p]->beamcode);
}

void Move_Fireball(int i, int xdist, int ydist)
{
    int emergency_counter = 100; //Prevent a crash from a bug
    while(emergency_counter AND (xdist OR ydist))
    {
        emergency_counter --;
        if(xdist > 0)
        {
            if(!Scan_Clips_Y(Ridley.Fireball[i].y, Ridley.Fireball[i].y+8, Ridley.Fireball[i].x+8, 0x02))
            {
                Ridley.Fireball[i].x ++;
                xdist --;
            }
            else
            {
                Ridley.Fireball[i].xspeed *= -1;
                xdist --;
                xdist *= -1;
            }
        }
        else if(xdist < 0)
        {
            if(!Scan_Clips_Y(Ridley.Fireball[i].y, Ridley.Fireball[i].y+8, Ridley.Fireball[i].x-1, 0x02))
            {
                Ridley.Fireball[i].x --;
                xdist ++;
            }
            else
            {
                Ridley.Fireball[i].xspeed *= -1;
                xdist ++;
                xdist *= -1;
            }
        }
        if(ydist > 0)
        {
            if(!Scan_Clips_X(Ridley.Fireball[i].x, Ridley.Fireball[i].x+8, Ridley.Fireball[i].y+9, 0x02))
            {
                Ridley.Fireball[i].y ++;
                ydist --;
            }
            else 
            {
                ydist = 0;
                Ridley.Fireball[i].yspeed = -5;
            }
        }
        else if(ydist < 0)
        {
            if(!Scan_Clips_X(Ridley.Fireball[i].x, Ridley.Fireball[i].x+8, Ridley.Fireball[i].y-1, 0x02))
            {
                Ridley.Fireball[i].y --;
                ydist ++;
            }
            else
            {
                ydist = 0;
                Ridley.Fireball[i].yspeed = 0;
            }
        }
    }
}

void Create_Ridley_Fireball(int x, int y, float xspeed, float yspeed, float xforce, float yforce)
{
    for(int i = 0; i < 5; i ++)
    {
        if(Ridley.Fireball[i].active == false)
        {
            Ridley.Fireball[i].active = true;
            Ridley.Fireball[i].x = x;
            Ridley.Fireball[i].y = y;
            Ridley.Fireball[i].xspeed = xspeed;
            Ridley.Fireball[i].yspeed = yspeed;
            Ridley.Fireball[i].xforce = xforce;
            Ridley.Fireball[i].yforce = yforce;
            Ridley.Fireball[i].rotation = 0;
            Ridley.Fireball[i].lifespan = 110; //When 0, terminate the fireball
            return;
        }
    }
}

void Draw_Ridley(BITMAP *output)
{
    for(int i = 0; i < 5; i ++)
    {
        if(Ridley.Fireball[i].active)
        {
            draw_sprite_palette(output, Ridley.fireball_img, Ridley.Fireball[i].x-camera.lft, Ridley.Fireball[i].y-camera.top, 0);
        }
    }
    if(Ridley.active)
    {
        if(Ridley.jumping)
        {
            draw_sprite_palette(output, Ridley.images[Ridley.to_show], Ridley.x-camera.lft, Ridley.y+7-camera.top, Ridley.palette);
        }
        else
        {
            draw_sprite_palette(output, Ridley.images[Ridley.to_show], Ridley.x-camera.lft, Ridley.y-camera.top, Ridley.palette);
        }
        if(samvar.draw_collision) rect(output, Ridley.dim.lft-camera.lft, Ridley.dim.top-camera.top, Ridley.dim.rgt - camera.lft, Ridley.dim.bot - camera.top, makecol(0, 255, 0)); //Clipping
    }
}

void Tear_Ridley_Into_Giblets(int xstep, int ystep)
{
    int p;
    for(int x = 0; x < Ridley.images[Ridley.to_show]->xsize; x += xstep)
    {
        for(int y = 0; y < Ridley.images[Ridley.to_show]->ysize; y += ystep)
        {
            if(Check_If_Valid_Giblet(Ridley.images[Ridley.to_show], x, y, x+xstep, y+ystep))
            {
                Create_Ridley_Gib(Ridley.images[Ridley.to_show], x, y, x+xstep, y+ystep);
                p = Create_Sprite(Ridley.x+x, Ridley.y+y, Ridley.x+x+xstep, Ridley.y+y+ystep, 0, 1, -1);
                Imagize_Sprite_Giblet(p, Ridley_Gibs[total_ridley_gibs-1]);
            }
        }
    }
}

void Create_Ridley_Gib(CUSTOM_IMAGE *src, int lft, int top, int rgt, int bot)
{
    if(lft < 0) lft = 0;
    if(top < 0) top = 0;
    if(rgt > src->xsize) rgt = src->xsize;
    if(bot > src->ysize) bot = src->ysize;
    Ridley_Gibs = (CUSTOM_IMAGE **)realloc(Ridley_Gibs, sizeof(CUSTOM_IMAGE*) * (total_ridley_gibs+1));
    Ridley_Gibs[total_ridley_gibs] = Create_Copy_Of_Custom_Image(src, lft, top, rgt, bot);
    total_ridley_gibs ++;
}

//If all the pixels in that zone are transparent, it can't be used.
bool Check_If_Valid_Giblet(CUSTOM_IMAGE *src, int lft, int top, int rgt, int bot)
{
    if(lft < 0) lft = 0;
    if(top < 0) top = 0;
    if(rgt > src->xsize) rgt = src->xsize;
    if(bot > src->ysize) bot = src->ysize;
    for(int x = lft; x < rgt; x ++)
    {
        for(int y = top; y < bot; y ++)
        {
            if(src->image[x][y] != 0) return true;
        }
    }
    return false;
}
