int Create_Rinka(int x, int y, bool unused, int unused_2)
{
    for(int i = 0; i < total_rinkas; i ++) //Scan the old enemies to see if one is unused
    {
        if(!Rinka[i].active)
        {
            Place_Rinka_In_Slot(i, x, y);
            return 0;
        }
    }
    if(total_rinkas == 3) return 0;
    Rinka = (RINKA *)realloc(Rinka, sizeof(RINKA) * (total_rinkas + 1));

    Place_Rinka_In_Slot(total_rinkas, x, y);
    total_rinkas ++;
    return 0;
}

void Place_Rinka_In_Slot(int i, int x, int y)
{
    Rinka[i].active = true;
    Rinka[i].damage = 30;
    Rinka[i].x = x;
    Rinka[i].y = y;
    Rinka[i].health = 1;
    Rinka[i].freeze_timer = 0;
    Rinka[i].dim.lft = x;
    Rinka[i].dim.top = y;
    Rinka[i].dim.rgt = x+12;
    Rinka[i].dim.bot = y+12;

    Update_Samus_Clips();
    float xspot = (float)(((samvar.dim.lft+samvar.dim.rgt)/2) - (x+8));
    float yspot = (float)(((samvar.dim.top+samvar.dim.bot)/2) - (y+8));
    Rinka[i].angle = (atan2(yspot, xspot) * 180.0 / PI);
    Rinka[i].xspeed = cos(Rinka[i].angle*PI/180.0) * 0.75;
    Rinka[i].yspeed = sin(Rinka[i].angle*PI/180.0) * 0.75;
    Add_To_Target_List(TARGET_RINKA, i);
}

void Update_Rinka(int i)
{
    if(Rinka[i].active)
    {
        if(Rinka[i].refreeze_timer > 0) Rinka[i].refreeze_timer --;
        else Rinka[i].refreeze_timer = 0;
        Rinka[i].show_freeze = 0;
        if(Rinka[i].health < 1)
        {
            Rinka[i].active = false;
            int spritenum = Create_Sprite(Rinka[i].dim.lft-8, Rinka[i].dim.top-8, 3, 2, 6);
            if(spritenum != -1) Imagize_Sprite_Explosion(spritenum);
            Remove_From_Target_List(&Rinka[i].health);
            Unclip_Area(Rinka[i].dim, STOP_FREEZE);
            return;
        }
        if(Rinka[i].freeze_timer > 0)
        {
            Freeze_Clip_Area(Rinka[i].dim, STOP_FREEZE);
            Rinka[i].freeze_timer --;
            if(Rinka[i].freeze_timer == 0) Unclip_Area(Rinka[i].dim, STOP_FREEZE);
            Rinka[i].show_freeze = 1;
            if(Rinka[i].freeze_timer < 120 AND Rinka[i].freeze_timer % 4 < 2)
            {
                Rinka[i].show_freeze = 0;
            }
            return;
        }
        Rinka[i].x += Rinka[i].xspeed;
        Rinka[i].y += Rinka[i].yspeed;
        Rinka[i].dim.lft = Rinka[i].x;
        Rinka[i].dim.top = Rinka[i].y;
        Rinka[i].dim.rgt = Rinka[i].x+12;
        Rinka[i].dim.bot = Rinka[i].y+12;

        if(Rinka[i].dim.lft < 0 OR Rinka[i].dim.rgt > Room->xsize*16 OR Rinka[i].dim.top < 0 OR Rinka[i].dim.bot > Room->ysize*16)
            Rinka[i].active = false;
    }
}

void Draw_Rinkas(BITMAP *output)
{
    for(int i = 0; i < total_rinkas; i ++)
    {
        if(Rinka[i].active AND rect_clip(Rinka[i].dim, camera))
        {
            draw_sprite_palette(output, Rinka_img, Rinka[i].dim.lft-camera.lft, Rinka[i].dim.top-camera.top, Rinka[i].show_freeze);
        }
    }
}
