////////////////////////////////////////////////////////////////////////////////
//  Rippers
//
//  No substructure
////////////////////////////////////////////////////////////////////////////////

int Create_Ripper(int x, int y, bool hardtype, int type)
{
    for(int i = 0; i < total_enemies; i ++) //Scan the old enemies to see if one is unused
    {
        if(!Enemies[i]->active)
        {
            Place_Ripper_In_Slot(i, x, y, hardtype, type);
            return i;
        }
    }
    Enemies = (ENEMY **)realloc(Enemies, sizeof(ENEMY *) * (total_enemies + 1));
    Enemies[total_enemies] = (ENEMY *)malloc(sizeof(ENEMY));
    Enemies[total_enemies]->substructure = NULL;
    Enemies[total_enemies]->display.images = NULL;
    Enemies[total_enemies]->immune.codes = NULL;

    Place_Ripper_In_Slot(total_enemies, x, y, hardtype, type);
    total_enemies ++;
    return total_enemies - 1;
}

void Place_Ripper_In_Slot(int i, int x, int y, bool hardtype, int type)
{
    Enemies[i]->active = true;
    Enemies[i]->type_flag = RIPPER;
    Enemies[i]->funcptr = &Update_Ripper;
    Enemies[i]->substructure = NULL;
    Enemies[i]->size_of_substructure = 0;
    Enemies[i]->coord.x = x;
    Enemies[i]->coord.y = y;
    Enemies[i]->bound.lft = Enemies[i]->coord.x;
    Enemies[i]->bound.top = Enemies[i]->coord.y;
    Enemies[i]->bound.rgt = Enemies[i]->coord.x + 16;
    Enemies[i]->bound.bot = Enemies[i]->coord.y + 8;
    Enemies[i]->coord.orientation = RIGHT;
    Enemies[i]->stats.health = 1;
    if(hardtype) Enemies[i]->stats.health *= 2;
    Enemies[i]->stats.hardtype = hardtype;
    Enemies[i]->stats.damage = 5;
    Enemies[i]->stats.speed_modifier = 1;
    Enemies[i]->stats.vulnerabilities = BEAM_MISSILE + BEAM_ICE;
    if(Enemies[i]->display.images) free(Enemies[i]->display.images);
    Enemies[i]->display.images = (CUSTOM_IMAGE **)malloc(sizeof(CUSTOM_IMAGE *) * 1);
    Enemies[i]->display.images[0] = Enemy_Images[8];
    Enemies[i]->display.to_show = 0;
    Enemies[i]->display.rotation = 0;
    Enemies[i]->display.vflip = false;
    Enemies[i]->display.hflip = false;
    Enemies[i]->team = 1;
    Enemies[i]->Sound = &Audio.Injured_Small;
    Enemies[i]->stun_timer = 0;
    Enemies[i]->freeze_timer = 0;
    Enemies[i]->refreeze_timer = 0;
    Add_To_Target_List(TARGET_ENEMY, i);

    if(Enemies[i]->immune.codes) free(Enemies[i]->immune.codes);
    Enemies[i]->immune.codes = NULL;
    Enemies[i]->immune.total_codes = 0;
}

void Update_Ripper(int i)
{
    if(Enemies[i]->stats.health <= 0) //Ripper is dead :(
    {
        Create_Random_Item(Enemies[i]->bound, SMALLTYPE, false);
        int spritenum = Create_Sprite(((Enemies[i]->bound.lft+Enemies[i]->bound.rgt)/2)-16, ((Enemies[i]->bound.top+Enemies[i]->bound.bot)/2)-16, 3, 2, 6);
        if(spritenum != -1) Imagize_Sprite_Explosion(spritenum);
        Enemies[i]->active = false;
        Remove_From_Target_List(&Enemies[i]->stats.health);
        Unclip_Area(Enemies[i]->bound, STOP_FREEZE);
        return;
    }
    if(Enemies[i]->stun_timer > 0)
    {
        Enemies[i]->stun_timer --;
        return;
    }
    if(Enemies[i]->freeze_timer > 0)
    {
        Freeze_Clip_Area(Enemies[i]->bound, STOP_FREEZE);
        Enemies[i]->freeze_timer --;
        if(Enemies[i]->freeze_timer == 0) Unclip_Area(Enemies[i]->bound, STOP_FREEZE);
        if(Enemies[i]->freeze_timer < 50)
        {
            if((Enemies[i]->freeze_timer % 4) < 2)
            {
                Enemies[i]->palette = 2;
            }
            else
            {
                if(Enemies[i]->stats.hardtype) Enemies[i]->palette = 1;
                else Enemies[i]->palette = 0;
            }
        }
        else
        {
            Enemies[i]->palette = 2;
        }
        return;
    }
    if(Enemies[i]->stats.hardtype) Enemies[i]->palette = 1;
    else Enemies[i]->palette = 0;

    Enemies[i]->bound.lft = Enemies[i]->coord.x;
    Enemies[i]->bound.top = Enemies[i]->coord.y;
    Enemies[i]->bound.rgt = Enemies[i]->coord.x + 16;
    Enemies[i]->bound.bot = Enemies[i]->coord.y + 8;

    //Going right
    if(Enemies[i]->coord.orientation == RIGHT)
    {
        Enemies[i]->coord.x ++;
        Enemies[i]->display.hflip = false;
        if(Scan_Clips_Y(Enemies[i]->bound.top, Enemies[i]->bound.bot, Enemies[i]->coord.x + 16, STOP_ENEMY))
        {
            Enemies[i]->coord.orientation = LEFT;
        }
    }
    else if(Enemies[i]->coord.orientation == LEFT)
    {
        Enemies[i]->coord.x --;
        Enemies[i]->display.hflip = true;
        if(Scan_Clips_Y(Enemies[i]->bound.top, Enemies[i]->bound.bot, Enemies[i]->coord.x, STOP_ENEMY))
        {
            Enemies[i]->coord.orientation = RIGHT;
        }
    }
}
