int Read_Config_File(char path[])
{
    FILE *script = NULL;
    if(!(script = fopen(path, "r+")))
    {
        return 1; //File not found, no CFG
    }

    char *instring = (char *)malloc(sizeof(char) * 257);

    while(!feof(script))
    {
        strclr(instring, 256);
        fgets(instring, 256, script);
        instring[Char_Search(instring, 10)] = 0;
        instring[Char_Search(instring, 13)] = 0;
        if(instring[0] == '/' AND instring[1] == '/')
        {
            //Do nothing, this line is ignored
        }
        else if(!strncmp(instring, "cvar.", 5))
        {
            int len;
            char **words = Collect_All_Words(instring, &len);
            String_Shift(words[0], 5);
            Remove_Quotes(words[1]);
            CVAR *tempvar = Find_CVar(words[0]);
            if(tempvar)
            {
                if(tempvar->is_int_type) //Integer type
                {
                    Update_CVar(tempvar, atoi(words[1]));
                }
                else //String type
                {
                    Update_CVar(tempvar, words[1]);
                }
            }
        }
    }
    if(script) fclose(script);
    return 0;
}

//Returns a point to the CVar in question
CVAR *Find_CVar(char name[])
{
    for(int i = 0; i < total_cvars; i ++)
    {
        if(!strcmp(CVars[i].name, name)) return &CVars[i];
    }
    return NULL;
}

int Get_Cvar_Value_I(char name[]) //Returns -7000 if invalid, be warned
{
    for(int i = 0; i < total_cvars; i ++)
    {
        if(!strcmp(CVars[i].name, name)) return CVars[i].valuei;
    }
    return -7000;
}

char *Get_Cvar_Value_C(char name[])
{
    for(int i = 0; i < total_cvars; i ++)
    {
        if(!strcmp(CVars[i].name, name)) return CVars[i].valuec;
    }
    return NULL;
}

void Update_CVar(CVAR *CVar, int number)
{
    CVar->valuei = number;
    printf("CVar %s changed to %i\n", CVar->name, CVar->valuei);
}

void Update_CVar(CVAR *CVar, char string[])
{
	if (CVar->valuec)
		CVar->valuec = (char *)realloc(CVar->valuec, sizeof(char) * (strlen(string)+1));
	else
		CVar->valuec = (char *)malloc(sizeof(char) * (strlen(string)+1));
    Init_String(CVar->valuec, string, strlen(string));
}
