//Shots travel 4 pixels per frame for 11 frames by default
void Create_Projectile(int reverse_flag, int special_flag)
{
    for(int i = 0; i < total_projectiles; i ++)
    {
        if(Projectiles[i]->owner_flag == -1)
        {
            Place_Shot_In_Slot(i, reverse_flag, special_flag);
            return;
        }
    }

    Projectiles = (PROJECTILE **)realloc(Projectiles, sizeof(PROJECTILE *) * (total_projectiles + 1));
    Projectiles[total_projectiles] = (PROJECTILE *)malloc(sizeof(PROJECTILE));
    Projectiles[total_projectiles]->images = NULL;

    Place_Shot_In_Slot(total_projectiles, reverse_flag, special_flag);

    total_projectiles ++;
}

void Place_Shot_In_Slot(int i, int reverse_flag, int special_flag)
{
    Projectiles[i]->owner_flag = 0;
    Projectiles[i]->duration = samvar.Beam_Data.duration;
    Projectiles[i]->dim.lft = samvar.Beam_Data.origin_x;
    Projectiles[i]->dim.top = samvar.Beam_Data.origin_y;
    Projectiles[i]->dim.rgt = samvar.Beam_Data.origin_x+samvar.Beam_Data.width;
    Projectiles[i]->dim.bot = samvar.Beam_Data.origin_y+samvar.Beam_Data.height;
    Projectiles[i]->clip.lft = samvar.Beam_Data.origin_x;
    Projectiles[i]->clip.top = samvar.Beam_Data.origin_y;
    Projectiles[i]->clip.rgt = samvar.Beam_Data.origin_x+samvar.Beam_Data.width;
    Projectiles[i]->clip.bot = samvar.Beam_Data.origin_y+samvar.Beam_Data.height;
    Projectiles[i]->clip_dif.lft = samvar.Beam_Data.clip_dif.lft;
    Projectiles[i]->clip_dif.top = samvar.Beam_Data.clip_dif.top;
    Projectiles[i]->clip_dif.rgt = samvar.Beam_Data.clip_dif.rgt;
    Projectiles[i]->clip_dif.bot = samvar.Beam_Data.clip_dif.bot;
    Projectiles[i]->image_num = 1;
    if(Projectiles[i]->images) free(Projectiles[i]->images);
    Projectiles[i]->images = (CUSTOM_IMAGE **)malloc(sizeof(CUSTOM_IMAGE *) * Projectiles[i]->image_num);
    Projectiles[i]->images[0] = samvar.Beam_Data.image;
    Projectiles[i]->image_show = 0;
    Projectiles[i]->image_numer = 0;
    Projectiles[i]->image_denom = 0;
    Projectiles[i]->xspeed = samvar.Beam_Data.xspeed;
    Projectiles[i]->yspeed = samvar.Beam_Data.yspeed;
    Projectiles[i]->xremainder = 0;
    Projectiles[i]->yremainder = 0;
    Projectiles[i]->damage = samvar.Beam_Data.damage;
    Projectiles[i]->properties = samvar.Beam_Data.properties;
    Projectiles[i]->facing = samvar.Beam_Data.facing;
    Projectiles[i]->terminate = false;
    Projectiles[i]->missile_terminate = false;

    Projectiles[i]->penetrate_enemy = samvar.Beam_Data.penetrate_enemy;
    Projectiles[i]->penetrate_world = samvar.Beam_Data.penetrate_world;
    Projectiles[i]->bomb = false;
    Projectiles[i]->beamcode = global_projectiles_fired;

    Projectiles[i]->width = samvar.Beam_Data.width;
    Projectiles[i]->height = samvar.Beam_Data.height;
    Projectiles[i]->palette = samvar.Beam_Data.palette;
    Projectiles[i]->vibrate_range = 0;
    Projectiles[i]->timer = samvar.Beam_Data.start_timer;
    Projectiles[i]->helix_draw = false;
    Projectiles[i]->img_offset_x = samvar.Beam_Data.img_offset_x;
    Projectiles[i]->img_offset_y = samvar.Beam_Data.img_offset_y;
    Projectiles[i]->not_less_than_pos = samvar.Beam_Data.not_less_than_pos;
    Projectiles[i]->damage_cooldown = 1;

    if(special_flag == 1) //This is a wave beam.  Vibrate!
    {
        Projectiles[i]->reverse = samvar.shot_reverse;
        samvar.shot_reverse = !samvar.shot_reverse;
        if(Projectiles[i]->facing == RIGHT OR Projectiles[i]->facing == LEFT) Projectiles[i]->lock_position = samvar.Beam_Data.origin_y;
        else Projectiles[i]->lock_position = samvar.Beam_Data.origin_x;
        Projectiles[i]->vibrate_range = 12;
        global_projectiles_fired ++;
    }
    else if(special_flag == 2) //This is a Spazer/Wave beam.  Vibrate (less!)
    {
        Projectiles[i]->reverse = reverse_flag;
        if(Projectiles[i]->facing == RIGHT OR Projectiles[i]->facing == LEFT) Projectiles[i]->lock_position = samvar.Beam_Data.origin_y;
        else Projectiles[i]->lock_position = samvar.Beam_Data.origin_x;
        Projectiles[i]->vibrate_range = 8;
        global_projectiles_fired ++;
    }
    else if(special_flag == 3) //This is a Plasma/Wave beam.  Vibrate (a lot!)
    {
        Projectiles[i]->reverse = reverse_flag;
        if(Projectiles[i]->facing == RIGHT OR Projectiles[i]->facing == LEFT) Projectiles[i]->lock_position = samvar.Beam_Data.origin_y;
        else Projectiles[i]->lock_position = samvar.Beam_Data.origin_x;
        Projectiles[i]->vibrate_range = 6;
    }
    else if(special_flag == 4) //This is a Helix beam.  Vibrate!
    {
        Projectiles[i]->reverse = reverse_flag;
        if(Projectiles[i]->facing == RIGHT OR Projectiles[i]->facing == LEFT) Projectiles[i]->lock_position = samvar.Beam_Data.origin_y;
        else Projectiles[i]->lock_position = samvar.Beam_Data.origin_x;
        Projectiles[i]->vibrate_range = 8;
        Projectiles[i]->helix_draw = true;
        if(Projectiles[i]->facing == LEFT OR Projectiles[i]->facing == RIGHT)
        {
            Projectiles[i]->dim.top -= 9;
        }
        global_projectiles_fired ++;
    }
    else
    {
        global_projectiles_fired ++;
    }
}

void Create_Bomb(int x, int y)
{
    for(int i = 0; i < total_projectiles; i ++)
    {
        if(Projectiles[i]->owner_flag == -1)
        {
            Place_Bomb_In_Slot(i, x, y);
            return;
        }
    }
    Projectiles = (PROJECTILE **)realloc(Projectiles, sizeof(PROJECTILE *) * (total_projectiles + 1));

    Projectiles[total_projectiles] = (PROJECTILE *)malloc(sizeof(PROJECTILE));
    Place_Bomb_In_Slot(total_projectiles, x, y);
    total_projectiles ++;
}

void Place_Bomb_In_Slot(int i, int x, int y)
{
    Projectiles[i]->properties = BEAM_BOMB;

    Projectiles[i]->owner_flag = 0;
    Projectiles[i]->duration = 72;
    Projectiles[i]->dim.lft = x;
    Projectiles[i]->dim.rgt = x + 8;
    Projectiles[i]->dim.top = y;
    Projectiles[i]->dim.bot = y + 8;
    Projectiles[i]->clip.lft = x;
    Projectiles[i]->clip.rgt = x + 8;
    Projectiles[i]->clip.top = y;
    Projectiles[i]->clip.bot = y + 8;
    Projectiles[i]->clip_dif.lft = 0;
    Projectiles[i]->clip_dif.rgt = 8;
    Projectiles[i]->clip_dif.top = 0;
    Projectiles[i]->clip_dif.bot = 8;
    Projectiles[i]->xspeed = 0;
    Projectiles[i]->yspeed = 0;
    Projectiles[i]->xremainder = 0;
    Projectiles[i]->yremainder = 0;
    Projectiles[i]->damage = 2;
    Projectiles[i]->penetrate_enemy = false;
    Projectiles[i]->penetrate_world = false;
    Projectiles[i]->image_num = 2;
    Projectiles[i]->images = (CUSTOM_IMAGE **)malloc(sizeof(CUSTOM_IMAGE *) * Projectiles[i]->image_num);
    Projectiles[i]->images[0] = Shot_bomb[0];
    Projectiles[i]->images[1] = Shot_bomb[1];
    Projectiles[i]->image_show = 0;
    Projectiles[i]->image_numer = 0;
    Projectiles[i]->image_denom = 3;
    Projectiles[i]->bomb = true;
    Projectiles[i]->facing = RIGHT;
    Projectiles[i]->terminate = false;
    Projectiles[i]->missile_terminate = false;
    Projectiles[i]->beamcode = global_projectiles_fired;
    Projectiles[i]->vibrate_range = 0;
    Projectiles[i]->helix_draw = false;
    Projectiles[i]->not_less_than_pos = -1;
    Projectiles[i]->palette = 0;
    Projectiles[i]->width = 8;
    Projectiles[i]->height = 8;
    BASS_ChannelPlay(Audio.Drop_Bomb, true);

    Projectiles[i]->img_offset_x = 0;
    Projectiles[i]->img_offset_y = 0;
    Projectiles[i]->not_less_than_pos = 0;
    Projectiles[i]->damage_cooldown = 1;
}

void Update_Projectiles()
{
    for(int i = 0; i < total_projectiles; i ++)
    {
        if(Projectiles[i]->owner_flag != -1)
        {
            Projectiles[i]->damage_cooldown --;
            if(Projectiles[i]->vibrate_range > 0)
            {
                Projectiles[i]->timer ++;
                if(Projectiles[i]->timer > 17) Projectiles[i]->timer = 0;
                if(Projectiles[i]->facing == RIGHT)
                {
                    if(!Projectiles[i]->helix_draw)
                    {
                        if(!Projectiles[i]->reverse)
                        {
                            Projectiles[i]->dim.top = Projectiles[i]->lock_position - (projectile_lookup_table[Projectiles[i]->timer] * Projectiles[i]->vibrate_range);
                            Projectiles[i]->dim.bot = Projectiles[i]->dim.top + Projectiles[i]->height;
                        }
                        else
                        {
                            Projectiles[i]->dim.top = Projectiles[i]->lock_position + (projectile_lookup_table[Projectiles[i]->timer] * Projectiles[i]->vibrate_range);
                            Projectiles[i]->dim.bot = Projectiles[i]->dim.top + Projectiles[i]->height;
                        }
                    }
                    else
                    {
                        if(!Projectiles[i]->reverse)
                        {
                            Projectiles[i]->clip.top = Projectiles[i]->lock_position - (projectile_lookup_table[Projectiles[i]->timer] * Projectiles[i]->vibrate_range);
                            Projectiles[i]->clip.bot = Projectiles[i]->clip.top + 3;

                            if(Projectiles[i]->facing == LEFT)
                            {
                                Projectiles[i]->clip.lft = Projectiles[i]->dim.lft;
                                Projectiles[i]->clip.rgt = Projectiles[i]->dim.lft + 3;
                            }
                            else
                            {
                                Projectiles[i]->clip.lft = Projectiles[i]->dim.rgt-3;
                                Projectiles[i]->clip.rgt = Projectiles[i]->dim.rgt;
                            }
                        }
                        else
                        {
                            Projectiles[i]->clip.top = Projectiles[i]->lock_position + (projectile_lookup_table[Projectiles[i]->timer] * Projectiles[i]->vibrate_range);
                            Projectiles[i]->clip.bot = Projectiles[i]->clip.top + 3;
                            if(Projectiles[i]->facing == LEFT)
                            {
                                Projectiles[i]->clip.lft = Projectiles[i]->dim.lft;
                                Projectiles[i]->clip.rgt = Projectiles[i]->dim.lft + 3;
                            }
                            else
                            {
                                Projectiles[i]->clip.lft = Projectiles[i]->dim.rgt-3;
                                Projectiles[i]->clip.rgt = Projectiles[i]->dim.rgt;
                            }
                        }
                        Create_Helix_Shot_Sprites(i);
                    }
                }
                else if(Projectiles[i]->facing == LEFT)
                {
                    if(!Projectiles[i]->helix_draw)
                    {
                        if(!Projectiles[i]->reverse)
                        {
                            Projectiles[i]->dim.top = Projectiles[i]->lock_position - (projectile_lookup_table[Projectiles[i]->timer] * Projectiles[i]->vibrate_range);
                            Projectiles[i]->dim.bot = Projectiles[i]->dim.top + Projectiles[i]->height;
                        }
                        else
                        {
                            Projectiles[i]->dim.top = Projectiles[i]->lock_position + (projectile_lookup_table[Projectiles[i]->timer] * Projectiles[i]->vibrate_range);
                            Projectiles[i]->dim.bot = Projectiles[i]->dim.top + Projectiles[i]->height;
                        }
                    }
                    else
                    {
                        if(!Projectiles[i]->reverse)
                        {
                            Projectiles[i]->clip.top = Projectiles[i]->lock_position - (projectile_lookup_table[Projectiles[i]->timer] * Projectiles[i]->vibrate_range);
                            Projectiles[i]->clip.bot = Projectiles[i]->clip.top + 3;

                            if(Projectiles[i]->facing == LEFT)
                            {
                                Projectiles[i]->clip.lft = Projectiles[i]->dim.lft;
                                Projectiles[i]->clip.rgt = Projectiles[i]->dim.lft + 3;
                            }
                            else
                            {
                                Projectiles[i]->clip.lft = Projectiles[i]->dim.rgt-3;
                                Projectiles[i]->clip.rgt = Projectiles[i]->dim.rgt;
                            }

                        }
                        else
                        {
                            Projectiles[i]->clip.top = Projectiles[i]->lock_position + (projectile_lookup_table[Projectiles[i]->timer] * Projectiles[i]->vibrate_range);
                            Projectiles[i]->clip.bot = Projectiles[i]->clip.top + 3;
                            if(Projectiles[i]->facing == LEFT)
                            {
                                Projectiles[i]->clip.lft = Projectiles[i]->dim.lft;
                                Projectiles[i]->clip.rgt = Projectiles[i]->dim.lft + 3;
                            }
                            else
                            {
                                Projectiles[i]->clip.lft = Projectiles[i]->dim.rgt-3;
                                Projectiles[i]->clip.rgt = Projectiles[i]->dim.rgt;
                            }
                        }
                        Create_Helix_Shot_Sprites(i);
                    }
                }
                else if(Projectiles[i]->facing == UP)
                {
                    if(!Projectiles[i]->helix_draw)
                    {
                        if(!Projectiles[i]->reverse)
                        {
                            Projectiles[i]->dim.lft = Projectiles[i]->lock_position - (projectile_lookup_table[Projectiles[i]->timer] * Projectiles[i]->vibrate_range);
                            Projectiles[i]->dim.rgt = Projectiles[i]->dim.lft + Projectiles[i]->width;
                        }
                        else
                        {
                            Projectiles[i]->dim.lft = Projectiles[i]->lock_position + (projectile_lookup_table[Projectiles[i]->timer] * Projectiles[i]->vibrate_range);
                            Projectiles[i]->dim.rgt = Projectiles[i]->dim.lft + Projectiles[i]->width;
                        }
                    }
                    else
                    {
                        if(!Projectiles[i]->reverse)
                        {
                            Projectiles[i]->clip.lft = Projectiles[i]->lock_position - (projectile_lookup_table[Projectiles[i]->timer] * Projectiles[i]->vibrate_range) + 10;
                            Projectiles[i]->clip.rgt = Projectiles[i]->clip.lft + 3;
                            Projectiles[i]->clip.top = Projectiles[i]->dim.top;
                            Projectiles[i]->clip.bot = Projectiles[i]->dim.top + 3;

                        }
                        else
                        {
                            Projectiles[i]->clip.lft = Projectiles[i]->lock_position + (projectile_lookup_table[Projectiles[i]->timer] * Projectiles[i]->vibrate_range) + 10;
                            Projectiles[i]->clip.rgt = Projectiles[i]->clip.lft + 3;
                            Projectiles[i]->clip.top = Projectiles[i]->dim.top;
                            Projectiles[i]->clip.bot = Projectiles[i]->dim.top + 3;
                        }
                        Create_Helix_Shot_Sprites(i);
                    }
                }
            }
            if(!Projectiles[i]->helix_draw)
            {
                Projectiles[i]->clip.lft = Projectiles[i]->dim.lft+Projectiles[i]->clip_dif.lft;
                Projectiles[i]->clip.top = Projectiles[i]->dim.top+Projectiles[i]->clip_dif.top;
                Projectiles[i]->clip.rgt = Projectiles[i]->clip.lft+Projectiles[i]->clip_dif.rgt;
                Projectiles[i]->clip.bot = Projectiles[i]->clip.top+Projectiles[i]->clip_dif.bot;
            }
            //Drawing code
            if(Projectiles[i]->image_num > 1)
            {
                Projectiles[i]->image_numer ++;
                if(Projectiles[i]->image_numer > Projectiles[i]->image_denom)
                {
                    Projectiles[i]->image_numer = 0;
                    Projectiles[i]->image_show ++;
                    if(Projectiles[i]->image_show >= Projectiles[i]->image_num) Projectiles[i]->image_show = 0;
                }
            }

            //Drawing boxes
            Projectiles[i]->draw.lft = 0;
            Projectiles[i]->draw.top = 0;
            if(Projectiles[i]->facing == RIGHT)
            {
                Projectiles[i]->draw.rgt = Projectiles[i]->width;
                Projectiles[i]->draw.bot = Projectiles[i]->height;
                if(Projectiles[i]->not_less_than_pos != -1 AND Projectiles[i]->dim.lft < Projectiles[i]->not_less_than_pos)
                    Projectiles[i]->draw.lft = Projectiles[i]->not_less_than_pos - Projectiles[i]->dim.lft;
            }
            else if(Projectiles[i]->facing == LEFT)
            {
                Projectiles[i]->draw.rgt = Projectiles[i]->width;
                Projectiles[i]->draw.bot = Projectiles[i]->height;
                if(Projectiles[i]->not_less_than_pos != -1 AND Projectiles[i]->dim.rgt > Projectiles[i]->not_less_than_pos)
                    Projectiles[i]->draw.rgt = Projectiles[i]->width + (Projectiles[i]->not_less_than_pos - Projectiles[i]->dim.rgt);
            }
            else if(Projectiles[i]->facing == UP)
            {
                Projectiles[i]->draw.rgt = Projectiles[i]->height;
                Projectiles[i]->draw.bot = Projectiles[i]->width;
                if(!Projectiles[i]->helix_draw)
                {
                    if(Projectiles[i]->not_less_than_pos != -1 AND Projectiles[i]->dim.top > Projectiles[i]->not_less_than_pos)
                        Projectiles[i]->draw.lft = Projectiles[i]->dim.top - Projectiles[i]->not_less_than_pos;
                }
                else
                {
                    if(Projectiles[i]->not_less_than_pos != -1 AND Projectiles[i]->dim.top+9 > Projectiles[i]->not_less_than_pos)
                        Projectiles[i]->draw.lft = (Projectiles[i]->dim.top+9) - Projectiles[i]->not_less_than_pos;
                }
            }

            //Duration
            if(Projectiles[i]->duration > 0) Projectiles[i]->duration --;
            else if(Projectiles[i]->duration == 0)
            {
                if(Projectiles[i]->bomb AND Projectiles[i]->owner_flag != -1)
                {
                    //Bomb explosion code here
                    int spritenum = Create_Sprite(Projectiles[i]->dim.lft-12, Projectiles[i]->dim.top-12, 3, 2, 6);
                    if(spritenum != -1) Imagize_Sprite_Explosion(spritenum);
                    if(rect_clip(samvar.dim, Projectiles[i]->dim.lft-8, Projectiles[i]->dim.top-5, Projectiles[i]->dim.rgt+8, Projectiles[i]->dim.bot+4) AND samvar.ball_mode)
                    {
                        samvar.yspeed = -2.7;
                    }
                    Compare_Targets_To_Bombs(i);
                    Compare_Breakables_To_Bombs(i);
                    BASS_ChannelPlay(Audio.Bomb_Explode, true);
                }
                Projectiles[i]->terminate = true;
            }

            //Screen Edges
            if(!rect_clip(camera, Projectiles[i]->clip))
            {
                Projectiles[i]->terminate = true;
            }

            //Hit detection
            if(Projectiles[i]->owner_flag != -1 AND !Projectiles[i]->bomb)
            {
                int emergency_counter = 100; //Prevent a crash from a bug
                int xremain = (int)Projectiles[i]->xspeed;
                int yremain = (int)Projectiles[i]->yspeed;
                Projectiles[i]->xremainder += Projectiles[i]->xspeed - xremain;
                Projectiles[i]->yremainder += Projectiles[i]->yspeed - yremain;

                if(Projectiles[i]->xremainder > 1)
                {
                    Projectiles[i]->xremainder -= 1;
                    xremain += 1;
                }
                else if(Projectiles[i]->xremainder < -1)
                {
                    Projectiles[i]->xremainder += 1;
                    xremain -= 1;
                }
                if(Projectiles[i]->yremainder > 1)
                {
                    Projectiles[i]->yremainder -= 1;
                    yremain += 1;
                }
                else if(Projectiles[i]->yremainder < -1)
                {
                    Projectiles[i]->yremainder += 1;
                    yremain -= 1;
                }

                while(emergency_counter AND (xremain OR yremain))
                {
                    emergency_counter --;
                    if(Detect_Projectile_Collision_Clips(i))
                    {
                        Projectiles[i]->terminate = true;
                        Projectiles[i]->missile_terminate = true;
                        emergency_counter = 0;
                    }
                    if(xremain > 0)
                    {
                        Projectiles[i]->dim.lft ++;
                        Projectiles[i]->dim.rgt ++;
                        Projectiles[i]->clip.lft ++;
                        Projectiles[i]->clip.rgt ++;
                        xremain --;
                    }
                    else if(xremain < 0)
                    {
                        Projectiles[i]->dim.lft --;
                        Projectiles[i]->dim.rgt --;
                        Projectiles[i]->clip.lft --;
                        Projectiles[i]->clip.rgt --;
                        xremain ++;
                    }
                    if(Detect_Projectile_Collision_Clips(i))
                    {
                        Projectiles[i]->terminate = true;
                        Projectiles[i]->missile_terminate = true;
                        emergency_counter = 0;
                    }
                    if(yremain > 0)
                    {
                        Projectiles[i]->dim.top ++;
                        Projectiles[i]->dim.bot ++;
                        Projectiles[i]->clip.top ++;
                        Projectiles[i]->clip.bot ++;
                        yremain --;
                    }
                    else if(yremain < 0)
                    {
                        Projectiles[i]->dim.top --;
                        Projectiles[i]->dim.bot --;
                        Projectiles[i]->clip.top --;
                        Projectiles[i]->clip.bot --;
                        yremain ++;
                    }
                }
            }
        }
    }
}

bool Detect_Projectile_Collision_Clips(int i) //True if it hits something
{
    if(Projectiles[i]->owner_flag != -1)
    {
        if(Projectiles[i]->clip.lft < 0 OR Projectiles[i]->clip.lft >= Room->xsize*16 OR
           Projectiles[i]->clip.top < 0 OR Projectiles[i]->clip.top >= Room->ysize*16 OR
           Projectiles[i]->clip.rgt < 0 OR Projectiles[i]->clip.rgt >= Room->xsize*16 OR
           Projectiles[i]->clip.bot < 0 OR Projectiles[i]->clip.bot >= Room->ysize*16)
        {
            Projectiles[i]->terminate = true;
            return false;
        }

        if(!Projectiles[i]->penetrate_world)
        {
            for(int x = Projectiles[i]->clip.lft; x < Projectiles[i]->clip.rgt; x ++)
            {
                if(cliparray[x][Projectiles[i]->clip.top] & STOP_PROJECTILE) return true;
                if(cliparray[x][Projectiles[i]->clip.bot] & STOP_PROJECTILE) return true;
            }
            for(int y = Projectiles[i]->clip.top; y < Projectiles[i]->clip.bot; y ++)
            {
                if(cliparray[Projectiles[i]->clip.lft][y] & STOP_PROJECTILE) return true;
                if(cliparray[Projectiles[i]->clip.rgt][y] & STOP_PROJECTILE) return true;
            }
        }
    }
    return false;
}

void Terminate_Projectiles()
{
    for(int i = 0; i < total_projectiles; i ++)
    {
        if(Projectiles[i]->owner_flag != -1 AND Projectiles[i]->terminate == true)
        {
            Projectiles[i]->terminate = false;
            Projectiles[i]->owner_flag = -1;
            if(Projectiles[i]->images[0] == Shot_missile AND Projectiles[i]->missile_terminate)
            {
                int duration_val;
                if(Get_Cvar_Value_I("fireworks_mode") == 1) duration_val = 100;
                else duration_val = 15;

                int q = Create_Sprite(Projectiles[i]->dim.lft+4, Projectiles[i]->dim.top, 1, 1, duration_val);
                Imagize_Sprite_Explosion_Bit(q, -2.0, 0, false, false, itofix(0));

                q = Create_Sprite(Projectiles[i]->dim.lft+4, Projectiles[i]->dim.top, 1, 1, duration_val);
                Imagize_Sprite_Explosion_Bit(q, -1.414, -1.414, false, false, itofix(32));

                q = Create_Sprite(Projectiles[i]->dim.lft+4, Projectiles[i]->dim.top, 1, 1, duration_val);
                Imagize_Sprite_Explosion_Bit(q, 0, -2.0, false, false, itofix(64));

                q = Create_Sprite(Projectiles[i]->dim.lft+4, Projectiles[i]->dim.top, 1, 1, duration_val);
                Imagize_Sprite_Explosion_Bit(q, 1.414, -1.414, true, false, itofix(32));

                q = Create_Sprite(Projectiles[i]->dim.lft+4, Projectiles[i]->dim.top, 1, 1, duration_val);
                Imagize_Sprite_Explosion_Bit(q, 2.0, 0, true, false, itofix(0));

                q = Create_Sprite(Projectiles[i]->dim.lft+4, Projectiles[i]->dim.top, 1, 1, duration_val);
                Imagize_Sprite_Explosion_Bit(q, 1.414, 1.414, true, true, itofix(32));

                q = Create_Sprite(Projectiles[i]->dim.lft+4, Projectiles[i]->dim.top, 1, 1, duration_val);
                Imagize_Sprite_Explosion_Bit(q, 0, 2.0, false, true, itofix(0));

                q = Create_Sprite(Projectiles[i]->dim.lft+4, Projectiles[i]->dim.top, 1, 1, duration_val);
                Imagize_Sprite_Explosion_Bit(q, -1.414, 1.414, false, true, itofix(32));
            }
        }
    }
}

void Assemble_Samus_Beam_Data()
{
    //If it's a missile, go to the missile function
    if(samvar.missile_mode)
    {
        Assemble_Samus_Missile_Data();
        return;
    }
    samvar.Beam_Data.penetrate_world = false;
    samvar.Beam_Data.penetrate_enemy = false;
    samvar.Beam_Data.freeze = false;
    samvar.Beam_Data.burn = false;
    samvar.Beam_Data.shock = false;
    samvar.Beam_Data.duration = 11;
    samvar.Beam_Data.damage = 1;
    samvar.Beam_Data.Sound = &Audio.Normal_Beam;
    samvar.Beam_Data.image = Shot_normal;
    samvar.Beam_Data.width = 4;
    samvar.Beam_Data.height = 5;
    if(samvar.aim_up) Swap_These(&samvar.Beam_Data.width, &samvar.Beam_Data.height);
    samvar.Beam_Data.palette = 0;
    samvar.Beam_Data.properties = BEAM_DAMAGE;
    samvar.Beam_Data.create_flag = 0;
    samvar.Beam_Data.refire_rate = 8;
    samvar.Beam_Data.wave_flag = false;
    samvar.Beam_Data.img_offset_x = 0;
    samvar.Beam_Data.img_offset_y = 0;
    samvar.Beam_Data.clip_dif.lft = 0;
    samvar.Beam_Data.clip_dif.top = 0;
    samvar.Beam_Data.clip_dif.rgt = 4;
    samvar.Beam_Data.clip_dif.bot = 5;

    //Long Beam
    if(samvar.Using.long_beam)
    {
        samvar.Beam_Data.duration = -1;
        samvar.Beam_Data.Sound = &Audio.Long_Beam;
    }

    if(!samvar.Using.spazer_beam AND !samvar.Using.plasma_beam AND !samvar.Using.helix_beam) //Normal carrier
    {
        if(samvar.Using.wave_beam)
        {
            samvar.Beam_Data.Sound = &Audio.Wave_Beam;
            samvar.Beam_Data.image = Shot_wave;
            samvar.Beam_Data.penetrate_world = true;
            samvar.Beam_Data.damage ++;
            samvar.Beam_Data.wave_flag = true;
            samvar.Beam_Data.width = 8;
            samvar.Beam_Data.height = 8;
            samvar.Beam_Data.clip_dif.lft = 0;
            samvar.Beam_Data.clip_dif.top = 0;
            samvar.Beam_Data.clip_dif.rgt = 8;
            samvar.Beam_Data.clip_dif.bot = 8;
            if(samvar.Using.burn_beam) //Wave and Burn
            {
                samvar.Beam_Data.burn = true;
                samvar.Beam_Data.palette = 2;
                samvar.Beam_Data.properties += BEAM_BURN;
            }
            else if(samvar.Using.ice_beam) //Wave and Ice
            {
                samvar.Beam_Data.freeze = true;
                samvar.Beam_Data.palette = 1;
                samvar.Beam_Data.properties += BEAM_ICE;
            }
        }
        else if(samvar.Using.shock_beam)
        {
            samvar.Beam_Data.shock = true;
            samvar.Beam_Data.damage ++;
            samvar.Beam_Data.properties += BEAM_SHOCK;
            if(samvar.Using.burn_beam) //Shock and Burn
            {
                samvar.Beam_Data.burn = true;
                samvar.Beam_Data.properties += BEAM_BURN;
            }
            else if(samvar.Using.ice_beam) //Shock and Ice
            {
                samvar.Beam_Data.freeze = true;
                samvar.Beam_Data.properties += BEAM_ICE;
            }
        }
        else
        {
            if(samvar.Using.burn_beam) //Burn
            {
                samvar.Beam_Data.burn = true;
                samvar.Beam_Data.image = Shot_burn;
                samvar.Beam_Data.width = 10;
                samvar.Beam_Data.height = 9;
                samvar.Beam_Data.clip_dif.rgt = 8;
                samvar.Beam_Data.clip_dif.bot = 8;
                if(samvar.aim_up) Swap_These(&samvar.Beam_Data.width, &samvar.Beam_Data.height);
                samvar.Beam_Data.properties += BEAM_BURN;
            }
            else if(samvar.Using.ice_beam) //Ice
            {
                samvar.Beam_Data.freeze = true;
                samvar.Beam_Data.Sound = &Audio.Ice_Beam;
                samvar.Beam_Data.palette = 1;
                samvar.Beam_Data.properties += BEAM_ICE;
            }
        }
    }
    else if(samvar.Using.spazer_beam) //Spazer carrier
    {
        samvar.Beam_Data.create_flag = 1;
        samvar.Beam_Data.refire_rate = 24;
        samvar.Beam_Data.damage += 2;
        samvar.Beam_Data.Sound = &Audio.Spazer_Beam;
        samvar.Beam_Data.image = Shot_spazer;
        samvar.Beam_Data.width = 8;
        samvar.Beam_Data.height = 2;
        samvar.Beam_Data.clip_dif.lft = 0;
        samvar.Beam_Data.clip_dif.top = 0;
        samvar.Beam_Data.clip_dif.rgt = 2;
        samvar.Beam_Data.clip_dif.bot = 2;
        if(samvar.aim_up)
        {
            Swap_These(&samvar.Beam_Data.width, &samvar.Beam_Data.height);
            samvar.Beam_Data.img_offset_x = -2;
            samvar.Beam_Data.img_offset_y = 2;
        }
        if(samvar.Using.wave_beam)
        {
            samvar.Beam_Data.penetrate_world = true;
            samvar.Beam_Data.palette = 1;
            samvar.Beam_Data.wave_flag = true;
        }
        else if(samvar.Using.shock_beam)
        {
            samvar.Beam_Data.damage ++;
            samvar.Beam_Data.shock = true;
            samvar.Beam_Data.properties += BEAM_SHOCK;
        }

        if(samvar.Using.burn_beam)
        {
            samvar.Beam_Data.burn = true;
            samvar.Beam_Data.properties += BEAM_BURN;
        }
        else if(samvar.Using.ice_beam)
        {
            samvar.Beam_Data.freeze = true;
            samvar.Beam_Data.palette = 2;
            samvar.Beam_Data.properties += BEAM_ICE;
        }
    }
    else if(samvar.Using.plasma_beam) //Plasma carrier
    {
        samvar.Beam_Data.properties += BEAM_PLASMA;
        samvar.Beam_Data.penetrate_enemy = true;
        samvar.Beam_Data.refire_rate = 24;
        samvar.Beam_Data.damage += 4;
        samvar.Beam_Data.Sound = &Audio.Spazer_Beam;
        samvar.Beam_Data.image = Shot_plasma;
        samvar.Beam_Data.width = 16;
        samvar.Beam_Data.height = 3;
        samvar.Beam_Data.clip_dif.lft = 0;
        samvar.Beam_Data.clip_dif.top = 0;
        samvar.Beam_Data.clip_dif.rgt = 3;
        samvar.Beam_Data.clip_dif.bot = 3;
        if(samvar.aim_up)
        {
            Swap_These(&samvar.Beam_Data.width, &samvar.Beam_Data.height);
            samvar.Beam_Data.img_offset_x = -6;
            samvar.Beam_Data.img_offset_y = 6;
        }
        if(samvar.Using.wave_beam)
        {
            samvar.Beam_Data.penetrate_world = true;
            samvar.Beam_Data.create_flag = 2;
        }
        if(samvar.Using.ice_beam)
        {
            samvar.Beam_Data.freeze = true;
            samvar.Beam_Data.palette = 1;
            samvar.Beam_Data.properties += BEAM_ICE;
        }
    }
    else if(samvar.Using.helix_beam) //Helix carrier
    {
        samvar.Beam_Data.create_flag = 3;
        samvar.Beam_Data.refire_rate = 24;
        samvar.Beam_Data.damage += 2;
        samvar.Beam_Data.Sound = &Audio.Spazer_Beam;
        samvar.Beam_Data.image = Shot_helix;
        samvar.Beam_Data.width = 3;
        samvar.Beam_Data.height = 3;
        if(samvar.Using.ice_beam)
        {
            samvar.Beam_Data.freeze = true;
            samvar.Beam_Data.palette = 2;
            samvar.Beam_Data.properties += BEAM_ICE;
        }
        if(samvar.Using.burn_beam)
        {
            samvar.Beam_Data.burn = true;
            samvar.Beam_Data.palette = 1;
            samvar.Beam_Data.properties += BEAM_BURN;
        }
        if(samvar.Using.burn_beam AND samvar.Using.ice_beam)
        {
            samvar.Beam_Data.palette = -1; //Special code that means to split this beam in two
        }
        if(samvar.Using.shock_beam)
        {
            samvar.Beam_Data.shock = true;
            samvar.Beam_Data.damage ++;
            samvar.Beam_Data.properties += BEAM_SHOCK;
        }
    }

    //Determine the X/Y speed
    bool recheck_var = false;
    if(!samvar.Using.spazer_beam AND !samvar.Using.plasma_beam AND !samvar.Using.helix_beam) recheck_var = true;
    if(samvar.aim_up)
    {
        samvar.Beam_Data.xspeed = 0;
        samvar.Beam_Data.yspeed = -4;
        samvar.Beam_Data.facing = UP;
        if(samvar.facing == LEFT)
        {
            samvar.Beam_Data.origin_x = samvar.x + 1;
        }
        else if(samvar.facing == RIGHT)
        {
            samvar.Beam_Data.origin_x = samvar.x + 2;
        }
        samvar.Beam_Data.origin_y = (samvar.y - 10) + samvar.Beam_Data.height;
        samvar.Beam_Data.not_less_than_pos = samvar.y-10;
        samvar.Beam_Data.start_timer = 0;
        if(recheck_var)
        {
            samvar.Beam_Data.start_timer = 0;
            samvar.Beam_Data.origin_y = samvar.y - 10;
        }
    }
    else if(samvar.facing == LEFT)
    {
        samvar.Beam_Data.xspeed = -4;
        samvar.Beam_Data.yspeed = 0;
        samvar.Beam_Data.facing = LEFT;
        samvar.Beam_Data.origin_x = (samvar.x - 9) + samvar.Beam_Data.width;
        samvar.Beam_Data.origin_y = samvar.y + 7;
        samvar.Beam_Data.not_less_than_pos = samvar.x-12;
        if(samvar.Using.helix_beam)
        {
            samvar.Beam_Data.not_less_than_pos = samvar.x-3;
        }
        samvar.Beam_Data.start_timer = 0;
        if(recheck_var)
        {
            samvar.Beam_Data.start_timer = 0;
            samvar.Beam_Data.origin_x = samvar.x-8;
        }
    }
    else if(samvar.facing == RIGHT)
    {
        samvar.Beam_Data.xspeed = 4;
        samvar.Beam_Data.yspeed = 0;
        samvar.Beam_Data.facing = RIGHT;
        samvar.Beam_Data.origin_x = (samvar.dim.rgt + 10) - samvar.Beam_Data.width;
        samvar.Beam_Data.origin_y = samvar.y + 7;
        samvar.Beam_Data.not_less_than_pos = samvar.x+10;
        samvar.Beam_Data.start_timer = 0;
        if(recheck_var)
        {
            samvar.Beam_Data.start_timer = 0;
            samvar.Beam_Data.origin_x = samvar.x + 12;
        }
        else
        {
            samvar.Beam_Data.clip_dif.lft += samvar.Beam_Data.width - 3;
        }
    }
}

void Assemble_Samus_Missile_Data()
{
    samvar.Beam_Data.penetrate_enemy = false;
    samvar.Beam_Data.penetrate_world = false;
    samvar.Beam_Data.freeze = false;
    samvar.Beam_Data.burn = false;
    samvar.Beam_Data.shock = false;
    samvar.Beam_Data.duration = -1;
    samvar.Beam_Data.damage = 16;
    samvar.Beam_Data.Sound = &Audio.Missile_Fire;
    samvar.Beam_Data.image = Shot_missile;
    samvar.Beam_Data.palette = 0;
    samvar.Beam_Data.width = 11;
    samvar.Beam_Data.height = 8;
    samvar.Beam_Data.clip_dif.lft = 0;
    samvar.Beam_Data.clip_dif.top = 0;
    samvar.Beam_Data.clip_dif.rgt = 11;
    samvar.Beam_Data.clip_dif.bot = 8;
    samvar.Beam_Data.properties = BEAM_MISSILE;
    samvar.Beam_Data.create_flag = 0;//Determine the X/Y speed
    samvar.Beam_Data.not_less_than_pos = -1;
    samvar.Beam_Data.refire_rate = 24;
    samvar.Beam_Data.wave_flag = false;
    samvar.Beam_Data.img_offset_x = 0;
    samvar.Beam_Data.img_offset_y = 0;
    if(samvar.aim_up)
    {
        samvar.Beam_Data.xspeed = 0;
        samvar.Beam_Data.yspeed = -4;
        samvar.Beam_Data.facing = UP;
        Swap_These(&samvar.Beam_Data.width, &samvar.Beam_Data.height);
        Swap_These(&samvar.Beam_Data.clip_dif.rgt, &samvar.Beam_Data.clip_dif.bot);
        if(samvar.facing == LEFT)
        {
            samvar.Beam_Data.origin_x = samvar.x - 3;
            samvar.Beam_Data.origin_y = samvar.y - 4;
        }
        else if(samvar.facing == RIGHT)
        {
            samvar.Beam_Data.origin_x = samvar.x - 1;
            samvar.Beam_Data.origin_y = samvar.y - 4;
        }
    }
    else if(samvar.facing == LEFT)
    {
        samvar.Beam_Data.xspeed = -4;
        samvar.Beam_Data.yspeed = 0;
        samvar.Beam_Data.facing = LEFT;
        samvar.Beam_Data.origin_x = samvar.x - 9;
        samvar.Beam_Data.origin_y = samvar.y + 6;
    }
    else if(samvar.facing == RIGHT)
    {
        samvar.Beam_Data.xspeed = 4;
        samvar.Beam_Data.yspeed = 0;
        samvar.Beam_Data.facing = RIGHT;
        samvar.Beam_Data.origin_x = samvar.x + 12;
        samvar.Beam_Data.origin_y = samvar.y + 6;
    }
}

void draw_shot_special(BITMAP *dest, CUSTOM_IMAGE *src, int xdest, int ydest, int pal_use, DIMENSION draw)
{
    if(pal_use >= src->palettes OR pal_use < 0) pal_use = 0;
    if(draw.lft < 0) draw.lft = 0;
    if(draw.top < 0) draw.top = 0;
    if(draw.rgt > src->xsize) draw.rgt = src->xsize;
    if(draw.bot > src->ysize) draw.bot = src->ysize;
    for(int x = draw.lft; x < draw.rgt; x ++)
    {
        for(int y = draw.top; y < draw.bot; y ++)
        {
            if(src->image[x][y] != 0)
            {
                putpixel(dest, xdest+x, ydest+y, src->values[pal_use][src->image[x][y]-1]);
            }
        }
    }
}

void draw_shot_special_h_flip(BITMAP *dest, CUSTOM_IMAGE *src, int xdest, int ydest, int pal_use, DIMENSION draw)
{
    if(pal_use >= src->palettes OR pal_use < 0) pal_use = 0;
    if(draw.lft < 0) draw.lft = 0;
    if(draw.top < 0) draw.top = 0;
    if(draw.rgt > src->xsize) draw.rgt = src->xsize;
    if(draw.bot > src->ysize) draw.bot = src->ysize;
    for(int x = draw.lft; x < draw.rgt; x ++)
    {
        for(int y = draw.top; y < draw.bot; y ++)
        {
            if(src->image[x][y] != 0)
            {
                putpixel(dest, xdest+src->xsize-x-1, ydest+y, src->values[pal_use][src->image[x][y]-1]);
            }
        }
    }
}

void rotate_shot_special(BITMAP *dest, CUSTOM_IMAGE *src, int xdest, int ydest, int pal_use, fixed angle, DIMENSION draw)
{
    if(pal_use >= src->palettes OR pal_use < 0) pal_use = 0;
    if(draw.lft < 0) draw.lft = 0;
    if(draw.top < 0) draw.top = 0;
    if(draw.rgt > src->xsize) draw.rgt = src->xsize;
    if(draw.bot > src->ysize) draw.bot = src->ysize;
    BITMAP *tmpbmp = create_bitmap(src->xsize, src->ysize);
    clear_to_color(tmpbmp, transparent);
    for(int x = draw.lft; x < draw.rgt; x ++)
    {
        for(int y = draw.top; y < draw.bot; y ++)
        {
            if(src->image[x][y] != 0)
            {
                putpixel(tmpbmp, x, y, src->values[pal_use][src->image[x][y]-1]);
            }
        }
    }
    rotate_sprite(dest, tmpbmp, xdest, ydest, angle);
    destroy_bitmap(tmpbmp);
}

void Create_Helix_Shot_Sprites(int i)
{
    CUSTOM_IMAGE *tmp = NULL;
    int r;
    int lft, top;
    if(Projectiles[i]->facing == LEFT)
    {
        tmp = Create_Blank_Custom_Image(1, 3, 5, 3);
        Copy_Custom_Image_Palette_Data(Shot_helix, tmp);
        for(int q = 0; q < 8; q ++)
        {
            tmp->image[0][0] = Shot_helix->image[q][0];
            tmp->image[0][1] = Shot_helix->image[q][1];
            tmp->image[0][2] = Shot_helix->image[q][2];
            lft = Projectiles[i]->clip.lft-q;
            if(Projectiles[i]->reverse) top = Projectiles[i]->lock_position + (projectile_lookup_table[Projectiles[i]->timer+(q/2)] * Projectiles[i]->vibrate_range);
            else top = Projectiles[i]->lock_position - (projectile_lookup_table[Projectiles[i]->timer+(q/2)] * Projectiles[i]->vibrate_range);
            r = Create_Sprite(lft, top, 4, tmp);
            Sprite_List[r]->palette = Projectiles[i]->palette;
        }
    }
    else if(Projectiles[i]->facing == RIGHT)
    {
        tmp = Create_Blank_Custom_Image(1, 3, 5, 3);
        Copy_Custom_Image_Palette_Data(Shot_helix, tmp);
        for(int q = 0; q < 8; q ++)
        {
            tmp->image[0][0] = Shot_helix->image[q][0];
            tmp->image[0][1] = Shot_helix->image[q][1];
            tmp->image[0][2] = Shot_helix->image[q][2];
            lft = Projectiles[i]->clip.lft+q;
            if(Projectiles[i]->reverse) top = Projectiles[i]->lock_position + (projectile_lookup_table[Projectiles[i]->timer+(q/2)] * Projectiles[i]->vibrate_range);
            else top = Projectiles[i]->lock_position - (projectile_lookup_table[Projectiles[i]->timer+(q/2)] * Projectiles[i]->vibrate_range);
            r = Create_Sprite(lft, top, 4, tmp);
            Sprite_List[r]->palette = Projectiles[i]->palette;
        }
    }
    else if(Projectiles[i]->facing == UP)
    {
        tmp = Create_Blank_Custom_Image(3, 1, 5, 3);
        Copy_Custom_Image_Palette_Data(Shot_helix, tmp);
        for(int q = 0; q < 8; q ++)
        {
            tmp->image[0][0] = Shot_helix->image[q][0];
            tmp->image[1][0] = Shot_helix->image[q][1];
            tmp->image[2][0] = Shot_helix->image[q][2];
            if(Projectiles[i]->reverse) lft = Projectiles[i]->lock_position + (projectile_lookup_table[Projectiles[i]->timer+(q/2)] * Projectiles[i]->vibrate_range) + 10;
            else lft = Projectiles[i]->lock_position - (projectile_lookup_table[Projectiles[i]->timer+(q/2)] * Projectiles[i]->vibrate_range) + 10;
            top = Projectiles[i]->dim.top-q;
            r = Create_Sprite(lft, top, 4, tmp);
            Sprite_List[r]->palette = Projectiles[i]->palette;
        }
    }
}
