int Place_Sprite_In_Slot(int i, int lft, int top, int rgt, int bot, int frame_denom, int total_images, int duration)
{
    Sprite_List[i]->active = true;
    Sprite_List[i]->dim.lft = lft;
    Sprite_List[i]->dim.top = top;
    Sprite_List[i]->dim.rgt = rgt;
    Sprite_List[i]->dim.bot = bot;
    Sprite_List[i]->frame_num = 0;
    Sprite_List[i]->frame_denom = frame_denom;
    if(Sprite_List[i]->images) free(Sprite_List[i]->images);
    Sprite_List[i]->images = (CUSTOM_IMAGE **)malloc(sizeof(CUSTOM_IMAGE *) * total_images);
    Sprite_List[i]->total_images = total_images;
    Sprite_List[i]->duration = duration;
    Sprite_List[i]->palette = 0;
    if(Sprite_List[i]->phys) free(Sprite_List[i]->phys);
    if(Sprite_List[i]->clip) free(Sprite_List[i]->clip);
    if(Sprite_List[i]->draw) free(Sprite_List[i]->draw);
    if(Sprite_List[i]->damage) free(Sprite_List[i]->damage);
    if(Sprite_List[i]->roll) free(Sprite_List[i]->roll);
}

int Create_Sprite(int lft, int top, int frame_denom, int total_images, int duration)
{
    for(int i = 0; i < total_sprites; i ++)
    {
        if(!Sprite_List[i]->active)
        {
            Place_Sprite_In_Slot(i, lft, top, lft, top, frame_denom, total_images, duration);
            return i;
        }
    }
    Sprite_List = (SPRITE **)realloc(Sprite_List, sizeof(SPRITE *) * (total_sprites + 1));
    Sprite_List[total_sprites] = (SPRITE *)malloc(sizeof(SPRITE));
    Sprite_List[total_sprites]->images = NULL;
    Sprite_List[total_sprites]->phys = NULL;
    Sprite_List[total_sprites]->clip = NULL;
    Sprite_List[total_sprites]->draw = NULL;
    Sprite_List[total_sprites]->damage = NULL;
    Sprite_List[total_sprites]->roll = NULL;
    Place_Sprite_In_Slot(total_sprites, lft, top, lft, top, frame_denom, total_images, duration);
    total_sprites ++;
    return total_sprites-1;
}

int Create_Sprite(int lft, int top, int total_images) //Minimalist overload for constructors
{
    for(int i = 0; i < total_sprites; i ++)
    {
        if(!Sprite_List[i]->active)
        {
            Place_Sprite_In_Slot(i, lft, top, lft, top, -1, total_images, -1);
            return i;
        }
    }
    Sprite_List = (SPRITE **)realloc(Sprite_List, sizeof(SPRITE *) * (total_sprites + 1));
    Sprite_List[total_sprites] = (SPRITE *)malloc(sizeof(SPRITE));
    Sprite_List[total_sprites]->images = NULL;
    Sprite_List[total_sprites]->phys = NULL;
    Sprite_List[total_sprites]->clip = NULL;
    Sprite_List[total_sprites]->draw = NULL;
    Sprite_List[total_sprites]->damage = NULL;
    Sprite_List[total_sprites]->roll = NULL;
    Place_Sprite_In_Slot(total_sprites, lft, top, lft, top, -1, total_images, -1);
    total_sprites ++;
    return total_sprites-1;
}

int Create_Sprite(int lft, int top, int rgt, int bot, int frame_denom, int total_images, int duration) //Overload for more clipping data
{
    for(int i = 0; i < total_sprites; i ++)
    {
        if(!Sprite_List[i]->active)
        {
            Place_Sprite_In_Slot(i, lft, top, rgt, bot, frame_denom, total_images, duration);
            return i;
        }
    }
    Sprite_List = (SPRITE **)realloc(Sprite_List, sizeof(SPRITE *) * (total_sprites + 1));
    Sprite_List[total_sprites] = (SPRITE *)malloc(sizeof(SPRITE));
    Sprite_List[total_sprites]->images = NULL;
    Sprite_List[total_sprites]->phys = NULL;
    Sprite_List[total_sprites]->clip = NULL;
    Sprite_List[total_sprites]->draw = NULL;
    Sprite_List[total_sprites]->damage = NULL;
    Sprite_List[total_sprites]->roll = NULL;
    Place_Sprite_In_Slot(total_sprites, lft, top, rgt, bot, frame_denom, total_images, duration);
    total_sprites ++;
    return total_sprites-1;
}

int Create_Sprite(int lft, int top, int duration, CUSTOM_IMAGE *image) //Overload for one-image sprites
{
    for(int i = 0; i < total_sprites; i ++)
    {
        if(!Sprite_List[i]->active)
        {
            Place_Sprite_In_Slot(i, lft, top, lft+image->xsize, top+image->ysize, 1, 1, duration);
            Sprite_List[i]->images[0] = image;
            Sprite_List[i]->frame_num = 0;
            Sprite_List[i]->frame_denom = 1;
            return i;
        }
    }
    Sprite_List = (SPRITE **)realloc(Sprite_List, sizeof(SPRITE *) * (total_sprites + 1));
    Sprite_List[total_sprites] = (SPRITE *)malloc(sizeof(SPRITE));
    Sprite_List[total_sprites]->images = NULL;
    Sprite_List[total_sprites]->phys = NULL;
    Sprite_List[total_sprites]->clip = NULL;
    Sprite_List[total_sprites]->draw = NULL;
    Sprite_List[total_sprites]->damage = NULL;
    Sprite_List[total_sprites]->roll = NULL;
    Place_Sprite_In_Slot(total_sprites, lft, top, lft+image->xsize, top+image->ysize, 1, 1, duration);
    Sprite_List[total_sprites]->images[0] = image;
    Sprite_List[total_sprites]->frame_num = 0;
    Sprite_List[total_sprites]->frame_denom = 1;
    total_sprites ++;
    return total_sprites-1;
}

//Destructor to remove the image array in a sprite when it is deactivated
void Deactive_Sprite(int i)
{
    if(Sprite_List[i]->active)
    {
        Sprite_List[i]->active = false;
        if(Sprite_List[i]->images) free(Sprite_List[i]->images);
        Sprite_List[i]->images = NULL;
        if(Sprite_List[i]->phys) free(Sprite_List[i]->phys);
        Sprite_List[i]->phys = NULL;
        if(Sprite_List[i]->clip) free(Sprite_List[i]->clip);
        Sprite_List[i]->clip = NULL;
        if(Sprite_List[i]->draw) free(Sprite_List[i]->draw);
        Sprite_List[i]->draw = NULL;
        if(Sprite_List[i]->damage) free(Sprite_List[i]->damage);
        Sprite_List[i]->damage = NULL;
        if(Sprite_List[i]->roll) free(Sprite_List[i]->roll);
        Sprite_List[i]->roll = NULL;
    }
}

//Preset to turn a sprite object into an explosion
void Imagize_Sprite_Explosion(int i)
{
    if(Sprite_List[i]->active)
    {
        Sprite_List[i]->images[0] = Explosion_Images[0];
        Sprite_List[i]->images[1] = Explosion_Images[1];
        Sprite_List[i]->duration = 6;
        Sprite_List[i]->frame_num = 0;
        Sprite_List[i]->frame_denom = 3;
    }
}

void Imagize_Sprite_Droplet_One(int i)
{
    if(Sprite_List[i]->active)
    {
        Sprite_List[i]->images[0] = Droplet_Images[0];
        Sprite_List[i]->duration = 30;
        Sprite_List[i]->frame_num = 0;
        Sprite_List[i]->frame_denom = 1;
    }
}

void Imagize_Sprite_Droplet_Two(int i)
{
    if(Sprite_List[i]->active)
    {
        Sprite_List[i]->images[0] = Droplet_Images[1];
        Sprite_List[i]->dim.rgt = Sprite_List[i]->dim.lft + 3;
        Sprite_List[i]->dim.bot = Sprite_List[i]->dim.top + 7;
        Sprite_List[i]->duration = -1;
        Sprite_List[i]->frame_num = 0;
        Sprite_List[i]->frame_denom = 1;
        Sprite_List[i]->phys = (PHYSICS_PACK *)calloc(1, sizeof(PHYSICS_PACK));
        Sprite_List[i]->phys->xpos = Sprite_List[i]->dim.lft;
        Sprite_List[i]->phys->ypos = Sprite_List[i]->dim.top;
        Sprite_List[i]->phys->yspeed = 1;
        Sprite_List[i]->phys->yaccel = .125;
        Sprite_List[i]->phys->ymax = 3;
        Sprite_List[i]->clip = (CLIPPING_PACK *)calloc(1, sizeof(CLIPPING_PACK));
        Sprite_List[i]->clip->bot = 1;
        Sprite_List[i]->clip->terminate = true;
    }
}

void Imagize_Sprite_Splash(int i)
{
    if(Sprite_List[i]->active)
    {
        for(int q = 0; q < 8; q ++) Sprite_List[i]->images[q] = Water_Splash[q];
        Sprite_List[i]->dim.rgt = Sprite_List[i]->dim.lft + 24;
        Sprite_List[i]->dim.bot = Sprite_List[i]->dim.top + 21;
        Sprite_List[i]->duration = 15;
        Sprite_List[i]->frame_num = 0;
        Sprite_List[i]->frame_denom = 2;
    }
}

void Imagize_Sprite_Explosion_Bit(int i, float xspeed, float yspeed, bool hflip, bool vflip, fixed angle)
{
    if(Sprite_List[i]->active)
    {
        Sprite_List[i]->phys = (PHYSICS_PACK *)calloc(1, sizeof(PHYSICS_PACK));
        Sprite_List[i]->phys->xpos = Sprite_List[i]->dim.lft;
        Sprite_List[i]->phys->ypos = Sprite_List[i]->dim.top;
        Sprite_List[i]->phys->xspeed = xspeed;
        Sprite_List[i]->phys->yspeed = yspeed;
        Sprite_List[i]->phys->xmax = 1000;
        Sprite_List[i]->phys->ymax = 1000;
        Sprite_List[i]->phys->ymax_reserve = 1000;
        Sprite_List[i]->phys->xmin = -1000;
        Sprite_List[i]->phys->ymin = -1000;
        Sprite_List[i]->draw = (DRAWING_PACK *)calloc(1, sizeof(DRAWING_PACK));
        Sprite_List[i]->draw->hflip = hflip;
        Sprite_List[i]->draw->vflip = vflip;
        Sprite_List[i]->draw->angle = angle;
        Sprite_List[i]->images[0] = Explosion_Bit;
        Sprite_List[i]->frame_num = 0;
        Sprite_List[i]->frame_denom = 1;
    }
}

void Imagize_Sprite_Shriekbat_Orb(int i, float xspeed, float yspeed)
{
    if(Sprite_List[i]->active)
    {
        Sprite_List[i]->damage = (DAMAGE_PACK *)calloc(1, sizeof(DAMAGE_PACK));
        Sprite_List[i]->damage->damage = 6;
        Sprite_List[i]->phys = (PHYSICS_PACK *)calloc(1, sizeof(PHYSICS_PACK));
        Sprite_List[i]->phys->xpos = Sprite_List[i]->dim.lft;
        Sprite_List[i]->phys->ypos = Sprite_List[i]->dim.top;
        Sprite_List[i]->phys->xspeed = xspeed;
        Sprite_List[i]->phys->yspeed = yspeed;
        Sprite_List[i]->phys->xmax = 1000;
        Sprite_List[i]->phys->ymax = 1000;
        Sprite_List[i]->phys->ymax_reserve = 1000;
        Sprite_List[i]->phys->xmin = -1000;
        Sprite_List[i]->phys->ymin = -1000;
        Sprite_List[i]->images[0] = Enemy_Images[7];
        Sprite_List[i]->frame_num = 0;
        Sprite_List[i]->frame_denom = 1;
    }
}

void Imagize_Sprite_Firehorse(int i, int direction)
{
    if(Sprite_List[i]->active)
    {
        Sprite_List[i]->damage = (DAMAGE_PACK *)calloc(1, sizeof(DAMAGE_PACK));
        Sprite_List[i]->damage->damage = 6;
        Sprite_List[i]->phys = (PHYSICS_PACK *)calloc(1, sizeof(PHYSICS_PACK));
        Sprite_List[i]->phys->xpos = Sprite_List[i]->dim.lft;
        Sprite_List[i]->phys->ypos = Sprite_List[i]->dim.top;
        Sprite_List[i]->phys->xspeed = 4;
        Sprite_List[i]->phys->yspeed = -4;
        Sprite_List[i]->phys->xaccel = 0;
        Sprite_List[i]->phys->yaccel = 0.125;
        Sprite_List[i]->phys->xmax = 1000;
        Sprite_List[i]->phys->ymax = 1000;
        Sprite_List[i]->phys->ymax_reserve = 1000;
        Sprite_List[i]->phys->xmin = -1000;
        Sprite_List[i]->phys->ymin = -1000;
        Sprite_List[i]->images[0] = Enemy_Images[31];
        Sprite_List[i]->frame_num = 0;
        Sprite_List[i]->frame_denom = 1;
    }
}

void Imagize_Sprite_Giblet(int i, CUSTOM_IMAGE *source)
{
    if(Sprite_List[i]->active)
    {
        Sprite_List[i]->phys = (PHYSICS_PACK *)calloc(1, sizeof(PHYSICS_PACK));
        Sprite_List[i]->phys->xpos = Sprite_List[i]->dim.lft;
        Sprite_List[i]->phys->ypos = Sprite_List[i]->dim.top;
        Sprite_List[i]->phys->xspeed = (rnd(0, 40) - 20)/10.0;
        Sprite_List[i]->phys->yspeed = (rnd(0, 40) - 20)/10.0;
        Sprite_List[i]->phys->xaccel = 0;
        Sprite_List[i]->phys->yaccel = 0.125;
        Sprite_List[i]->phys->xmax = 1000;
        Sprite_List[i]->phys->ymax = 1000;
        Sprite_List[i]->phys->ymax_reserve = 1000;
        Sprite_List[i]->phys->xmin = -1000;
        Sprite_List[i]->phys->ymin = -1000;
        Sprite_List[i]->images[0] = source;
        Sprite_List[i]->frame_num = 0;
        Sprite_List[i]->frame_denom = 1;
        Sprite_List[i]->clip = (CLIPPING_PACK *)calloc(1, sizeof(CLIPPING_PACK));
        Sprite_List[i]->clip->bot = 1;
        Sprite_List[i]->clip->lft = 1;
        Sprite_List[i]->clip->rgt = 1;
        Sprite_List[i]->clip->bounce = true;
        Sprite_List[i]->clip->terminate = false;
        Sprite_List[i]->clip->friction = true;
    }
}

void Imagize_Sprite_Minigun_Shot(int i, int dir)
{
    Sprite_List[i]->frame_num = 0;
    Sprite_List[i]->frame_denom = 1;
    Sprite_List[i]->damage = (DAMAGE_PACK *)calloc(1, sizeof(DAMAGE_PACK));
    Sprite_List[i]->damage->damage = 6;
    Sprite_List[i]->phys = (PHYSICS_PACK *)calloc(1, sizeof(PHYSICS_PACK));
    Sprite_List[i]->phys->xpos = Sprite_List[i]->dim.lft;
    Sprite_List[i]->phys->ypos = Sprite_List[i]->dim.top;
    Sprite_List[i]->phys->xaccel = 0;
    Sprite_List[i]->phys->yaccel = 0;
    Sprite_List[i]->phys->xmax = 1000;
    Sprite_List[i]->phys->ymax = 1000;
    Sprite_List[i]->phys->ymax_reserve = 1000;
    Sprite_List[i]->phys->xmin = -1000;
    Sprite_List[i]->phys->ymin = -1000;
    Sprite_List[i]->clip = (CLIPPING_PACK *)calloc(1, sizeof(CLIPPING_PACK));
    Sprite_List[i]->clip->bounce = false;
    Sprite_List[i]->clip->terminate = true;
    Sprite_List[i]->clip->friction = false;
    Sprite_List[i]->clip->top = 0;
    Sprite_List[i]->clip->lft = 0;
    Sprite_List[i]->clip->rgt = 0;
    Sprite_List[i]->clip->bot = 0;
    Sprite_List[i]->draw = (DRAWING_PACK *)calloc(1, sizeof(DRAWING_PACK));
    Sprite_List[i]->draw->angle = 0;
    Sprite_List[i]->draw->vflip = false;
    if(dir == 0) //Fires down left, Minigun is a left-facing gun
    {
        Sprite_List[i]->phys->xspeed = -1.0;
        Sprite_List[i]->phys->yspeed = 1.0;
        Sprite_List[i]->images[0] = Minigun_Shot_D;
        Sprite_List[i]->clip->bot = 1;
        Sprite_List[i]->clip->lft = 1;
        Sprite_List[i]->draw->hflip = true;
    }
    else if(dir == 1) //Fires down right, Minigun is right-facing
    {
        Sprite_List[i]->phys->xspeed = 1.0;
        Sprite_List[i]->phys->yspeed = 1.0;
        Sprite_List[i]->images[0] = Minigun_Shot_D;
        Sprite_List[i]->clip->bot = 1;
        Sprite_List[i]->clip->rgt = 1;
        Sprite_List[i]->draw->hflip = false;
    }
    else if(dir == 2) //Fires down, Gun faces down
    {
        Sprite_List[i]->phys->xspeed = 0.0;
        Sprite_List[i]->phys->yspeed = 1.25;
        Sprite_List[i]->images[0] = Minigun_Shot_V;
        Sprite_List[i]->clip->bot = 1;
        Sprite_List[i]->draw->hflip = false;
    }
}

void Update_Sprites()
{
    for(int i = 0; i < total_sprites; i ++)
    {
        if(Sprite_List[i]->active)
        {
            if(Sprite_List[i]->duration != -1) //If duration is -1, something else terminates the sprite
            {
                Sprite_List[i]->duration --;
                if(Sprite_List[i]->duration == 0) Deactive_Sprite(i);
            }
            Sprite_List[i]->frame_num ++;
            if(Sprite_List[i]->frame_num >= Sprite_List[i]->frame_denom * Sprite_List[i]->total_images)
            {
                Sprite_List[i]->frame_num = 0;
            }

            //Only executes if a physics pack is on this sprite
            if(Sprite_List[i]->phys)
            {
                Sprite_List[i]->phys->xspeed += Sprite_List[i]->phys->xaccel;
                if(Sprite_List[i]->phys->xspeed > Sprite_List[i]->phys->xmax) Sprite_List[i]->phys->xspeed = Sprite_List[i]->phys->xmax;
                if(Sprite_List[i]->phys->xspeed < Sprite_List[i]->phys->xmin) Sprite_List[i]->phys->xspeed = Sprite_List[i]->phys->xmin;
                Sprite_List[i]->phys->yspeed += Sprite_List[i]->phys->yaccel;
                if(Sprite_List[i]->phys->yspeed > Sprite_List[i]->phys->ymax) Sprite_List[i]->phys->yspeed = Sprite_List[i]->phys->ymax;
                if(Sprite_List[i]->phys->yspeed < Sprite_List[i]->phys->ymin) Sprite_List[i]->phys->yspeed = Sprite_List[i]->phys->ymin;

                Sprite_List[i]->phys->xpos += Sprite_List[i]->phys->xspeed;
                Sprite_List[i]->phys->ypos += Sprite_List[i]->phys->yspeed;

                int width = Sprite_List[i]->dim.rgt - Sprite_List[i]->dim.lft;
                int height = Sprite_List[i]->dim.bot - Sprite_List[i]->dim.top;
                Sprite_List[i]->dim.lft = (int)Sprite_List[i]->phys->xpos;
                Sprite_List[i]->dim.rgt = (int)Sprite_List[i]->phys->xpos + width;
                Sprite_List[i]->dim.top = (int)Sprite_List[i]->phys->ypos;
                Sprite_List[i]->dim.bot = (int)Sprite_List[i]->phys->ypos + height;
            }

            //Only executes if a clipping pack is on this sprite
            if(Sprite_List[i]->clip)
            {
                if(Sprite_List[i]->clip->bot == 1) 
                {
                    if(Scan_Clips_X(Sprite_List[i]->dim.lft, Sprite_List[i]->dim.rgt, Sprite_List[i]->dim.bot, 8))
                    {
                        if(Sprite_List[i]->clip->terminate) Sprite_List[i]->duration = 1;
                        else if(Sprite_List[i]->clip->bounce)
                        {
                            if(Sprite_List[i]->phys)
                            {
                                if(Sprite_List[i]->phys->yspeed > 0 AND Sprite_List[i]->phys->yspeed < 0.5)
                                {
                                    Sprite_List[i]->phys->yspeed = 0;
                                    Sprite_List[i]->phys->ymax = 0;
                                }
                                else
                                    Sprite_List[i]->phys->yspeed /= -2.0;
                            }
                        }
                        if(Sprite_List[i]->clip->friction AND Sprite_List[i]->phys)
                        {
                            if(Sprite_List[i]->phys->xspeed > 0)
                            {
                                Sprite_List[i]->phys->xspeed -= 0.25;
                                if(Sprite_List[i]->phys->xspeed < 0) Sprite_List[i]->phys->xspeed = 0;
                            }
                            else if(Sprite_List[i]->phys->xspeed < 0)
                            {
                                Sprite_List[i]->phys->xspeed += 0.25;
                                if(Sprite_List[i]->phys->xspeed > 0) Sprite_List[i]->phys->xspeed = 0;
                            }
                        }
                    }
                    else
                    {
                        Sprite_List[i]->phys->ymax = Sprite_List[i]->phys->ymax_reserve;
                    }
                }
                if(Sprite_List[i]->clip->top == 1) 
                {
                    if(Scan_Clips_X(Sprite_List[i]->dim.lft, Sprite_List[i]->dim.rgt, Sprite_List[i]->dim.top, 8)) Sprite_List[i]->duration = 1;
                }
                if(Sprite_List[i]->clip->lft == 1) 
                {
                    if(Scan_Clips_Y(Sprite_List[i]->dim.top, Sprite_List[i]->dim.bot, Sprite_List[i]->dim.lft, 8))
                    {
                        if(Sprite_List[i]->clip->terminate) Sprite_List[i]->duration = 1;
                        else if(Sprite_List[i]->clip->bounce)
                        {
                            if(Sprite_List[i]->phys)
                            {
                                if(Sprite_List[i]->phys->xspeed < 0 AND Sprite_List[i]->phys->xspeed > -0.5)
                                {
                                    Sprite_List[i]->phys->xspeed = 0;
                                }
                                else
                                    Sprite_List[i]->phys->xspeed /= -2.0;
                            }
                        }
                    }
                }
                if(Sprite_List[i]->clip->rgt == 1) 
                {
                    if(Scan_Clips_Y(Sprite_List[i]->dim.top, Sprite_List[i]->dim.bot, Sprite_List[i]->dim.rgt, 8))
                    {
                        if(Sprite_List[i]->clip->terminate) Sprite_List[i]->duration = 1;
                        else if(Sprite_List[i]->clip->bounce)
                        {
                            if(Sprite_List[i]->phys)
                            {
                                if(Sprite_List[i]->phys->xspeed > 0 AND Sprite_List[i]->phys->xspeed < 0.5)
                                {
                                    Sprite_List[i]->phys->xspeed = 0;
                                }
                                else
                                    Sprite_List[i]->phys->xspeed /= -2.0;
                            }
                        }
                    }
                }
            }

            //Executes if a damage pack is on the sprite
            if(Sprite_List[i]->damage)
            {
                if(!samvar.invincible_timer AND samvar.screw_attack_active == -1 AND !Samstart.active AND rect_clip(Sprite_List[i]->dim, samvar.dim))
                {
                    Injure_Samus(Sprite_List[i]->damage->damage);
                }
            }
        }
    }
}
