void Subscreen_Processes()
{
    //Cursor
    if(cursor_ctr_up)
    {
        cursor_ctr += 8;
        if(cursor_ctr >= 255)
        {
            cursor_ctr = 255;
            cursor_ctr_up = false;
        }
    }
    else
    {
        cursor_ctr -= 8;
        if(cursor_ctr <= 0)
        {
            cursor_ctr = 0;
            cursor_ctr_up = true;
        }
    }

    //Fading
    if(subscreen_fade_stage == 1) //Fade out of gameplay
    {
        if(subscreen_ctr > 8) subscreen_ctr -= 8;
        else
        {
            subscreen_ctr = 255;
            subscreen_fade_stage = 4;
        }
    }
    else if(subscreen_fade_stage == 2) //Fade into gameplay
    {
        if(subscreen_ctr > 8) subscreen_ctr -= 8;
        else
        {
            subscreen_ctr = 0;
            subscreen_up = false;
            subscreen_fade_stage = 0;
            exiting_subscreen = false;
            if(!samvar.missile_mode)
            {
                if(samvar.Using.gravity_suit) samvar.palette = 4;
                else if(samvar.Using.varia_suit) samvar.palette = 2;
                else samvar.palette = 0;
                samvar.qpalette = samvar.palette;
            }
            else
            {
                if(samvar.Using.gravity_suit) samvar.palette = 5;
                else if(samvar.Using.varia_suit) samvar.palette = 3;
                else samvar.palette = 1;
                samvar.qpalette = samvar.palette;
            }
        }
    }
    else if(subscreen_fade_stage == 3) //Fade out of page x
    {
        if(subscreen_ctr > 16) subscreen_ctr -= 16;
        else
        {
            subscreen_ctr = 255;
            if(exiting_subscreen) subscreen_fade_stage = 2;
            else
            {
                subscreen_fade_stage = 4;
                if(subscreen_page == 0) subscreen_page = 1;
                else subscreen_page = 0;
            }
        }
    }
    else if(subscreen_fade_stage == 4) //Fade into page y
    {
        if(subscreen_ctr > 16) subscreen_ctr -= 16;
        else
        {
            subscreen_ctr = 0;
            subscreen_fade_stage = 0;
        }
    }
    else //Normal subscreen processes
    {
        if(subscreen_page == 0) //Map page
        {
            if(samvar.press_rshoulder AND !samvar.press_lshoulder)
            {
                subscreen_fade_stage = 3;
                subscreen_ctr = 255;
            }
        }
        else if(subscreen_page == 1) //Inventory Page
        {
            if(samvar.press_lshoulder AND !samvar.press_rshoulder)
            {
                subscreen_fade_stage = 3;
                subscreen_ctr = 255;
            }
            if(!subscreen_press_cooldown)
            {
                if(samvar.press_left  AND !samvar.press_right)
                {
                    if(Subscreen_Item[subscreen_item_selected].lpath != -1) subscreen_item_selected = Subscreen_Item[subscreen_item_selected].lpath;
                    subscreen_press_cooldown = 15;
                }
                if(samvar.press_right AND !samvar.press_left)
                {
                    if(Subscreen_Item[subscreen_item_selected].rpath != -1) subscreen_item_selected = Subscreen_Item[subscreen_item_selected].rpath;
                    subscreen_press_cooldown = 15;
                }
                if(samvar.press_up    AND !samvar.press_down)
                {
                    if(Subscreen_Item[subscreen_item_selected].upath != -1) subscreen_item_selected = Subscreen_Item[subscreen_item_selected].upath;
                    subscreen_press_cooldown = 15;
                }
                if(samvar.press_down  AND !samvar.press_up)
                {
                    if(Subscreen_Item[subscreen_item_selected].dpath != -1) subscreen_item_selected = Subscreen_Item[subscreen_item_selected].dpath;
                    subscreen_press_cooldown = 15;
                }
                if(samvar.press_fire)
                {
                    if(*Subscreen_Item[subscreen_item_selected].col)
                    {
                        if(*Subscreen_Item[subscreen_item_selected].use) (*Subscreen_Item[subscreen_item_selected].use) = 0;
                        else
                        {
                            (*Subscreen_Item[subscreen_item_selected].use) = true;
                            for(int i = 0; i < Subscreen_Item[subscreen_item_selected].exclusive_total; i ++)
                            {
                                int q = Subscreen_Item[subscreen_item_selected].exclusive[i];
                                if(*Subscreen_Item[15].use AND ((subscreen_item_selected == 1 AND q == 16) OR (subscreen_item_selected == 16 AND q == 1)))
                                {
                                    ;
                                }
                                else if(*Subscreen_Item[q].use) *Subscreen_Item[q].use = false;
                            }
                        }
                    }
                    subscreen_press_cooldown = 15;
                }
            }
            else
            {
                if(!samvar.press_right AND !samvar.press_left AND !samvar.press_up AND !samvar.press_down AND !samvar.press_fire) subscreen_press_cooldown = 0;
                else subscreen_press_cooldown --;
            }
            if(!(*Subscreen_Item[15].use) AND *Subscreen_Item[1].use AND *Subscreen_Item[16].use)
            {
                *Subscreen_Item[1].use = false;
                *Subscreen_Item[16].use = false;
            }
        }
    }
}

void Draw_Subscreen(BITMAP *output)
{
    //Normal subscreen processes
    if(subscreen_fade_stage == 3 OR subscreen_fade_stage == 4 OR subscreen_fade_stage == 0)
    {
        if(subscreen_page == 0) //Map page
        {
            draw_sprite(output, Map_Base, 0, 31);
            Display_Map(output, Curmap, 8, 47);
        }
        else if(subscreen_page == 1) //Inventory Page
        {
            draw_sprite(output, Item_Base, 0, 31);
            if(samvar.Using.varia_suit) draw_sprite(output, Varia_Suit, 98, 53);
            else draw_sprite(output, Plain_Suit, 99, 53);
            for(int i = 0; i < 18; i ++)
            {
                Draw_Subscreen_Item(output, i);
            }
        }
    }

    if(subscreen_fade_stage == 1) //Fade out of gameplay
    {
        clear_to_color(output, 0);
        set_trans_blender(0, 0, 0, 255-subscreen_ctr);
        draw_sprite(output, subscreen_reserve_buffer, 0, 0);
        draw_trans_sprite(output, subscreen_black_buffer, 0, 0);
    }
    else if(subscreen_fade_stage == 2) //Fade into gameplay
    {
        clear_to_color(output, 0);
        set_trans_blender(0, 0, 0, subscreen_ctr);
        draw_sprite(output, subscreen_reserve_buffer, 0, 0);
        draw_trans_sprite(output, subscreen_black_buffer, 0, 0);
    }
    else if(subscreen_fade_stage == 3) //Fade out of page x
    {
        set_trans_blender(0, 0, 0, 255-subscreen_ctr);
        draw_trans_sprite(output, subscreen_black_buffer, 0, 0);
    }
    else if(subscreen_fade_stage == 4) //Fade into page y
    {
        set_trans_blender(0, 0, 0, subscreen_ctr);
        draw_trans_sprite(output, subscreen_black_buffer, 0, 0);
    }
}

void Create_Subscreen_Item(int i, int lft, int top, int rgt, int bot, bool *hookcol, bool *hookuse, char text[])
{
    Subscreen_Item[i].col = hookcol;
    Subscreen_Item[i].use = hookuse;
    Subscreen_Item[i].text = (char *)malloc(sizeof(char) * (strlen(text)+1));
    Init_String(Subscreen_Item[i].text, text, 0);
    Subscreen_Item[i].dim.lft = lft;
    Subscreen_Item[i].dim.top = top;
    Subscreen_Item[i].dim.rgt = rgt;
    Subscreen_Item[i].dim.bot = bot;
    Subscreen_Item[i].exclusive_total = 0;
    Subscreen_Item[i].exclusive = NULL;
}

void Set_Item_Path(int i, int lpath, int upath, int rpath, int dpath)
{
    Subscreen_Item[i].lpath = lpath;
    Subscreen_Item[i].upath = upath;
    Subscreen_Item[i].rpath = rpath;
    Subscreen_Item[i].dpath = dpath;
}

void Make_Exclusive_With(int i, int exclusive_with) //When i is activated, turn off exclusive_with automatically
{
    if(i == 15 AND exclusive_with == 2)
    {
        printf("loop'd %i\n", Subscreen_Item[i].exclusive);
    }
	#ifndef NOMW
    mwDoFlush(1);
	#endif
    Subscreen_Item[i].exclusive = (int *)realloc(Subscreen_Item[i].exclusive, sizeof(int) * (Subscreen_Item[i].exclusive_total+1));
    if(i == 15 AND exclusive_with == 2)
    {
        printf("loop'd\n");
    }
    Subscreen_Item[i].exclusive[Subscreen_Item[i].exclusive_total] = exclusive_with;
    Subscreen_Item[i].exclusive_total ++;
}

void Draw_Subscreen_Item(BITMAP *output, int i)
{
    if(*Subscreen_Item[i].col)
    {
        if(*Subscreen_Item[i].use)
        {
            rectfill(output, Subscreen_Item[i].dim.lft, Subscreen_Item[i].dim.top, Subscreen_Item[i].dim.rgt, Subscreen_Item[i].dim.bot, makecol(248, 176, 0));
            textprintf_ex(output, SubscreenFont, Subscreen_Item[i].dim.lft+7, Subscreen_Item[i].dim.top+2, 0, -1, "%s", Subscreen_Item[i].text);
            draw_sprite(output, Red_Button, Subscreen_Item[i].dim.lft+2, Subscreen_Item[i].dim.top+2);
        }
        else
        {
            rectfill(output, Subscreen_Item[i].dim.lft, Subscreen_Item[i].dim.top, Subscreen_Item[i].dim.rgt, Subscreen_Item[i].dim.bot, makecol(144, 144, 144));
            textprintf_ex(output, SubscreenFont, Subscreen_Item[i].dim.lft+7, Subscreen_Item[i].dim.top+2, makecol(56, 56, 56), -1, "%s", Subscreen_Item[i].text);
            draw_sprite(output, Gray_Button, Subscreen_Item[i].dim.lft+2, Subscreen_Item[i].dim.top+2);
        }
    }
    if(i == subscreen_item_selected)
    {
        rect(output, Subscreen_Item[i].dim.lft, Subscreen_Item[i].dim.top, Subscreen_Item[i].dim.rgt, Subscreen_Item[i].dim.bot, makecol(cursor_ctr, cursor_ctr, cursor_ctr));
        if(*Subscreen_Item[i].col) draw_sprite(output, Pink_Button, Subscreen_Item[i].dim.lft+2, Subscreen_Item[i].dim.top+2);
    }
}
