void Add_To_Target_List(int type, int location)
{
    for(int i = 0; i < total_targets; i ++)
    {
        if(!Targets[i]->active)
        {
            Targets[i]->active = true;
            Targets[i]->type = type;
            Targets[i]->location = location;
            Targets[i]->snd = NULL;
            Targets[i]->stun_timer = NULL;
            Update_Target_List();
            return;
        }
    }
    Targets = (TARGET **)realloc(Targets, sizeof(TARGET *) * (total_targets + 1));
    Targets[total_targets] = (TARGET *)malloc(sizeof(TARGET));
    Targets[total_targets]->active = true;
    Targets[total_targets]->type = type;
    Targets[total_targets]->location = location;
    Targets[total_targets]->snd = NULL;
    Targets[total_targets]->stun_timer = NULL;
    total_targets ++;
    Update_Target_List();
    return;
}

void Remove_From_Target_List(int *address)
{
    for(int i = 0; i < total_targets; i ++)
    {
        if(Targets[i]->hp == address)
        {
            Targets[i]->active = false;
        }
    }
}

void Update_Target_List()
{
    for(int i = 0; i < total_targets; i ++)
    {
        if(Targets[i]->active)
        {
            if(Targets[i]->type == TARGET_DOOR)
            {
                Targets[i]->dim = &Doors[Targets[i]->location].dim;
                Targets[i]->hp = &Doors[Targets[i]->location].health;
                Targets[i]->team = &doorteam;
                if(Doors[Targets[i]->location].type == NORMAL_DOOR)
                    Targets[i]->vulnerabilities = &door_vuln;
                else
                    Targets[i]->vulnerabilities = &missile_door_vuln;
            }
            else if(Targets[i]->type == TARGET_ENEMY)
            {
                Targets[i]->dim = &Enemies[Targets[i]->location]->bound;
                Targets[i]->hp = &Enemies[Targets[i]->location]->stats.health;
                Targets[i]->team = &Enemies[Targets[i]->location]->team;
                Targets[i]->vulnerabilities = &Enemies[Targets[i]->location]->stats.vulnerabilities;
                Targets[i]->snd = Enemies[Targets[i]->location]->Sound;
                Targets[i]->stun_timer = &Enemies[Targets[i]->location]->stun_timer;
            }
            else if(Targets[i]->type == TARGET_RIDLEY)
            {
                Targets[i]->dim = &Ridley.dim;
                Targets[i]->hp = &Ridley.health;
                Targets[i]->team = &Ridley.team;
                Targets[i]->vulnerabilities = &Ridley.vulnerabilities;
                Targets[i]->snd = Ridley.Sound;
                Targets[i]->stun_timer = &Ridley.stun_timer;
            }
            else if(Targets[i]->type == TARGET_KRAID)
            {
                Targets[i]->dim = &Kraid.dim;
                Targets[i]->hp = &Kraid.health;
                Targets[i]->team = &Kraid.team;
                Targets[i]->vulnerabilities = &Kraid.vulnerabilities;
                Targets[i]->snd = Kraid.Sound;
                Targets[i]->stun_timer = &Kraid.stun_timer;
            }
            else if(Targets[i]->type == TARGET_ZEBETITE)
            {
                Targets[i]->dim = &Zebetite[Targets[i]->location].dim;
                Targets[i]->hp = &Zebetite[Targets[i]->location].health;
                Targets[i]->team = &enemy_team;
                Targets[i]->vulnerabilities = &zebetite_vulnerabilities;
                Targets[i]->snd = NULL;
                Targets[i]->stun_timer = NULL;
            }
            else if(Targets[i]->type == TARGET_KRAID_HOOK)
            {
                Targets[i]->dim = &Hooks[Targets[i]->location].dim;
                Targets[i]->hp = &Hooks[Targets[i]->location].health;
                Targets[i]->team = &enemy_team;
                Targets[i]->vulnerabilities = &kraid_hook_vulnerabilities;
                Targets[i]->snd = NULL;
                Targets[i]->stun_timer = NULL;
            }
            else if(Targets[i]->type == TARGET_KRAID_NEEDLE)
            {
                Targets[i]->dim = &Needles[Targets[i]->location].dim;
                Targets[i]->hp = &Needles[Targets[i]->location].health;
                Targets[i]->team = &enemy_team;
                Targets[i]->vulnerabilities = &kraid_hook_vulnerabilities;
                Targets[i]->snd = NULL;
                Targets[i]->stun_timer = NULL;
            }
            else if(Targets[i]->type == TARGET_MOTHER_BRAIN)
            {
                Targets[i]->dim = &Mbrain.dim;
                Targets[i]->hp = &Mbrain.health;
                Targets[i]->team = &enemy_team;
                Targets[i]->vulnerabilities = &zebetite_vulnerabilities;
                Targets[i]->snd = Mbrain.Sound;
                Targets[i]->stun_timer = NULL;
            }
            else if(Targets[i]->type == TARGET_RINKA)
            {
                Targets[i]->dim = &Rinka[Targets[i]->location].dim;
                Targets[i]->hp = &Rinka[Targets[i]->location].health;
                Targets[i]->team = &enemy_team;
                Targets[i]->vulnerabilities = &vulnerable_all;
                Targets[i]->snd = &Audio.Injured_Small;
                Targets[i]->stun_timer = NULL;
            }
        }
    }
}

void Compare_Targets_To_Projectiles()
{
    //Loop through the projectiles
    for(int p = 0; p < total_projectiles; p ++)
    {
        if(Projectiles[p]->owner_flag != -1 AND Projectiles[p]->damage_cooldown < 1)
        {
            //Samus is also a target
            if(Projectiles[p]->owner_flag == 1 AND !samvar.invincible_timer)
            {
                if(rect_clip(samvar.dim, Projectiles[p]->dim))
                {
                    Injure_Samus(Projectiles[p]->damage);
                }
            }
            //Loop through the targets
            for(int t = 0; t < total_targets; t ++)
            {
                if(Targets[t]->active AND *Targets[t]->team != Projectiles[p]->owner_flag AND !Projectiles[p]->bomb)
                {
                    if(rect_clip(Targets[t]->dim[0], Projectiles[p]->clip))
                    {
                        Deal_Damage_To_Target(t, p);
                    }
                }
            }
        }
    }
}

void Compare_Targets_To_Bombs(int p)
{
    //Loop through the targets
    for(int t = 0; t < total_targets; t ++)
    {
        if(Targets[t]->active)
        {
            if(rect_clip(Targets[t]->dim[0], Projectiles[p]->dim.lft-8, Projectiles[p]->dim.top-5, Projectiles[p]->dim.rgt+8, Projectiles[p]->dim.bot+4))
            {
                if((*Targets[t]->vulnerabilities & BEAM_BOMB))
                {
                    *Targets[t]->hp -= Projectiles[p]->damage;
                }
                if(metroid_latch_index == Targets[t]->location)
                {
                    Enemies[metroid_latch_index]->substructure[1] --;
                    if(Enemies[metroid_latch_index]->substructure[1] == 0)
                    {
                        Enemies[metroid_latch_index]->substructure[2] = 60;
                        Enemies[metroid_latch_index]->substructure[0] = 0;
                        Enemies[metroid_latch_index]->substructure[3] = 100;
                        Enemies[metroid_latch_index]->substructure[4] = 100;
                        metroid_latch_index = -1;
                    }
                }
                Projectiles[p]->terminate = true;
            }
        }
    }
}

void Compare_Targets_To_Screw_Attack()
{
    //Loop through the targets
    for(int t = 0; t < total_targets; t ++)
    {
        if(Targets[t]->active)
        {
            if(rect_clip(Targets[t]->dim[0], samvar.dim))
            {
                if(*Targets[t]->vulnerabilities & BEAM_SCREW)
                {
                    *Targets[t]->hp -= 16;
                    if(Targets[t]->snd != NULL) BASS_ChannelPlay(*Targets[t]->snd, true);
                }
                else
                {
                    BASS_ChannelPlay(Audio.Invuln, true);
                }
            }
        }
    }
}

void Deal_Damage_To_Target(int t, int p)
{
    int hitflag = false;
    if(Targets[t]->type == TARGET_RIDLEY)
    {
        if(Ridley.active) Damage_Ridley(p);
    }
    else if(Targets[t]->type == TARGET_KRAID)
    {
        if(Kraid.active) Damage_Kraid(p);
    }
    else if(Targets[t]->type == TARGET_KRAID_HOOK)
    {
        if(!(Projectiles[p]->properties & BEAM_PLASMA))
        {
            BASS_ChannelPlay(Audio.Invuln, true);
            Projectiles[p]->terminate = true;
        }
    }
    else if(Targets[t]->type == TARGET_KRAID_NEEDLE)
    {
        if(!(Projectiles[p]->properties & BEAM_PLASMA))
        {
            BASS_ChannelPlay(Audio.Invuln, true);
            Projectiles[p]->terminate = true;
        }
    }
    else if(Targets[t]->type == TARGET_RINKA)
    {
        BASS_ChannelPlay(Audio.Injured_Small, true);
        if(Projectiles[p]->properties & BEAM_ICE)
        {
            if(Rinka[Targets[t]->location].freeze_timer < 1)
            {
                Rinka[Targets[t]->location].freeze_timer = 600;
                Rinka[Targets[t]->location].refreeze_timer = 20;
            }
            else
            {
                if(Rinka[Targets[t]->location].refreeze_timer < 1) Rinka[Targets[t]->location].health = 0;
            }
        }
        else
        {
            Rinka[Targets[t]->location].health = 0;
        }
        if(!(Projectiles[p]->properties & BEAM_PLASMA))
        {
            Projectiles[p]->terminate = true;
        }
    }
    else if(Targets[t]->type == TARGET_MOTHER_BRAIN)
    {
        if(Mbrain.active AND Projectiles[p]->properties & BEAM_MISSILE) Damage_Mother_Brain(p);
    }
    else if(Targets[t]->type == TARGET_ZEBETITE)
    {
        if(Projectiles[p]->properties & BEAM_MISSILE) *Targets[t]->hp -= Projectiles[p]->damage;
    }
    else if(metroid_latch_index != Targets[t]->location)
    {
        if(Targets[t]->type == TARGET_ENEMY)
        {
            for(int e = 0; e < Enemies[Targets[t]->location]->immune.total_codes; e ++)
            {
                if(Projectiles[p]->beamcode == Enemies[Targets[t]->location]->immune.codes[e]) return;//Already been hit by this beam
            }
            Immunize_From_Beam(Targets[t]->location, Projectiles[p]->beamcode);
        }
        if(*Targets[t]->vulnerabilities & BEAM_DAMAGE AND Projectiles[p]->properties & BEAM_DAMAGE) //Damage
        {
            if(*Targets[t]->vulnerabilities & BEAM_ICE AND Projectiles[p]->properties & BEAM_ICE AND Targets[t]->type == TARGET_ENEMY)
            {
                if(Enemies[Targets[t]->location]->freeze_timer != 0) *Targets[t]->hp -= Projectiles[p]->damage;
            }
            else
                *Targets[t]->hp -= Projectiles[p]->damage;
            Projectiles[p]->terminate = true;
            hitflag = true;
        }
        if(*Targets[t]->vulnerabilities & BEAM_MISSILE AND Projectiles[p]->properties & BEAM_MISSILE) //Missile fire
        {
            if(hitflag == false) *Targets[t]->hp -= Projectiles[p]->damage;
            Projectiles[p]->missile_terminate = true;
            Projectiles[p]->terminate = true;
            hitflag = true;
        }
        if(*Targets[t]->vulnerabilities & BEAM_PLASMA AND Projectiles[p]->properties & BEAM_PLASMA) //Plasma
        {
            if(hitflag == false) *Targets[t]->hp -= Projectiles[p]->damage;
            hitflag = true;
        }
        if(*Targets[t]->vulnerabilities & BEAM_ICE AND Projectiles[p]->properties & BEAM_ICE AND Targets[t]->type== TARGET_ENEMY) //Freezing
        {
            if(Enemies[Targets[t]->location]->refreeze_timer == 0)
            {
                if(Enemies[Targets[t]->location]->freeze_timer == 0)
                {
                    if(Enemies[Targets[t]->location]->type_flag == METROID) Enemies[Targets[t]->location]->freeze_timer = 300;
                    else Enemies[Targets[t]->location]->freeze_timer = 600;
                    Enemies[Targets[t]->location]->stun_timer = 0;
                    Enemies[Targets[t]->location]->refreeze_timer = 5;
                    if(Enemies[Targets[t]->location]->stats.health < 1) Enemies[Targets[t]->location]->stats.health = 1;
                }
                else
                {
                    if(Enemies[Targets[t]->location]->type_flag == METROID)
                    {
                        Enemies[Targets[t]->location]->freeze_timer = 300;
                        Enemies[Targets[t]->location]->stun_timer = 0;
                        Enemies[Targets[t]->location]->refreeze_timer = 5;
                    }
                    else
                    {
                        Enemies[Targets[t]->location]->freeze_timer = 0;
                        Enemies[Targets[t]->location]->stun_timer = 0;
                        Enemies[Targets[t]->location]->refreeze_timer = 5;
                        Unclip_Area(Enemies[Targets[t]->location]->bound, STOP_FREEZE);
                    }
                }
            }
            Projectiles[p]->terminate = true;
            hitflag = true;
        }
        if(*Targets[t]->vulnerabilities & BEAM_BURN AND Projectiles[p]->properties & BEAM_BURN) //Burn
        {
            ;//Set the enemy on fire
            Projectiles[p]->terminate = true;
            hitflag = true;
        }
        if(*Targets[t]->vulnerabilities & BEAM_SHOCK AND Projectiles[p]->properties & BEAM_SHOCK) //Shock
        {
            ;//Stun the enemy for several seconds
            Projectiles[p]->terminate = true;
            hitflag = true;
        }
        if(*Targets[t]->vulnerabilities & BEAM_CHARGE AND Projectiles[p]->properties & BEAM_CHARGE) //Charge
        {
            *Targets[t]->hp -= Projectiles[p]->damage;
            Projectiles[p]->terminate = true;
            hitflag = true;
        }
        if(Projectiles[p]->penetrate_enemy AND Targets[t]->type == TARGET_ENEMY OR
           Projectiles[p]->penetrate_world AND Targets[t]->type == TARGET_DOOR)
        {
            Projectiles[p]->terminate = false;
        }
        if(hitflag == false)
        {
            if(Enemies[Targets[t]->location]->type_flag == METROID)
            {
                BASS_ChannelPlay(Audio.Injured_Metroid, true);
            }
            else
            {
                BASS_ChannelPlay(Audio.Invuln, true);
            }
            Projectiles[p]->terminate = true;
        }
        else
        {
            if(Targets[t]->snd != NULL) BASS_ChannelPlay(*Targets[t]->snd, true);
            if(Targets[t]->stun_timer != NULL)
            {
                *Targets[t]->stun_timer = 5;
                if(Targets[t]->stun_timer > 0 AND Enemies[Targets[t]->location]->freeze_timer > 0) Targets[t]->stun_timer = 0;
            }
            if(Targets[t]->type == TARGET_DOOR)
            {
                if(Doors[Targets[t]->location].type == MISSILE_DOOR)
                {
                    Add_Door_To_Opened_List(Saveout, curlev_name, Doors[Targets[t]->location].name, Doors[Targets[t]->location].health);
                }
            }
        }
    }
}
