void Create_Water_Zones(int lft, int top, int rgt, int bot, int type)
{
    int lplace, tplace, rplace, bplace;
    bool hastop = false;
    for(int x = lft; x < rgt; x += WSIZE)
    {
        for(int y = top; y < bot; y += WSIZE)
        {
            if(y == top) hastop = true;
            else hastop = false;
            lplace = x;
            rplace = x+WSIZE;
            tplace = y;
            bplace = y+WSIZE;
            if(rplace > rgt) rplace = rgt;
            if(bplace > bot) bplace = bot;
            Create_Water_Zone(lplace, tplace, rplace, bplace, type, hastop);
        }
    }
}

int Create_Water_Zone(int lft, int top, int rgt, int bot, int type, bool hastop)//Return Slot the water was put in
{
    for(int i = 0; i < total_water_zones; i ++)
    {
        if(!Water[i].active)
        {
            Place_Water_Zone_In_Slot(i, lft, top, rgt, bot, type, top);
            return i;
        }
    }
    total_water_zones ++;
    Water = (WATER_ZONE *)realloc(Water, sizeof(WATER_ZONE) * (total_water_zones));

    Place_Water_Zone_In_Slot(total_water_zones-1, lft, top, rgt, bot, type, hastop);
    return total_water_zones - 1;
}

void Place_Water_Zone_In_Slot(int i, int lft, int top, int rgt, int bot, int type, bool hastop)
{
    Water[i].active = true;
    Water[i].has_top = hastop;
    Water[i].dim.lft = lft;
    Water[i].dim.rgt = rgt;
    Water[i].dim.top = top;
    Water[i].dim.bot = bot;
    Water[i].type = type;
    if(type == 0)
    {
        Water[i].bmp = create_bitmap(rgt-lft, bot-top);
        Water[i].bmp2 = create_bitmap(rgt-lft, bot-top);
    }
    else if(type == 1)
    {
        Water[i].bmp = create_bitmap(rgt-lft, bot-top);
        Water[i].bmp2 = NULL;
    }
}

void Update_Water_Zones()
{
    water_global_timer ++;
    if(water_global_timer >= 120) water_global_timer = 0;
    BITMAP *Top_Water;
    BITMAP *Mid_Water;
    for(int i = 0; i < total_water_zones; i ++)
    {
        if(Water[i].active AND rect_clip(Water[i].dim, camera))
        {
            if(Water[i].type == 0)
            {
                Top_Water = Water_Img_Top;
                Mid_Water = Water_Img_Mid;
            }
            else if(Water[i].type == 1)
            {
                Top_Water = Acid_Img_Top;
                Mid_Water = Acid_Img_Mid;
            }
            else
            {
                printf("Error with water zone %i!\n", i);
                break;
            }
            // Drawing and Updating //
            Water[i].counter ++;
            if(Water[i].counter > 128) Water[i].counter = 0;
            clear_to_color(Water[i].bmp, 0);

            if(Get_Cvar_Value_I("complex_water"))
            {
                int img_x=0, img_y=0;
                int array_pos = water_global_timer;
                int ystart = 0;
                if(Water[i].has_top)
                {
                    for(int y = ystart; y < Top_Water->h; y ++)
                    {
                        img_y = y;
                        img_x = water_array[array_pos/20];
                        for(int x = 0; x < Water[i].bmp->w; x += Top_Water->w/2)
                        {
                            blit(Top_Water, Water[i].bmp, img_x, img_y, x, y, Mid_Water->w/2, 1);
                            img_x ++;
                            if(img_x >= Top_Water->w/2) img_x = 0;
                        }
                        array_pos ++;
                        if(array_pos >= 120) array_pos = 0;
                    }
                    ystart += Top_Water->h;
                }
                for(int y = ystart; y < Water[i].bmp->h; y ++)
                {
                    img_y = y%Mid_Water->h;
                    img_x = water_array[array_pos/20];
                    for(int x = 0; x < Water[i].bmp->w; x += Mid_Water->w/2)
                    {
                        blit(Mid_Water, Water[i].bmp, img_x, img_y, x, y, Mid_Water->w/2, 1);
                        img_x ++;
                        if(img_x >= Mid_Water->w/2) img_x = 0;
                    }
                    array_pos ++;
                    if(array_pos >= 120) array_pos = 0;
                }
            }
            else
            {
                for(int x = -(Water[i].counter/4); x < Water[i].bmp->w; x += Mid_Water->w)
                {
                    int ystart = 0;
                    if(Water[i].has_top)
                    {
                        draw_sprite(Water[i].bmp, Top_Water, x, 0);
                        ystart += Top_Water->h;
                    }
                    for(int y = ystart; y < Water[i].bmp->h; y += Mid_Water->h)
                    {
                        draw_sprite(Water[i].bmp, Mid_Water, x, y);
                    }
                }
            }

            // Create Splashes when landed in //
            if(!samvar.is_in_water AND rect_clip(Water[i].dim, samvar.dim.lft, samvar.dim.bot, samvar.dim.rgt, samvar.dim.bot+1))
            {
                samvar.is_in_water = true;
                if(Water[i].type == 0 AND elevator_trans_cooldown == 0) //Create a splash
                {
                    int p = Create_Sprite(samvar.dim.lft-9, Water[i].dim.top-21, 8);
                    Imagize_Sprite_Splash(p);
                }
            }
            if(rect_clip(Water[i].dim, samvar.dim.lft, samvar.dim.bot, samvar.dim.rgt, samvar.dim.bot) AND Water[i].type == 1)
            {
                samvar.is_in_acid = true;
            }
        }
    }
}
