void Create_Zebetite(int lft, int top, int rgt, int bot, int health)
{
    for(int i = 0; i < total_zebetites; i ++)
    {
        if(!Zebetite[i].active)
        {
            Place_Zebetite_In_Slot(i, lft, top, rgt, bot, health);
            return;
        }
    }
    Zebetite = (ZEBETITE *)realloc(Zebetite, sizeof(ZEBETITE) * (total_zebetites + 1));
    Place_Zebetite_In_Slot(total_zebetites, lft, top, rgt, bot, health);
    total_zebetites ++;
    return;
}

void Place_Zebetite_In_Slot(int i, int lft, int top, int rgt, int bot, int health)
{
    Zebetite[i].active = true;
    Zebetite[i].x = lft;
    Zebetite[i].y = top;
    Zebetite[i].health = health;
    Zebetite[i].core.lft = lft;
    Zebetite[i].core.top = top;
    Zebetite[i].core.rgt = rgt;
    Zebetite[i].core.bot = bot;
    Zebetite[i].regen_timer = 20;
    Zebetite[i].size = 0;
    Add_To_Target_List(TARGET_ZEBETITE, i);
}

void Update_Zebetite(int i)
{
    if(Zebetite[i].active)
    {
        if(Zebetite[i].health > 120)
        {
            Zebetite[i].size = 0;
            Zebetite[i].dim.lft = Zebetite[i].core.lft;
            Zebetite[i].dim.top = Zebetite[i].core.top;
            Zebetite[i].dim.rgt = Zebetite[i].core.rgt;
            Zebetite[i].dim.bot = Zebetite[i].core.bot;
            Clip_Area(Zebetite[i].dim, STOP_PROJECTILE | STOP_SAMUS);
        }
        else if(Zebetite[i].health > 80)
        {
            Zebetite[i].size = 1;
            Zebetite[i].dim.lft = Zebetite[i].core.lft+2;
            Zebetite[i].dim.top = Zebetite[i].core.top;
            Zebetite[i].dim.rgt = Zebetite[i].core.rgt-2;
            Zebetite[i].dim.bot = Zebetite[i].core.bot;
            Clip_Area(Zebetite[i].core, STOP_SAMUS);
            Clip_Area(Zebetite[i].dim, STOP_PROJECTILE);
            
        }
        else if(Zebetite[i].health > 40)
        {
            Zebetite[i].size = 2;
            Zebetite[i].dim.lft = Zebetite[i].core.lft+4;
            Zebetite[i].dim.top = Zebetite[i].core.top;
            Zebetite[i].dim.rgt = Zebetite[i].core.rgt-4;
            Zebetite[i].dim.bot = Zebetite[i].core.bot;
            Clip_Area(Zebetite[i].core, STOP_SAMUS);
            Clip_Area(Zebetite[i].dim, STOP_PROJECTILE);
        }
        else if(Zebetite[i].health > 0)
        {
            Zebetite[i].size = 3;
            Zebetite[i].dim.lft = Zebetite[i].core.lft+6;
            Zebetite[i].dim.top = Zebetite[i].core.top;
            Zebetite[i].dim.rgt = Zebetite[i].core.rgt-6;
            Zebetite[i].dim.bot = Zebetite[i].core.bot;
            Clip_Area(Zebetite[i].core, STOP_SAMUS);
            Clip_Area(Zebetite[i].dim, STOP_PROJECTILE);
        }
        else if(Zebetite[i].health <= 0)
        {
            Zebetite[i].active = false;
            Clip_Area(Zebetite[i].core, STOP_NONE);
        }
        if(Zebetite[i].regen_timer > 0) Zebetite[i].regen_timer --;
        else
        {
            Zebetite[i].regen_timer = 15;
            Zebetite[i].health ++;
        }
        if(Zebetite[i].health > 160) Zebetite[i].health = 160;
    }
}

void Draw_Zebetites(BITMAP *output)
{
    for(int i = 0; i < total_zebetites; i ++)
    {
        if(Zebetite[i].active AND rect_clip(camera, Zebetite[i].dim))
        {
            draw_sprite_palette(output, Zebetite_Img[Zebetite[i].size], Zebetite[i].x-camera.lft, Zebetite[i].y-camera.top, 0);
        }
    }
}
